###############################################################################
# Greymatter 1.7.4                            
# Copyright (c)2000-2007, The Greymatter team 
# http://greymatterforum.proboards82.com/     
# By possessing this software, you agree not to hold the author responsible for 
# any problems that may arise from your installation or usage of Greymatter 
# itself, or from any content generated by yourself or others through the use of 
# this program.  You <I>may</I> freely modify and redistribute this program, so 
# long as every copyright notice (including in this manual and in the Greymatter 
# code) remains fully intact.  Finally, you may <I>not</I> sell or in any way 
# make a financial profit from this program, either in original or modified form.
# Your possession of this software signifies that you agree to these terms; 
# please delete your copy of this software if you don't agree to these terms.
# Original Creators Noah Grey
###############################################################################

use lib 'libs';

use Gm_Constants;
use Gm_Utils qw( println );
use Gm_Web;
use Gm_Storage;
use Gm_Security;
use Gm_Core;


### GLOBAL VARS
my $newTemplates = (); # init to empty
my $newConfigs = (); # init to empty

$cookiename = Gm_Constants::GM_COOKIE_PW;

$authorIP = $ENV{'REMOTE_ADDR'};

# -----------------
# program variables
# -----------------

# NOTE that the version is MAJOR NUMBER.YEAR.NO_OF_REL_THAT_YEAR
# e.g. a major refactoring is done in 2007 the release would be 1.7.1
# later that year a security fix comes out so release would be 1.7.2
# Also NOTE that in deference to a previous Greymatter developer, this GM
# (which is perl based) will retain the Major version of 1.  The previous
#developer has begun a php rewrite of Greymatter and is using the Major version 2
$gmversion = Gm_Constants::GM_VERSION;


## Setting up some variables that are used below
# TODO refactor out these intermeditate variables.  The code using these variables should be in gm.cgi
# or Gm_Web.pm
$gmfonttag = $Gm_Web::gmfonttag;
$gmadmincss = $Gm_Web::gmadmincss;
$gmheadtag = $Gm_Web::gmheadtag;
$gmheadtagtwo = $gmheadtag;


$gmframetop = $Gm_Web::gmframetop;
## TODO get rid of frametoptow and framebottomtwo
$gmframetoptwo = qq(<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100% HEIGHT=100%><TR><TD VALIGN=MIDDLE ALIGN=CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 BGCOLOR="#FFFFFF"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag);
$gmframebottom = $Gm_Web::gmframebottom;
$gmframebottomtwo = qq(</font></TD></TR></TABLE></TD></TR></TABLE></TD></TR></TABLE></TD></TR></TABLE></TD></TR></TABLE>);
## TODO this shouldn't be a global variable, get rid of once all pertainent code is in gm.cgi
$statusnote = Gm_Constants::EMPTY;


# ------------------
# emoticons subroutine
# ------------------
# DEPRECATED: Gm_Core::translateEmoticons
sub gm_emoticons {
	die( "gm_emoticons has been DEPRECATED");
}

# ------------------
# emoticons code display subroutine
# ------------------
# added by flipped cracker 9/17/2003
# version 1.3
## DEPRECATED BY: emoticonsCode in gm.cgi
sub gm_emoticons_code {

&gm_readconfig;
$emoticonsmaincode = Gm_Constants::EMPTY;
if( ($emoticonsallowed eq Gm_Constants::BOTH) || ($emoticonsallowed eq Gm_Constants::ENTRIES) ) {
$emoticonsmaincode = "<td>
  <table>
   <tr>
    <td><img alt=\":)\" onclick=\"commentEmoticonMain(':)')\" src=\"$emoticonspath/smile.gif\" title=\":)\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":O\" onclick=\"commentEmoticonMain(':O')\" src=\"$emoticonspath/shocked.gif\" title=\":O\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":(\" onclick=\"commentEmoticonMain(':(')\" src=\"$emoticonspath/sad.gif\" title=\":(\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":D\" onclick=\"commentEmoticonMain(':D')\" src=\"$emoticonspath/biggrin.gif\" title=\":D\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":P\" onclick=\"commentEmoticonMain(':P')\" src=\"$emoticonspath/tongue.gif\" title=\":P\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\";)\" onclick=\"commentEmoticonMain(';)')\" src=\"$emoticonspath/wink.gif\" title=\";)\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":angry:\" onclick=\"commentEmoticonMain(':angry:')\" src=\"$emoticonspath/angry.gif\" title=\":angry:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":blush:\" onclick=\"commentEmoticonMain(':blush:')\" src=\"$emoticonspath/blush.gif\" title=\":blush:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":confused:\" onclick=\"commentEmoticonMain(':confused:')\" src=\"$emoticonspath/confused.gif\" title=\":confused:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":cool:\" onclick=\"commentEmoticonMain(':cool:')\" src=\"$emoticonspath/cool.gif\" title=\":cool:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":crazy:\" onclick=\"commentEmoticonMain(':crazy:')\" src=\"$emoticonspath/crazy.gif\" title=\":crazy:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":cry:\" onclick=\"commentEmoticonMain(':cry:')\" src=\"$emoticonspath/cry.gif\" title=\":cry:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":doze:\" onclick=\"commentEmoticonMain(':doze:')\" src=\"$emoticonspath/doze.gif\" title=\":doze:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":hehe:\" onclick=\"commentEmoticonMain(':hehe:')\" src=\"$emoticonspath/hehe.gif\" title=\":hehe:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":laugh:\" onclick=\"commentEmoticonMain(':laugh:')\" src=\"$emoticonspath/laugh.gif\" title=\":laugh:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":plain:\" onclick=\"commentEmoticonMain(':plain:')\" src=\"$emoticonspath/plain.gif\" title=\":plain:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":rolleyes:\" onclick=\"commentEmoticonMain(':rolleyes:')\" src=\"$emoticonspath/rolleyes.gif\" title=\":rollseyes:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":satisfied:\" onclick=\"commentEmoticonMain(':satisfied:')\" src=\"$emoticonspath/satisfied.gif\" title=\":satisfied:\" width=\"19\" height=\"14\" /></td>
   </tr>
  </table>
 </td>";

$emoticonsmorecode = "<td>
  <table>
   <tr>
    <td><img alt=\":)\" onclick=\"commentEmoticonMore(':)')\" src=\"$emoticonspath/smile.gif\" title=\"s:)\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":O\" onclick=\"commentEmoticonMore(':O')\" src=\"$emoticonspath/shocked.gif\" title=\":O\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":(\" onclick=\"commentEmoticonMore(':(')\" src=\"$emoticonspath/sad.gif\" title=\":(\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":D\" onclick=\"commentEmoticonMore(':D')\" src=\"$emoticonspath/biggrin.gif\" title=\":D\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":P\" onclick=\"commentEmoticonMore(':P')\" src=\"$emoticonspath/tongue.gif\" title=\":P\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\";)\" onclick=\"commentEmoticonMore(';)')\" src=\"$emoticonspath/wink.gif\" title=\";)\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":angry:\" onclick=\"commentEmoticonMore(':angry:')\" src=\"$emoticonspath/angry.gif\" title=\":angry:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":blush:\" onclick=\"commentEmoticonMore(':blush:')\" src=\"$emoticonspath/blush.gif\" title=\":blush:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":confused:\" onclick=\"commentEmoticonMore(':confused:')\" src=\"$emoticonspath/confused.gif\" title=\":confused:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":cool:\" onclick=\"commentEmoticonMore(':cool:')\" src=\"$emoticonspath/cool.gif\" title=\":cool:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":crazy:\" onclick=\"commentEmoticonMore(':crazy:')\" src=\"$emoticonspath/crazy.gif\" title=\":crazy:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":cry:\" onclick=\"commentEmoticonMore(':cry:')\" src=\"$emoticonspath/cry.gif\" title=\":cry:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":doze:\" onclick=\"commentEmoticonMore(':doze:')\" src=\"$emoticonspath/doze.gif\" title=\":doze:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":hehe:\" onclick=\"commentEmoticonMore(':hehe:')\" src=\"$emoticonspath/hehe.gif\" title=\":hehe:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":laugh:\" onclick=\"commentEmoticonMore(':laugh:')\" src=\"$emoticonspath/laugh.gif\" title=\":laugh:\" width=\"19\" height=\"14\" /></td>
   </tr>
   <tr>
    <td><img alt=\":plain:\" onclick=\"commentEmoticonMore(':plain:')\" src=\"$emoticonspath/plain.gif\" title=\":plain:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":rolleyes:\" onclick=\"commentEmoticonMore(':rolleyes:')\" src=\"$emoticonspath/rolleyes.gif\" title=\":rollseyes:\" width=\"19\" height=\"14\" /></td>
    <td><img alt=\":satisfied:\" onclick=\"commentEmoticonMore(':satisfied:')\" src=\"$emoticonspath/satisfied.gif\" title=\"satisfied:\" width=\"19\" height=\"14\" /></td>
   </tr>
  </table>
 </td>";
 }
}


# ---------------
# date subroutine
# ---------------
# DEPRECATED: Gm_Utils::getStdDate( $serveroffset );
#

# ----------------
# read the counter
# ----------------
# TODO, DEPRECATE THIS AND USE GETCOUNTERS EVERYWHERE
sub gm_readcounter {

my $gmcounters = Gm_Storage::getCounters( errHandler=>\&Gm_Web::displayAdminErrorExit );

$newentrynumber = $gmcounters->{'entrytotal'};
$newarchivenumber = $gmcounters->{'archivetotal'};
$newstayattopnumber = $gmcounters->{'stayattopentry'};
$newalltimepktotalnumber = $gmcounters->{'karmapos'};
$newalltimenktotalnumber = $gmcounters->{'karmaneg'};
$newalltimecommentstotalnumber = $gmcounters->{'commenttotal'};
$newalltimeopenentriesnumber = $gmcounters->{'opentotal'};
$newalltimeclosedentriesnumber = $gmcounters->{'closedtotal'};

}

# -----------------
# write the counter
# -----------------
# TODO, DEPRECATE THIS AND USE SETCOUNTERS EVERYWHERE
sub gm_writecounter {

my %counters = ();
$counters{'entrytotal'} = $newentrynumber;
$counters{'archivetotal'} = $newarchivenumber;
$counters{'stayattopentry'} = $newstayattopnumber;
$counters{'karmapos'} = $newalltimepktotalnumber;
$counters{'karmaneg'} = $newalltimenktotalnumber;
$counters{'commenttotal'} = $newalltimecommentstotalnumber;
$counters{'opentotal'} = $newalltimeopenentriesnumber;
$counters{'closedtotal'} = $newalltimeclosedentriesnumber;

Gm_Storage::setCounters( list=>\%counters, errHandler=>\&Gm_Web::displayAdminErrorExit );

}

# ------------------
# read the templates
## TODO REMOVE ALL REFERENCES TO THIS CALL.  REPLACED BY GM_STORAGE FUNCTION
## if leave, access global newTemplates hash reference
# ------------------

sub gm_readtemplates {

$newTemplates = Gm_Storage::getTemplates( errHandler=>\&Gm_Web::displayAdminErrorExit );

### TODO, NOW THAT WE ARE USING HASH FOR TEMPLATES, GO THROUGH AND REMOVE REFERENCES TO 
## INVIDUAL VARS BELOW, E.G. REPLACE $gmindextemplate WITH $newTemplates->{'gmindextemplate'}
$gmindextemplate = $newTemplates->{'gmindextemplate'};
$gmentrypagetemplate = $newTemplates->{'gmentrypagetemplate'};
$gmarchiveindextemplate = $newTemplates->{'gmarchiveindextemplate'};
$gmarchiveentrypagetemplate = $newTemplates->{'gmarchiveentrypagetemplate'};
$gmentrytemplate = $newTemplates->{'gmentrytemplate'};
$gmarchiveentrytemplate = $newTemplates->{'gmarchiveentrytemplate'};
$gmstayattoptemplate = $newTemplates->{'gmstayattoptemplate'};
$gmdatetemplate = $newTemplates->{'gmdatetemplate'};
$gmcommentstemplate = $newTemplates->{'gmcommentstemplate'};
$gmcommentsformtemplate = $newTemplates->{'gmcommentsformtemplate'};
$gmparaseparationtemplate = $newTemplates->{'gmparaseparationtemplate'};
$gmkarmaformtemplate = $newTemplates->{'gmkarmaformtemplate'};
$gmlinktargettemplate = $newTemplates->{'gmlinktargettemplate'};
$gmdategroupingfootertemplate = $newTemplates->{'gmdategroupingfootertemplate'};
$gmkarmalinktemplate = $newTemplates->{'gmkarmalinktemplate'};
$gmcommentslinktemplate = $newTemplates->{'gmcommentslinktemplate'};
$gmcommentauthoremailtemplate = $newTemplates->{'gmcommentauthoremailtemplate'};
$gmcommentauthorhomepagetemplate = $newTemplates->{'gmcommentauthorhomepagetemplate'};
$gmcommentdividertemplate = $newTemplates->{'gmcommentdividertemplate'};
$gmmoreentrytemplate = $newTemplates->{'gmmoreentrytemplate'};
$gmmoreentrypagetemplate = $newTemplates->{'gmmoreentrypagetemplate'};
$gmmorearchiveentrypagetemplate = $newTemplates->{'gmmorearchiveentrypagetemplate'};
$gmpreviouslinktemplate = $newTemplates->{'gmpreviouslinktemplate'};
$gmnextlinktemplate = $newTemplates->{'gmnextlinktemplate'};
$gmpreviousmorelinktemplate = $newTemplates->{'gmpreviousmorelinktemplate'};
$gmnextmorelinktemplate = $newTemplates->{'gmnextmorelinktemplate'};
$gmarchivemasterindextemplate = $newTemplates->{'gmarchivemasterindextemplate'};
$gmlogarchiveslinktemplate = $newTemplates->{'gmlogarchiveslinktemplate'};
$gmentrypagelinktemplate = $newTemplates->{'gmentrypagelinktemplate'};
$gmmoreentrypagelinktemplate = $newTemplates->{'gmmoreentrypagelinktemplate'};
$gmlogarchiveslinkseparatortemplate = $newTemplates->{'gmlogarchiveslinkseparatortemplate'};
$gmentrypagelinkseparatortemplate = $newTemplates->{'gmentrypagelinkseparatortemplate'};
$gmentrypagelinkmonthseparatortemplate = $newTemplates->{'gmentrypagelinkmonthseparatortemplate'};
$gmentrypagelinkdayseparatortemplate = $newTemplates->{'gmentrypagelinkdayseparatortemplate'};
$gmentrypagelinkyearseparatortemplate = $newTemplates->{'gmentrypagelinkyearseparatortemplate'};
$gmheadertemplate = $newTemplates->{'gmheadertemplate'};
$gmfootertemplate = $newTemplates->{'gmfootertemplate'};
$gmsidebartemplate = $newTemplates->{'gmsidebartemplate'};
$gmentryseparatortemplate = $newTemplates->{'gmentryseparatortemplate'};
$gmarchiveentryseparatortemplate = $newTemplates->{'gmarchiveentryseparatortemplate'};
$gmmorearchiveentrytemplate = $newTemplates->{'gmmorearchiveentrytemplate'};
$gmdatearchivetemplate = $newTemplates->{'gmdatearchivetemplate'};
$gmlogarchiveslinkweeklytemplate = $newTemplates->{'gmlogarchiveslinkweeklytemplate'};
$gmcustomonetemplate = $newTemplates->{'gmcustomonetemplate'};
$gmcustomtwotemplate = $newTemplates->{'gmcustomtwotemplate'};
$gmcustomthreetemplate = $newTemplates->{'gmcustomthreetemplate'};
$gmcustomfourtemplate = $newTemplates->{'gmcustomfourtemplate'};
$gmcustomfivetemplate = $newTemplates->{'gmcustomfivetemplate'};
$gmcustomsixtemplate = $newTemplates->{'gmcustomsixtemplate'};
$gmcustomseventemplate = $newTemplates->{'gmcustomseventemplate'};
$gmcustomeighttemplate = $newTemplates->{'gmcustomeighttemplate'};
$gmcustomninetemplate = $newTemplates->{'gmcustomninetemplate'};
$gmcustomtentemplate = $newTemplates->{'gmcustomtentemplate'};
$gmpopuppagetemplate = $newTemplates->{'gmpopuppagetemplate'};
$gmpopupcodetemplate = $newTemplates->{'gmpopupcodetemplate'};
$gmsearchformtemplate = $newTemplates->{'gmsearchformtemplate'};
$gmsearchresultspagetemplate = $newTemplates->{'gmsearchresultspagetemplate'};
$gmsearchresultsentrytemplate = $newTemplates->{'gmsearchresultsentrytemplate'};
$gmcalendartablebeginningtemplate = $newTemplates->{'gmcalendartablebeginningtemplate'};
$gmcalendartableendingtemplate = $newTemplates->{'gmcalendartableendingtemplate'};
$gmcalendarblankcelltemplate = $newTemplates->{'gmcalendarblankcelltemplate'};
$gmcalendarfullcelltemplate = $newTemplates->{'gmcalendarfullcelltemplate'};
$gmcalendarfullcelllinktemplate = $newTemplates->{'gmcalendarfullcelllinktemplate'};
$gmcalendarweekfulldaytemplate = $newTemplates->{'gmcalendarweekfulldaytemplate'};
$gmcalendarweekfulldaylinktemplate = $newTemplates->{'gmcalendarweekfulldaylinktemplate'};
$gmcommentpreviewdividertemplate = $newTemplates->{'gmcommentpreviewdividertemplate'};
$gmcommentpreviewformtemplate = $newTemplates->{'gmcommentpreviewformtemplate'};
$gmsmartlinknocommentstemplate = $newTemplates->{'gmsmartlinknocommentstemplate'};
$gmsmartlinkonecommenttemplate = $newTemplates->{'gmsmartlinkonecommenttemplate'};
$gmsmartlinkmanycommentstemplate = $newTemplates->{'gmsmartlinkmanycommentstemplate'};
$gmlinebreaktemplate = $newTemplates->{'gmlinebreaktemplate'};
$gmcommentlinktargettemplate = $newTemplates->{'gmcommentlinktargettemplate'};
$gmsmartentrymoodtemplate = $newTemplates->{'gmsmartentrymoodtemplate'};
$gmsmartentrymusictemplate = $newTemplates->{'gmsmartentrymusictemplate'};
$gmdategroupingfooterarchivetemplate = $newTemplates->{'gmdategroupingfooterarchivetemplate'};
$gmsmartemoticonscodetemplate = $newTemplates->{'gmsmartemoticonscodetemplate'};
$gmcookiescodetemplate = $newTemplates->{'gmcookiescodetemplate'};
$gmusererrorheadertemplate = $newTemplates->{'gmusererrorheadertemplate'};
$gmusererrorfootertemplate =  $newTemplates->{'gmusererrorfootertemplate'};
}

# ---------------------
# delouse all templates
# ---------------------
### TODO JUST LOOP THROUGH THE TEMPLATES HASH ARRAY ONCE ALL THESE REFERENCES ARE REMOVED
sub gm_delousealltemplates {

$gmindextemplate = Gm_Utils::toWebSafe($gmindextemplate);
$gmentrypagetemplate = Gm_Utils::toWebSafe($gmentrypagetemplate);
$gmarchiveindextemplate = Gm_Utils::toWebSafe($gmarchiveindextemplate);
$gmarchiveentrypagetemplate = Gm_Utils::toWebSafe($gmarchiveentrypagetemplate);
$gmentrytemplate = Gm_Utils::toWebSafe($gmentrytemplate);
$gmarchiveentrytemplate = Gm_Utils::toWebSafe($gmarchiveentrytemplate);
$gmstayattoptemplate = Gm_Utils::toWebSafe($gmstayattoptemplate);
$gmdatetemplate = Gm_Utils::toWebSafe($gmdatetemplate);
$gmcommentstemplate = Gm_Utils::toWebSafe($gmcommentstemplate);
$gmcommentsformtemplate = Gm_Utils::toWebSafe($gmcommentsformtemplate);
$gmparaseparationtemplate = Gm_Utils::toWebSafe($gmparaseparationtemplate);
$gmkarmaformtemplate = Gm_Utils::toWebSafe($gmkarmaformtemplate);
$gmlinktargettemplate = Gm_Utils::toWebSafe($gmlinktargettemplate);
$gmdategroupingfootertemplate = Gm_Utils::toWebSafe($gmdategroupingfootertemplate); 
$gmkarmalinktemplate = Gm_Utils::toWebSafe($gmkarmalinktemplate);
$gmcommentslinktemplate = Gm_Utils::toWebSafe($gmcommentslinktemplate);
$gmcommentauthoremailtemplate = Gm_Utils::toWebSafe($gmcommentauthoremailtemplate);
$gmcommentauthorhomepagetemplate = Gm_Utils::toWebSafe($gmcommentauthorhomepagetemplate);
$gmcommentdividertemplate = Gm_Utils::toWebSafe($gmcommentdividertemplate);
$gmmoreentrytemplate = Gm_Utils::toWebSafe($gmmoreentrytemplate);
$gmmoreentrypagetemplate = Gm_Utils::toWebSafe($gmmoreentrypagetemplate);
$gmmorearchiveentrypagetemplate = Gm_Utils::toWebSafe($gmmorearchiveentrypagetemplate);
$gmpreviouslinktemplate = Gm_Utils::toWebSafe($gmpreviouslinktemplate);
$gmnextlinktemplate = Gm_Utils::toWebSafe($gmnextlinktemplate);
$gmpreviousmorelinktemplate = Gm_Utils::toWebSafe($gmpreviousmorelinktemplate);
$gmnextmorelinktemplate = Gm_Utils::toWebSafe($gmnextmorelinktemplate);
$gmarchivemasterindextemplate = Gm_Utils::toWebSafe($gmarchivemasterindextemplate);
$gmlogarchiveslinktemplate = Gm_Utils::toWebSafe($gmlogarchiveslinktemplate);
$gmentrypagelinktemplate = Gm_Utils::toWebSafe($gmentrypagelinktemplate);
$gmmoreentrypagelinktemplate = Gm_Utils::toWebSafe($gmmoreentrypagelinktemplate);
$gmlogarchiveslinkseparatortemplate = Gm_Utils::toWebSafe($gmlogarchiveslinkseparatortemplate);
$gmentrypagelinkseparatortemplate = Gm_Utils::toWebSafe($gmentrypagelinkseparatortemplate);
$gmentrypagelinkmonthseparatortemplate = Gm_Utils::toWebSafe($gmentrypagelinkmonthseparatortemplate);
$gmentrypagelinkdayseparatortemplate = Gm_Utils::toWebSafe($gmentrypagelinkdayseparatortemplate);
$gmentrypagelinkyearseparatortemplate = Gm_Utils::toWebSafe($gmentrypagelinkyearseparatortemplate);
$gmheadertemplate = Gm_Utils::toWebSafe($gmheadertemplate);
$gmfootertemplate = Gm_Utils::toWebSafe($gmfootertemplate);
$gmsidebartemplate = Gm_Utils::toWebSafe($gmsidebartemplate);
$gmentryseparatortemplate = Gm_Utils::toWebSafe($gmentryseparatortemplate);
$gmarchiveentryseparatortemplate = Gm_Utils::toWebSafe($gmarchiveentryseparatortemplate);
$gmmorearchiveentrytemplate = Gm_Utils::toWebSafe($gmmorearchiveentrytemplate);
$gmdatearchivetemplate = Gm_Utils::toWebSafe($gmdatearchivetemplate);
$gmlogarchiveslinkweeklytemplate = Gm_Utils::toWebSafe($gmlogarchiveslinkweeklytemplate);
$gmcustomonetemplate = Gm_Utils::toWebSafe($gmcustomonetemplate);
$gmcustomtwotemplate = Gm_Utils::toWebSafe($gmcustomtwotemplate);
$gmcustomthreetemplate = Gm_Utils::toWebSafe($gmcustomthreetemplate);
$gmcustomfourtemplate = Gm_Utils::toWebSafe($gmcustomfourtemplate);
$gmcustomfivetemplate = Gm_Utils::toWebSafe($gmcustomfivetemplate);
$gmcustomsixtemplate = Gm_Utils::toWebSafe($gmcustomsixtemplate);
$gmcustomseventemplate = Gm_Utils::toWebSafe($gmcustomseventemplate);
$gmcustomeighttemplate = Gm_Utils::toWebSafe($gmcustomeighttemplate);
$gmcustomninetemplate = Gm_Utils::toWebSafe($gmcustomninetemplate);
$gmcustomtentemplate = Gm_Utils::toWebSafe($gmcustomtentemplate);
$gmpopuppagetemplate = Gm_Utils::toWebSafe($gmpopuppagetemplate);
$gmpopupcodetemplate = Gm_Utils::toWebSafe($gmpopupcodetemplate);
$gmsearchformtemplate = Gm_Utils::toWebSafe($gmsearchformtemplate);
$gmsearchresultspagetemplate = Gm_Utils::toWebSafe($gmsearchresultspagetemplate);
$gmsearchresultsentrytemplate = Gm_Utils::toWebSafe($gmsearchresultsentrytemplate);
$gmcalendartablebeginningtemplate = Gm_Utils::toWebSafe($gmcalendartablebeginningtemplate);
$gmcalendartableendingtemplate = Gm_Utils::toWebSafe($gmcalendartableendingtemplate);
$gmcalendarblankcelltemplate = Gm_Utils::toWebSafe($gmcalendarblankcelltemplate);
$gmcalendarfullcelltemplate = Gm_Utils::toWebSafe($gmcalendarfullcelltemplate);
$gmcalendarfullcelllinktemplate = Gm_Utils::toWebSafe($gmcalendarfullcelllinktemplate);
$gmcalendarweekfulldaytemplate = Gm_Utils::toWebSafe($gmcalendarweekfulldaytemplate);
$gmcalendarweekfulldaylinktemplate = Gm_Utils::toWebSafe($gmcalendarweekfulldaylinktemplate);
$gmcommentpreviewdividertemplate = Gm_Utils::toWebSafe($gmcommentpreviewdividertemplate);
$gmcommentpreviewformtemplate = Gm_Utils::toWebSafe($gmcommentpreviewformtemplate);
$gmsmartlinknocommentstemplate = Gm_Utils::toWebSafe($gmsmartlinknocommentstemplate);
$gmsmartlinkonecommenttemplate = Gm_Utils::toWebSafe($gmsmartlinkonecommenttemplate);
$gmsmartlinkmanycommentstemplate = Gm_Utils::toWebSafe($gmsmartlinkmanycommentstemplate);
$gmlinebreaktemplate = Gm_Utils::toWebSafe($gmlinebreaktemplate);
$gmcommentlinktargettemplate = Gm_Utils::toWebSafe($gmcommentlinktargettemplate);
$gmsmartentrymoodtemplate = Gm_Utils::toWebSafe($gmsmartentrymoodtemplate);
$gmsmartentrymusictemplate = Gm_Utils::toWebSafe($gmsmartentrymusictemplate);
$gmdategroupingfooterarchivetemplate = Gm_Utils::toWebSafe($gmdategroupingfooterarchivetemplate);
$gmsmartemoticonscodetemplate = Gm_Utils::toWebSafe($gmsmartemoticonscodetemplate);
$gmcookiescodetemplate = Gm_Utils::toWebSafe($gmcookiescodetemplate);
$gmusererrorheadertemplate = Gm_Utils::toWebSafe($gmusererrorheadertemplate);
$gmusererrorfootertemplate = Gm_Utils::toWebSafe($gmusererrorfootertemplate);
}

# --------------------
# read the config file
## TODO REMOVE ALL REFERENCES TO THIS CALL.  REPLACED BY GM_STORAGE FUNCTION
## if leave, access global newConfigs hash reference
# --------------------

sub gm_readconfig {

	$newConfigs = Gm_Storage::getConfigs( errHandler=>\&Gm_Web::displayAdminErrorExit );

	### TODO, NOW THAT WE ARE USING HASH FOR TEMPLATES, GO THROUGH AND REMOVE REFERENCES TO 
	## INVIDUAL VARS BELOW, E.G. REPLACE $gmindextemplate WITH $newTemplates->{'gmindextemplate'}
	$LogPath = $newConfigs->{'gmlogpath'};
	$EntriesPath = $newConfigs->{'gmentriespath'};
	$LogWebPath = $newConfigs->{'gmlogwebpath'};
	$EntriesWebPath = $newConfigs->{'gmentrieswebpath'};
	$NotifyEmail = $newConfigs->{'gmnotifyemail'};
	$indexfilename = $newConfigs->{'gmindexfilename'};
	$entrysuffix = $newConfigs->{'gmentrysuffix'};
	$indexdays = $newConfigs->{'gmindexdays'};
	$serveroffset = $newConfigs->{'gmserveroffset'};
	$timezone = $newConfigs->{'gmtimezone'};
	$keeplog = $newConfigs->{'gmkeeplog'};
	$posttoarchives = $newConfigs->{'gmposttoarchives'};
	$allowkarmadefault = $newConfigs->{'gmallowkarmadefault'};
	$allowcommentsdefault = $newConfigs->{'gmallowcommentsdefault'};
	$commentsorder = $newConfigs->{'gmcommentsorder'};
	$generateentrypages = $newConfigs->{'gmgenerateentrypages'};
	$allowhtmlincomments = $newConfigs->{'gmallowhtmlincomments'};
	$logkarmaandcomments = $newConfigs->{'gmlogkarmaandcomments'};
	$mailprog = $newConfigs->{'gmmailprog'};
	$NotifyForStatus = $newConfigs->{'gmnotifyforstatus'};
	$autolinkurls = $newConfigs->{'gmautolinkurls'};
	$striplinesfromcomments = $newConfigs->{'gmstriplinesfromcomments'};
	$allowmultiplekarmavotes = $newConfigs->{'gmallowmultiplekarmavotes'};
	$versionsetup = $newConfigs->{'gmversionsetup'};
	$cgilocalpath = $newConfigs->{'gmcgilocalpath'};
	$cgiwebpath = $newConfigs->{'gmcgiwebpath'};
	$concurrentmainandarchives = $newConfigs->{'gmconcurrentmainandarchives'};
	$keeparchivemasterindex = $newConfigs->{'gmkeeparchivemasterindex'};
	$entrylistsortorder = $newConfigs->{'gmentrylistsortorder'};
	$allowkarmaorcomments = $newConfigs->{'gmallowkarmaorcomments'};
	$entrylistcountnumber = $newConfigs->{'gmentrylistcountnumber'};
	$cookiesallowed = $newConfigs->{'gmcookiesallowed'};
	$logarchivesuffix = $newConfigs->{'gmlogarchivesuffix'};
	$censorlist = $newConfigs->{'gmcensorlist'};
	$censorenabled = $newConfigs->{'gmcensorenabled'};
	$keepmonthlyarchives = $newConfigs->{'gmkeepmonthlyarchives'};
	$defaultentrylistview = $newConfigs->{'gmdefaultentrylistview'};
	$linktocalendarentries = $newConfigs->{'gmlinktocalendarentries'};
	$automaticrebuilddefault = $newConfigs->{'gmautomaticrebuilddefault'};
	$commententrylistonlyifokay = $newConfigs->{'gmcommententrylistonlyifokay'};
	$otherfilelist = $newConfigs->{'gmotherfilelist'};
	$otherfilelistentryrebuild = $newConfigs->{'gmotherfilelistentryrebuild'};
	$archiveformat = $newConfigs->{'gmarchiveformat'};
	$inlineformatting = $newConfigs->{'gminlineformatting'};
	$uploadfilesallowed = $newConfigs->{'gmuploadfilesallowed'};
	$uploadfilesizelimit = $newConfigs->{'gmuploadfilesizelimit'};
	$emoticonspath = $newConfigs->{'gmemoticonspath'};
	$keepphphacklog = $newConfigs->{'gmkeepphphacklog'};
	$mailhacknotice = $newConfigs->{'gmmailhacknotice'};
	$emoticonsallowed = $newConfigs->{'gmemoticonsallowed'};
	$protectauthorname = $newConfigs->{'gmprotectauthorname'};
	$commentlinklimit = $newConfigs->{'gmcommentlinklimit'};
	$commentlinklimitnum = $newConfigs->{'gmcommentlinklimitnum'};
	$commentforcepreview = $newConfigs->{'gmcommentforcepreview'};
	$commentverify = $newConfigs->{'gmcommentverify'};
	$commentverifyphrase = $newConfigs->{'gmcommentverifyphrase'};
	$commentverifyreferer = $newConfigs->{'gmcommentverifyreferer'};
	$commentthrottle = $newConfigs->{'gmcommentthrottle'};
	$commentthrottlemin = $newConfigs->{'gmcommentthrottlemin'};
	
}

# ---------------------
# write the config file
# ---------------------

sub gm_writeconfig {

if ($versionsetup eq Gm_Constants::EMPTY) { $versionsetup = $gmversion; }
my %confs = ();
$confs{'gmlogpath'} = $LogPath;
$confs{'gmentriespath'} = $EntriesPath;
$confs{'gmlogwebpath'} = $LogWebPath;
$confs{'gmentrieswebpath'} = $EntriesWebPath;
$confs{'gmnotifyemail'} = $NotifyEmail;
$confs{'gmindexfilename'} = $indexfilename;
$confs{'gmentrysuffix'} = $entrysuffix;
$confs{'gmindexdays'} = $indexdays;
$confs{'gmserveroffset'} = $serveroffset;
$confs{'gmtimezone'} = $timezone;
$confs{'gmkeeplog'} = $keeplog;
$confs{'gmposttoarchives'} = $posttoarchives;
$confs{'gmallowkarmadefault'} = $allowkarmadefault;
$confs{'gmallowcommentsdefault'} = $allowcommentsdefault;
$confs{'gmcommentsorder'} = $commentsorder;
$confs{'gmgenerateentrypages'} = $generateentrypages;
$confs{'gmallowhtmlincomments'} = $allowhtmlincomments;
$confs{'gmlogkarmaandcomments'} = $logkarmaandcomments;
$confs{'gmmailprog'} = $mailprog;
$confs{'gmnotifyforstatus'} = $NotifyForStatus;
$confs{'gmautolinkurls'} = $autolinkurls;
$confs{'gmstriplinesfromcomments'} = $striplinesfromcomments;
$confs{'gmallowmultiplekarmavotes'} = $allowmultiplekarmavotes;
$confs{'gmversionsetup'} = $versionsetup;
$confs{'gmversion'} = Gm_Constants::GM_VERSION;
$confs{'gmcgilocalpath'} = $cgilocalpath;
$confs{'gmcgiwebpath'} = $cgiwebpath;
$confs{'gmconcurrentmainandarchives'} = $concurrentmainandarchives;
$confs{'gmkeeparchivemasterindex'} = $keeparchivemasterindex;
$confs{'gmentrylistsortorder'} = $entrylistsortorder;
$confs{'gmallowkarmaorcomments'} = $allowkarmaorcomments;
$confs{'gmentrylistcountnumber'} = $entrylistcountnumber;
$confs{'gmcookiesallowed'} = $cookiesallowed;
$confs{'gmlogarchivesuffix'} = $logarchivesuffix;
$confs{'gmcensorlist'} = $censorlist;
$confs{'gmcensorenabled'} = $censorenabled;
$confs{'gmkeepmonthlyarchives'} = $keepmonthlyarchives;
$confs{'gmdefaultentrylistview'} = $defaultentrylistview;
$confs{'gmlinktocalendarentries'} = $linktocalendarentries;
$confs{'gmautomaticrebuilddefault'} = $automaticrebuilddefault;
$confs{'gmcommententrylistonlyifokay'} = $commententrylistonlyifokay;
$confs{'gmotherfilelist'} = $otherfilelist;
$confs{'gmotherfilelistentryrebuild'} = $otherfilelistentryrebuild;
$confs{'gmarchiveformat'} = $archiveformat;
$confs{'gminlineformatting'} = $inlineformatting;
$confs{'gmuploadfilesallowed'} = $uploadfilesallowed;
$confs{'gmuploadfilesizelimit'} = $uploadfilesizelimit;
$confs{'gmemoticonspath'} = $emoticonspath;
$confs{'gmkeepphphacklog'} = $keepphphacklog;
$confs{'gmmailhacknotice'} = $mailhacknotice;
$confs{'gmemoticonsallowed'} = $emoticonsallowed;
$confs{'gmprotectauthorname'} = $protectauthorname;
$confs{'gmcommentlinklimit'} = $commentlinklimit;
$confs{'gmcommentlinklimitnum'} = $commentlinklimitnum;
$confs{'gmcommentforcepreview'} = $commentforcepreview;
$confs{'gmcommentverify'} = $commentverify;
$confs{'gmcommentverifyphrase'} = $commentverifyphrase;
$confs{'gmcommentverifyreferer'} = $commentverifyreferer;
$confs{'gmcommentthrottle'} = $commentthrottle;
$confs{'gmcommentthrottlemin'} = $commentthrottlemin;

Gm_Storage::setConfigs( configs=>\%confs, errHandler=>\&Gm_Web::displayAdminErrorExit );

}

# ---------------------------------
# gather ye all thy entry variables
# ---------------------------------
# DEPRECATED: Gm_Core::getEntryVariables
sub gm_getentryvariables {
	die( "gm_getentryvariables has been DEPRECATED");
}

# -----------------
# comment collating
# -----------------
# DEPRECATED: Gm_Core::collateComments( entry=>$gmEntry );
sub gm_collatecomments {
	die( "gm_collatecomments has been DEPRECATED");
}

# ----------------
# format the entry
# ----------------
# Note: doesn't return string, just modifies it
# DEPRECATED: Gm_Core::translateEntryTemplates
sub gm_formatentry {
	die( "gm_formatentry has been DEPRECATED");
}

# ----------------------------
# generate the main index file
# ----------------------------

sub gm_generatemainindex {

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

$indexlogbody = Gm_Constants::EMPTY;
$indexentrycounter = $newentrynumber;
$indexcurrentdatemarker = "erewhon";
$indexcurrentdatescounted = 0;

my $entryVars = ();

if ($newstayattopnumber ne "0") {
# 	&gm_getentryvariables($newstayattopnumber);
	$entryVars = Gm_Core::getEntryVariables( entryid=>$newstayattopnumber, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );
	if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
# 		&gm_formatentry($gmstayattoptemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmstayattoptemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		$indexlogbody .= $entryreturn;
	}
}


do {

# &gm_getentryvariables($indexentrycounter);
$entryVars = Gm_Core::getEntryVariables( entryid=>$indexentrycounter, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );

$datemark = "$entryVars->{'thisentrymonth'} $entryVars->{'thisentryday'} $entryVars->{'thisentryyearyear'}";

# if (($datemark ne $indexcurrentdatemarker) && ($thisentryopenstatus eq Gm_Constants::OPEN) && ($indexentrycounter ne $newstayattopnumber)) {
if( ($datemark ne $indexcurrentdatemarker) && 
	($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
	($indexentrycounter ne $newstayattopnumber) ){
	$indexcurrentdatescounted++;
	if ($gmdatetemplate ne Gm_Constants::EMPTY) {
		$currentdatehead = $gmdatetemplate;
		$currentdatehead =~ s/{{day}}/$entryVars->{'thisentryday'}/gi;
		$currentdatehead =~ s/{{dayday}}/$entryVars->{'thisentrydayday'}/gi;
		$currentdatehead =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
		$currentdatehead =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
		$currentdatehead =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
		$currentdatehead =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
		$currentdatehead =~ s/{{weekday}}/$entryVars->{'thisentryweekday'}/gi;
		$currentdatehead =~ s/{{weekdayshort}}/$entryVars->{'thisentryweekdayshort'}/gi;		
		$currentdatehead =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
		$currentdatehead =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;		
		$currentdatehead =~ s/{{weekdayupper}}/$entryVars->{'thisentryweekdayupper'}/gi;
		$currentdatehead =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
		$currentdatehead =~ s/{{weekdaylower}}/$entryVars->{'thisentryweekdaylower'}/gi;
		$currentdatehead =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
		$currentdatehead =~ s/{{weekdayuppershort}}/$entryVars->{'thisentryweekdayuppershort'}/gi;
		$currentdatehead =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
		$currentdatehead =~ s/{{weekdaylowershort}}/$entryVars->{'thisentryweekdaylowershort'}/gi;
		$currentdatehead =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;

		$thisentrydayappend = Gm_Utils::toOrdinal($entryVars->{'thisentryday'});
		$currentdatehead =~ s/{{dayappend}}/$thisentrydayappend/gi;

		unless( $indexcurrentdatescounted > $indexdays ){ 
		   $indexlogbody .= $currentdatehead;
		   $dategrouping = Gm_Constants::OPEN;
		}
	}
	$indexcurrentdatemarker = "$entryVars->{'thisentrymonth'} $entryVars->{'thisentryday'} $entryVars->{'thisentryyearyear'}";
} else {
# 	if (($indexentrycounter ne $newstayattopnumber) && ($thisentryopenstatus eq Gm_Constants::OPEN) && ($indexcurrentdatescounted <= $indexdays) && ($gmentryseparatortemplate ne Gm_Constants::EMPTY)) {
	if (($indexentrycounter ne $newstayattopnumber) && 
		($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
		($indexcurrentdatescounted <= $indexdays) && 
		($gmentryseparatortemplate ne Gm_Constants::EMPTY)) {
		$indexlogbody .= $gmentryseparatortemplate;
	}
}

# if (($indexentrycounter ne $newstayattopnumber) && ($thisentryopenstatus eq Gm_Constants::OPEN) && ($indexcurrentdatescounted <= $indexdays)) {
if (($indexentrycounter ne $newstayattopnumber) && 
	($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
	($indexcurrentdatescounted <= $indexdays)) {
# 	if ($thisentrymorebody ne Gm_Constants::EMPTY) {
	if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 		&gm_formatentry($gmmoreentrytemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmmoreentrytemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
	} else {
# 		&gm_formatentry($gmentrytemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmentrytemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
	}
	$indexlogbody .= $entryreturn;
}

if ($indexentrycounter > 1) {
#     &gm_getentryvariables($indexentrycounter - 1); # look at the last open entry
		$entryVars = Gm_Core::getEntryVariables( entryid=>($indexentrycounter - 1), 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
    $nextdatemark = "$entryVars->{'thisentrymonth'} $entryVars->{'thisentryday'} $entryVars->{'thisentryyearyear'}";
    $nextentryopenstatus = $entryVars->{'thisentryopenstatus'};
#     &gm_getentryvariables($indexentrycounter); # look at the current entry again
		$entryVars = Gm_Core::getEntryVariables( entryid=>$indexentrycounter, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );

    if (($nextdatemark ne $indexcurrentdatemarker) && ($dategrouping eq Gm_Constants::OPEN) && ($nextentryopenstatus eq Gm_Constants::OPEN) && ($indexentrycounter ne $newstayattopnumber)) {     
        if ($gmdategroupingfootertemplate ne Gm_Constants::EMPTY) {
        	$currentdatefoot = $gmdategroupingfootertemplate;
        	$currentdatefoot =~ s/{{day}}/$entryVars->{'thisentryday'}/gi;
        	$currentdatefoot =~ s/{{dayday}}/$entryVars->{'thisentrydayday'}/gi;
        	$currentdatefoot =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
        	$currentdatefoot =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
        	$currentdatefoot =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
        	$currentdatefoot =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
        	$currentdatefoot =~ s/{{weekday}}/$entryVars->{'thisentryweekday'}/gi;
        	$currentdatefoot =~ s/{{weekdayshort}}/$entryVars->{'thisentryweekdayshort'}/gi;		
        	$currentdatefoot =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
        	$currentdatefoot =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;		
        	$currentdatefoot =~ s/{{weekdayupper}}/$entryVars->{'thisentryweekdayupper'}/gi;
        	$currentdatefoot =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
        	$currentdatefoot =~ s/{{weekdaylower}}/$entryVars->{'thisentryweekdaylower'}/gi;
        	$currentdatefoot =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
        	$currentdatefoot =~ s/{{weekdayuppershort}}/$entryVars->{'thisentryweekdayuppershort'}/gi;
        	$currentdatefoot =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
        	$currentdatefoot =~ s/{{weekdaylowershort}}/$entryVars->{'thisentryweekdaylowershort'}/gi;
        	$currentdatefoot =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;

        	$thisentrydayappend = Gm_Utils::toOrdinal($entryVars->{'thisentryday'});
        	$currentdatefoot =~ s/{{dayappend}}/$thisentrydayappend/gi;

      		unless ($indexcurrentdatescounted > $indexdays) { 
						$indexlogbody .= $currentdatefoot;
						$dategrouping = Gm_Constants::CLOSED;
					}
        }
    }
} 
$indexentrycounter--;

if ($indexentrycounter eq '0') {
	if ($indexcurrentdatescounted > $indexdays) { $indexentrycounter++; }
	$indexcurrentdatescounted = $indexdays + 1;
}

if (($newstayattopnumber eq '1') && ($newentrynumber eq '1')) { 
	$indexcurrentdatescounted = $indexdays + 1; 
}

if ($indexcurrentdatescounted > $indexdays) {
	if ($indexentrycounter < 0) { $indexentrycounter = 0; }
	unless ($indexentrycounter eq "0") { $indexentrycounter = $entryVars->{'thisentrynumber'}; }
}

} until $indexcurrentdatescounted > $indexdays;

if ( ($gmdategroupingfootertemplate ne Gm_Constants::EMPTY) && ($dategrouping eq Gm_Constants::OPEN) ) {
	$currentdatefoot = $gmdategroupingfootertemplate;
	$currentdatefoot =~ s/{{day}}/$entryVars->{'thisentryday'}/gi;
	$currentdatefoot =~ s/{{dayday}}/$entryVars->{'thisentrydayday'}/gi;
	$currentdatefoot =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
	$currentdatefoot =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
	$currentdatefoot =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
	$currentdatefoot =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
	$currentdatefoot =~ s/{{weekday}}/$entryVars->{'thisentryweekday'}/gi;
	$currentdatefoot =~ s/{{weekdayshort}}/$entryVars->{'thisentryweekdayshort'}/gi;		
	$currentdatefoot =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
	$currentdatefoot =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;		
	$currentdatefoot =~ s/{{weekdayupper}}/$entryVars->{'thisentryweekdayupper'}/gi;
	$currentdatefoot =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
	$currentdatefoot =~ s/{{weekdaylower}}/$entryVars->{'thisentryweekdaylower'}/gi;
	$currentdatefoot =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
	$currentdatefoot =~ s/{{weekdayuppershort}}/$entryVars->{'thisentryweekdayuppershort'}/gi;
	$currentdatefoot =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
	$currentdatefoot =~ s/{{weekdaylowershort}}/$entryVars->{'thisentryweekdaylowershort'}/gi;
	$currentdatefoot =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;
	
	$thisentrydayappend = Gm_Utils::toOrdinal($entryVars->{'thisentryday'});
	$currentdatefoot =~ s/{{dayappend}}/$thisentrydayappend/gi;
	$indexlogbody .= $currentdatefoot;
	$dategrouping = Gm_Constants::CLOSED;
}

$newindexfile = $gmindextemplate;
$newindexfile =~ s/{{logbody}}/$indexlogbody/gi;

# &gm_getentryvariables($newentrynumber);
$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );
# &gm_formatentry($newindexfile);
$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
	template=>$newindexfile, errHandler=>\&Gm_Web::displayAdminErrorExit);

# open (THISFILECLAWS, ">$LogPath/$indexfilename") || &gm_dangermouse("Can't write to $LogPath/$indexfilename.  Please make sure your paths are configured correctly and that $indexfilename is CHMODed to 666; also try running Diagnostics & Repair from the Configuration screen.");
# print THISFILECLAWS $entryreturn;
# close (THISFILECLAWS);
Gm_Storage::saveFile( loc=>"$LogPath/$indexfilename", content=>[$entryreturn],
	'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );

$newarchivenumber = $indexentrycounter;

&gm_writecounter;

}

# ---------------------
# generate archive file
# ---------------------

sub gm_generatearchive {

my $getstartnumber = shift;

$startnumber = $getstartnumber;

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

$indexarchivebody = Gm_Constants::EMPTY;
$indexentrycounter = $startnumber;
$indexcurrentdatemarker = "erewhon";
$indexcurrentdatescounted = 0;
# &gm_getentryvariables($startnumber);
my $entryVars = Gm_Core::getEntryVariables( entryid=>$startnumber, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );
$indexcurrentmonthcounter = $entryVars->{'thisentrymonth'};
$indexcurrentweekcounter = "$entryVars->{'thisentryweekbeginningdayday'}$entryVars->{'thisentryweekendingdayday'}";

my $entryVars = ();

do {

# &gm_getentryvariables($indexentrycounter);
$entryVars = Gm_Core::getEntryVariables( entryid=>$indexentrycounter, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );

$thisentryweek = "$entryVars->{'thisentryweekbeginningdayday'}$entryVars->{'thisentryweekendingdayday'}";

if (($generateentrypages eq Gm_Constants::YES) && ($indexentrycounter eq $newarchivenumber)) {
	if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
# 		&gm_formatentry($gmarchiveentrypagetemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmarchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
# 		open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write to $EntriesPath/$thisentrynumberpadded.$entrysuffix.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# 		print THISFILE $entryreturn;
# 		close (THISFILE);
		Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
			content=>[$entryreturn], 'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );
	} else {
		unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
	}
}

$datemark = "$entryVars->{'thisentrymonth'} $entryVars->{'thisentryday'} $entryVars->{'thisentryyearyear'}";

if (($datemark ne $indexcurrentdatemarker) && 
	($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN)) {
	$indexcurrentdatescounted++;
	if ($gmdatearchivetemplate ne Gm_Constants::EMPTY) {
		$currentdatehead = $gmdatearchivetemplate;
		$currentdatehead =~ s/{{day}}/$entryVars->{'thisentryday'}/gi;
		$currentdatehead =~ s/{{dayday}}/$entryVars->{'thisentrydayday'}/gi;
		$currentdatehead =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
		$currentdatehead =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
		$currentdatehead =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
		$currentdatehead =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
		$currentdatehead =~ s/{{weekday}}/$entryVars->{'thisentryweekday'}/gi;
		$currentdatehead =~ s/{{weekdayshort}}/$entryVars->{'thisentryweekdayshort'}/gi;		
		$currentdatehead =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
		$currentdatehead =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;		
		$currentdatehead =~ s/{{weekdayupper}}/$entryVars->{'thisentryweekdayupper'}/gi;
		$currentdatehead =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
		$currentdatehead =~ s/{{weekdaylower}}/$entryVars->{'thisentryweekdaylower'}/gi;
		$currentdatehead =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
		$currentdatehead =~ s/{{weekdayuppershort}}/$entryVars->{'thisentryweekdayuppershort'}/gi;
		$currentdatehead =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
		$currentdatehead =~ s/{{weekdaylowershort}}/$entryVars->{'thisentryweekdaylowershort'}/gi;
		$currentdatehead =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;

		$thisentrydayappend = Gm_Utils::toOrdinal($entryVars->{'thisentryday'});
		$currentdatehead =~ s/{{dayappend}}/$thisentrydayappend/gi;
		
		if ($archiveformat eq Gm_Constants::WEEK) {
			unless ($entryVars->{'thisentryweek'} ne $indexcurrentweekcounter) {
			   $indexarchivebody .= $currentdatehead;
			   $dategrouping = Gm_Constants::OPEN;
			}
		} else {
			unless ($entryVars->{'thisentrymonth'} ne $indexcurrentmonthcounter) {
			   $indexarchivebody .= $currentdatehead;
			   $dategrouping = Gm_Constants::OPEN;
			}
		}
	}
	$indexcurrentdatemarker = "$entryVars->{'thisentrymonth'} $entryVars->{'thisentryday'} $entryVars->{'thisentryyearyear'}";
} else {
	if ($archiveformat eq Gm_Constants::WEEK) {
		if (($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
			($entryVars->{'thisentryweek'} eq $indexcurrentweekcounter) && 
			($gmarchiveentryseparatortemplate ne Gm_Constants::EMPTY)) {
			$indexarchivebody .= $gmarchiveentryseparatortemplate;
		}
	} else {
		if (($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
			($entryVars->{'thisentrymonth'} eq $indexcurrentmonthcounter) && 
			($gmarchiveentryseparatortemplate ne Gm_Constants::EMPTY)) {
			$indexarchivebody .= $gmarchiveentryseparatortemplate;
		}
	}
}

if ($archiveformat eq Gm_Constants::WEEK) {
	if (($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
		($entryVars->{'thisentryweek'} eq $indexcurrentweekcounter)) {
		if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 			&gm_formatentry($gmmorearchiveentrytemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmmorearchiveentrytemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		} else {
# 			&gm_formatentry($gmarchiveentrytemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmarchiveentrytemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		}
		$indexarchivebody .= $entryreturn;
	}
} else {
	if (($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) && 
		($entryVars->{'thisentrymonth'} eq $indexcurrentmonthcounter)) {
		if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 			&gm_formatentry($gmmorearchiveentrytemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmmorearchiveentrytemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		} else {
# 			&gm_formatentry($gmarchiveentrytemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmarchiveentrytemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		}
		$indexarchivebody .= $entryreturn;
	}
}

if ($indexentrycounter > 1) {
#     &gm_getentryvariables($indexentrycounter - 1); # look at the previous entry
		$entryVars = Gm_Core::getEntryVariables( entryid=>($indexentrycounter - 1), 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
    $nextdatemark = "$entryVars->{'thisentrymonth'} $entryVars->{'thisentryday'} $entryVars->{'thisentryyearyear'}";
    $nextentryopenstatus = $entryVars->{'thisentryopenstatus'};
#     &gm_getentryvariables($indexentrycounter); # look at the current entry again
		$entryVars = Gm_Core::getEntryVariables( entryid=>$indexentrycounter, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
    if (($nextdatemark ne $indexcurrentdatemarker) && 
    	($dategrouping eq Gm_Constants::OPEN) && 
    	($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN)) {
        if ($gmdategroupingfooterarchivetemplate ne Gm_Constants::EMPTY) {
        	$currentdatefoot = $gmdategroupingfooterarchivetemplate;
        	$currentdatefoot =~ s/{{day}}/$entryVars->{'thisentryday'}/gi;
        	$currentdatefoot =~ s/{{dayday}}/$entryVars->{'thisentrydayday'}/gi;
        	$currentdatefoot =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
        	$currentdatefoot =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
        	$currentdatefoot =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
        	$currentdatefoot =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
        	$currentdatefoot =~ s/{{weekday}}/$entryVars->{'thisentryweekday'}/gi;
        	$currentdatefoot =~ s/{{weekdayshort}}/$entryVars->{'thisentryweekdayshort'}/gi;		
        	$currentdatefoot =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
        	$currentdatefoot =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;		
        	$currentdatefoot =~ s/{{weekdayupper}}/$entryVars->{'thisentryweekdayupper'}/gi;
        	$currentdatefoot =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
        	$currentdatefoot =~ s/{{weekdaylower}}/$entryVars->{'thisentryweekdaylower'}/gi;
        	$currentdatefoot =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
        	$currentdatefoot =~ s/{{weekdayuppershort}}/$entryVars->{'thisentryweekdayuppershort'}/gi;
        	$currentdatefoot =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
        	$currentdatefoot =~ s/{{weekdaylowershort}}/$entryVars->{'thisentryweekdaylowershort'}/gi;
        	$currentdatefoot =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;

        	$thisentrydayappend = Gm_Utils::toOrdinal($entryVars->{'thisentryday'});
        	$currentdatefoot =~ s/{{dayappend}}/$thisentrydayappend/gi;
        	$indexarchivebody .= $currentdatefoot;
        	$dategrouping = Gm_Constants::CLOSED;
        }
    }
}
 
$indexentrycounter--;
if( $indexentrycounter eq "0" && $indexcurrentmonthcounter ne $entryVars->{'thisentrymonth'} ){ 
	$gmneedstogeneratefirstarchive=1; 
}
if( $indexentrycounter eq "0" && $archiveformat eq Gm_Constants::WEEK && 
	$entryVars->{'thisentryweek'} ne $indexcurrentweekcounter ){ 
	$gmneedstogeneratefirstarchive=1; 
}
if ($archiveformat eq Gm_Constants::WEEK) {
	if ($entryVars->{'thisentryweek'} ne $indexcurrentweekcounter) {
		$indexcurrentmonthcounter = "finis";
	} else {
		$indexcurrentmonthcounter = $entryVars->{'thisentrymonth'};
	}
}

if ($indexentrycounter eq "0") { $indexcurrentmonthcounter = "finis"; }

} until $entryVars->{'thisentrymonth'} ne $indexcurrentmonthcounter;

if ( ($gmdategroupingfooterarchivetemplate ne Gm_Constants::EMPTY) && ($dategrouping eq Gm_Constants::OPEN) ) {
	$currentdatefoot = $gmdategroupingfooterarchivetemplate;
	$currentdatefoot =~ s/{{day}}/$entryVars->{'thisentryday'}/gi;
	$currentdatefoot =~ s/{{dayday}}/$entryVars->{'thisentrydayday'}/gi;
	$currentdatefoot =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
	$currentdatefoot =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
	$currentdatefoot =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
	$currentdatefoot =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
	$currentdatefoot =~ s/{{weekday}}/$entryVars->{'thisentryweekday'}/gi;
	$currentdatefoot =~ s/{{weekdayshort}}/$entryVars->{'thisentryweekdayshort'}/gi;		
	$currentdatefoot =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
	$currentdatefoot =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;		
	$currentdatefoot =~ s/{{weekdayupper}}/$entryVars->{'thisentryweekdayupper'}/gi;
	$currentdatefoot =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
	$currentdatefoot =~ s/{{weekdaylower}}/$entryVars->{'thisentryweekdaylower'}/gi;
	$currentdatefoot =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
	$currentdatefoot =~ s/{{weekdayuppershort}}/$entryVars->{'thisentryweekdayuppershort'}/gi;
	$currentdatefoot =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
	$currentdatefoot =~ s/{{weekdaylowershort}}/$entryVars->{'thisentryweekdaylowershort'}/gi;
	$currentdatefoot =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;

	$thisentrydayappend = Gm_Utils::toOrdinal($entryVars->{'thisentryday'});
	$currentdatefoot =~ s/{{dayappend}}/$thisentrydayappend/gi;
	$indexarchivebody .= $currentdatefoot;
	$dategrouping = Gm_Constants::CLOSED;
}

$stoppednumber = $entryVars->{'thisentrynumber'};

# &gm_getentryvariables($startnumber);
$entryVars = Gm_Core::getEntryVariables( entryid=>$startnumber, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );
			
if ($archiveformat eq Gm_Constants::WEEK) {
	$usethisarchivefilename = "$EntriesPath/archive-$entryVars->{'thisentryweekbeginningmonthmonth'}$entryVars->{'thisentryweekbeginningdayday'}$entryVars->{'thisentryweekbeginningyearyear'}-$entryVars->{'thisentryweekendingmonthmonth'}$entryVars->{'thisentryweekendingdayday'}$entryVars->{'thisentryweekendingyearyear'}\.$logarchivesuffix";
} else {
	$usethisarchivefilename = "$EntriesPath/archive-$entryVars->{'thisentrymonthmonth'}$entryVars->{'thisentryyearyear'}\.$logarchivesuffix";
}

$newarchivefile = $gmarchiveindextemplate;
$newarchivefile =~ s/{{year}}/$entryVars->{'thisentryyear'}/gi;
$newarchivefile =~ s/{{yearyear}}/$entryVars->{'thisentryyearyear'}/gi;
$newarchivefile =~ s/{{month}}/$entryVars->{'thisentrymonth'}/gi;
$newarchivefile =~ s/{{monthmonth}}/$entryVars->{'thisentrymonthmonth'}/gi;
$newarchivefile =~ s/{{monthword}}/$entryVars->{'thisentrymonthword'}/gi;
$newarchivefile =~ s/{{monthwordshort}}/$entryVars->{'thisentrymonthwordshort'}/gi;
$newarchivefile =~ s/{{monthwordupper}}/$entryVars->{'thisentrymonthwordupper'}/gi;
$newarchivefile =~ s/{{monthwordlower}}/$entryVars->{'thisentrymonthwordlower'}/gi;
$newarchivefile =~ s/{{monthworduppershort}}/$entryVars->{'thisentrymonthworduppershort'}/gi;
$newarchivefile =~ s/{{monthwordlowershort}}/$entryVars->{'thisentrymonthwordlowershort'}/gi;
$newarchivefile =~ s/{{archivebody}}/$indexarchivebody/gi;
$newarchivefile =~ s/{{logbody}}/$indexarchivebody/gi;

# &gm_formatentry($newarchivefile);
$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
	template=>$newarchivefile, errHandler=>\&Gm_Web::displayAdminErrorExit);

##if ($archiveformat eq Gm_Constants::WEEK) {
##	$usethisarchivefilename = "$EntriesPath/archive-$thisentryweekbeginningmonthmonth$thisentryweekbeginningdayday$thisentryweekbeginningyearyear-$thisentryweekendingmonthmonth$thisentryweekendingdayday$thisentryweekendingyearyear\.$logarchivesuffix";
##} else {
##	$usethisarchivefilename = "$EntriesPath/archive-$thisentrymonthmonth$thisentryyearyear\.$logarchivesuffix";
##}

# open (THISFILEPAWS, ">$usethisarchivefilename") || &gm_dangermouse("Can't write to $usethisarchivefilename.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# print THISFILEPAWS $entryreturn;
# close (THISFILEPAWS); 
# chmod (0666, "$usethisarchivefilename");

Gm_Storage::saveFile( loc=>"$usethisarchivefilename", content=>[$entryreturn],
	'new'=>1, ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit );
                        
}

# -----------------------
# rebuild connected files
# -----------------------

sub gm_rebuildconnectedfiles {

@connectedfilelist = split ('\\n', $otherfilelist);

## TODO: THESE SHOULD BE CONSTANTS
@variabledatabase = (Gm_Constants::TAGS);

# &gm_getentryvariables($newentrynumber);
my $entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );

$connectedfilesdone = Gm_Constants::NO;
$connectstartfromhere = $IN{'connectednumber'};
if ($connectstartfromhere eq Gm_Constants::EMPTY) { $connectstartfromhere = 0; }
$connectendhere = $connectstartfromhere + 9;
if (($connectendhere > $#connectedfilelist) || ($connectendhere eq $#connectedfilelist)) {
	$connectendhere = $#connectedfilelist;
	$connectedfilesdone = Gm_Constants::YES;
}
$IN{'connectednumber'} = $connectendhere + 1;

$connectcounter = 0;

foreach $usethisfilename (@connectedfilelist) {
unless (($connectcounter < $connectstartfromhere) || ($connectcounter > $connectendhere)) {

	$usethisfilenamestripped = $usethisfilename;
	$usethisfilenamestripped =~ s/\//BACKSLASH/g;
	$usethisfilenamestripped =~ s/\W//g;
	$usethisfilenamestripped =~ s/BACKSLASH/-/g;

	$thereisapattern = Gm_Constants::NO;

# 	open (OTHERORIGFILE, "<$usethisfilename") || &gm_dangermouse("Can't open $usethisfilename.  Please make sure that this file exists and is CHMODed to 666, or else remove it from your list of connected files in configuration.");
# 	@otherorigfilelines = <OTHERORIGFILE>;
# 	close (OTHERORIGFILE);
	@otherorigfilelines = @{Gm_Storage::readFile( loc=>"$usethisfilename", rel=>'1',
		errHandler=>\&Gm_Web::displayAdminErrorExit )};
	## couldn't use the < because it would freak out and not open file
# 	unless (!(open(CHECKTHISFILE,"$EntriesPath/$usethisfilenamestripped.cgi"))) {
# 		open (OTHERPATTERNFILE, "$EntriesPath/$usethisfilenamestripped.cgi") || &gm_dangermouse("Can't open $EntriesPath/$usethisfilenamestripped.cgi.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# 		@otherpatternfilelines = <OTHERPATTERNFILE>;
# 		close (OTHERPATTERNFILE);
# 		$thereisapattern = Gm_Constants::YES;
# 	}
# 	close(CHECKTHISFILE);
	if( -e "$EntriesPath/$usethisfilenamestripped.cgi" ){
		@otherpatternfilelines = @{Gm_Storage::readFile( loc=>"$EntriesPath/$usethisfilenamestripped.cgi", 
			errHandler=>\&Gm_Web::displayAdminErrorExit )};
		$thereisapattern = Gm_Constants::YES;
	}

	$gmcounter = 0;

	foreach (@otherorigfilelines) {
		chomp ($otherorigfilelines[$gmcounter]);
		$gmcounter++;
	}
	## TODO: making assumptions about how to store, CHANGE THIS!
	$otherorigfilebody = join ('|*|', @otherorigfilelines);

	foreach $thisvariablecheck (@variabledatabase) {
		if ($otherorigfilebody =~ m/$thisvariablecheck/i) { $thereisapattern = Gm_Constants::NO; }
	}

	unless ($thereisapattern eq Gm_Constants::NO) {
		$gmcounter = 0;
		foreach (@otherpatternfilelines) {
			chomp ($otherpatternfilelines[$gmcounter]);
			$gmcounter++;
		}
		## TODO: making assumptions about how to store, CHANGE THIS!
		$otherpatternfilebody = join ('|*|', @otherpatternfilelines);
		$otherfilebody = $otherpatternfilebody;
	} else {
		$otherfilebody = $otherorigfilebody;
	}

	$newfilebodypattern = $otherfilebody;

	# 	&gm_formatentry($otherfilebody);
	$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
		template=>$otherfilebody, errHandler=>\&Gm_Web::displayAdminErrorExit);

	## TODO: making assumptions about how to store, CHANGE THIS!
	$entryreturn =~ s/\|\*\|/\n/g;
	$newfilebodypattern =~ s/\|\*\|/\n/g;

#  	chmod (0666, "$usethisfilename");  ## if the webuser is different, then we can't do anything ...

# 	open (OTHERFILEONE, ">$usethisfilename") || &gm_dangermouse("Can't write to $usethisfilename.  Please make sure that this file exists and is CHMODed to 666, or else remove it from your list of connected files in configuration.");
# 	print OTHERFILEONE $entryreturn;
# 	close (OTHERFILEONE);
	Gm_Storage::saveFile( loc=>"$usethisfilename", content=>[$entryreturn], rel=>'1',
		errHandler=>\&Gm_Web::displayAdminErrorExit );

# 	open (OTHERFILETWO, ">$EntriesPath/$usethisfilenamestripped.cgi") || &gm_dangermouse("Can't write to $EntriesPath/$usethisfilenamestripped.cgi.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# 	print OTHERFILETWO $newfilebodypattern;
# 	close (OTHERFILETWO);
	Gm_Storage::saveFile( loc=>"$EntriesPath/$usethisfilenamestripped.cgi", content=>[$newfilebodypattern],
		'new'=>1, ch_mod=>'0666', rel=>'1', errHandler=>\&Gm_Web::displayAdminErrorExit );
# 	chmod (0666, "$EntriesPath/$usethisfilenamestripped.cgi");

}
$connectcounter++;
}

}

# -------------------------
# generate log archive list
# -------------------------
# DEPRECATED: Gm_Core::generateArchiveLogList()
sub gm_generatearchiveloglist {
	die( "gm_generatearchiveloglist has been DEPRECATED");
}

# -----------------------
# generate log entry list
# -----------------------
# DEPRECATED BY: Gm_Core::generateEntryLogList
sub gm_generateentryloglist {
	die( "gm_generateentryloglist has been DEPRECATED");
}

# ----------------------------------------------
# generate log entry list for individual authors
# ----------------------------------------------
# DEPRECATED BY: Gm_Core::generateEntryLogListAuthor
sub gm_generateentryloglistauthor {
	die( "gm_generateentryloglistauthor has been DEPRECATED");
}

# -------------------------------------------
# generate log entry list for comment sorting
# -------------------------------------------
# DEPRECATED BY: Gm_Core::generateEntryLogListComments
sub gm_generateentryloglistcomments {
	die( "gm_generateentryloglistcomments has been DEPRECATED");
}


# ----------------------
# get log list variables
# ----------------------
# DEPRECATED by Gm_Core::getArchiveVariables
sub gm_getloglistvariables {
	die( "gm_getloglistvariables has been DEPRECATED");
}

# --------------------------
# entry list sub-sub routine
# --------------------------
## DEPRECATED BY: translateArchiveTemplates
sub entrylistsubsub {
	die( "entrylistsubsub has been DEPRECATED");
}

# ----------------------------------
# generate external author variables
# ----------------------------------
## DEPRECATED BY: Gm_Core::translateExternalAuthorVariables
sub gm_generateexternalauthorvariables {
	die( "gm_generateexternalauthorvariables has been DEPRECATED");
}

# -----------------
# generate calendar
# -----------------
# DEPRECATED BY: Gm_Core::generateCalendar
sub gm_generatecalendar {
	die( "gm_generatecalendar has been DEPRECATED");
}

# -----------------
# log the author in
# -----------------
# DEPRECATED BY: Gm_Security::_login
sub gm_login {

## TODO PERHAPS THIS SHOULD USE CUSTOM ERRORHANDLER TO GIVE USER OPTION TO FIX FILES?
## DIAGNOSITICS CHMODS, BUT COULD GET TO IT IF IT DIDN'T ALREADY WORK, REALLY NEED
## TO RESTRICT DIAGNOSITIC ACCESS?
Gm_Storage::validateResources( errHandler=>\&Gm_Web::displayAdminErrorExit );

if ($loginnotice eq Gm_Constants::EMPTY) { $loginnotice = qq(<B><FONT COLOR="#000000">Login Prompt</font></B><P>); }

&gm_readconfig;

if ($cookiesallowed eq Gm_Constants::NO) {
	$getnameandpwcookie = Gm_Constants::EMPTY;
} else {
	$getnameandpwcookie = "<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"JavaScript\">\n<!--//\ndocument.gmloginform.authorname.value = getCookie(\"gmcookiename\");\ndocument.gmloginform.authorpassword.value = getCookie(\"$cookiename\");\ndocument.gmloginform.authorname.focus();\n//-->\n</SCRIPT>";
}


## TODO THIS SHOULD UTILIZE A PRINT_ADMIN_SCREEN TYPE FUNCTION
print Gm_Web::createRequestHeader();
print<<GMLOGIN;

$gmheadtag

$gmframetop
$loginnotice

<FORM ACTION="gm.cgi" METHOD=POST NAME="gmloginform">
<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0>
<TR><TD ALIGN=RIGHT>$gmfonttag Author:</font></TD><TD ALIGN=LEFT></font>
  <INPUT TYPE=TEXT CLASS="textinput" SIZE=20 NAME="authorname" STYLE="width: 200">$gmfonttag</TD></TR>
<TR><TD ALIGN=RIGHT>$gmfonttag Password:</font></TD><TD ALIGN=LEFT></font>
  <INPUT TYPE=PASSWORD CLASS="textinput" SIZE=20 NAME="authorpassword" STYLE="width: 200">$gmfonttag</TD></TR></TABLE>
  
<P>

<INPUT TYPE=SUBMIT CLASS="button" VALUE="Enter" STYLE="background: #D0FFD0; width: 75">
<INPUT TYPE=HIDDEN NAME="thomas" VALUE="login">
</FORM><P>

$getnameandpwcookie
$gmframebottom

</BODY>
</HTML>

GMLOGIN

exit;

}

# ------------------
# validate the login
# ------------------
## DEPRECATED BY Gm_Security::auth
# Can auth be refactored in here?
sub gm_validate {

&gm_readconfig; ## TODO COORDINATE SO ONLY DONE ONCE PER CALL
&gm_bancheck; ## works off of some configs


$gmvalidated = Gm_Constants::NO;
$gmentryaccess = Gm_Constants::NO;
$gmentryeditaccess = Gm_Constants::NO;
$gmconfigurationaccess = Gm_Constants::NO;
$gmtemplateaccess = Gm_Constants::NO;
$gmauthoraccess = Gm_Constants::NO;
$gmcplogaccess = Gm_Constants::NO;
$gmrebuildaccess = Gm_Constants::NO;
$gmbookmarkletaccess = Gm_Constants::NO;
$gmuploadaccess = Gm_Constants::NO;
$gmloginaccess = Gm_Constants::NO;

$IN{'authorname'} =~ s/\|//g;
$IN{'authorpassword'} =~ s/\|//g;
$IN{'authorname'} =~ s/^\s+//;
$IN{'authorname'} =~ s/\s+$//;
$IN{'authorpassword'} =~ s/^\s+//;
$IN{'authorpassword'} =~ s/\s+$//;

########################################################################
## gm_validate extension to allow a rebuild operation without a password
## by passing a token reference instead. added by linear 9/3/2003 
########################################################################
# merged in 1.3

if ( (($IN{'authorname'} eq Gm_Constants::EMPTY) || ($IN{'authorpassword'} eq Gm_Constants::EMPTY)) 
	&& $IN{'thomas'} ne '') {
    unless($IN{'gmtoken'}) {
    	$loginnotice = qq(<B><FONT COLOR="#0000FF">You left one or more of the fields blank.  Please try again.</font></B><P>);
    	gm_writetocplog("<B><FONT COLOR=\"#FF0000\">Invalid login attempt:</font></B> One or more fields left blank ($IN{'authorname'} $IN{'authorpassword'})");
    	&gm_login;
	}
}

if ($IN{'gmtoken'} && $IN{'rebuilding'}) {
  # read the token from the file where we persisted it
#   open (TOKENPLEASE, "<$EntriesPath/gm-token.cgi") || &gm_dangermouse("Can't read the token file.");
#   @gmtoken = <TOKENPLEASE>;
#   $gmtoken = $gmtoken[0];
#   chomp ($gmtoken);
#   $gmtokenauthor = $gmtoken[1];
#   chomp ($gmtokenauthor);
#   $gmtokenpass = $gmtoken[2];
#   chomp ($gmtokenpass);
#   close (TOKENPLEASE);
@gmtoken = @{Gm_Storage::readFile( loc=>"$EntriesPath/gm-token.cgi",
	errHandler=>\&Gm_Web::displayAdminErrorExit )};
$gmtoken = $gmtoken[0];
$gmtokenauthor = $gmtoken[1];
$gmtokenpass = $gmtoken[2];

  # examine the token for validity
  if ($IN{'gmtoken'} eq $gmtoken) { 
        $IN{'authorname'} = $gmtokenauthor;
        $IN{'authorpassword'} = $gmtokenpass;
  }
}                  

my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );
my $selectedauthor = $gmauthors->{$IN{'authorname'}};

if ($selectedauthor->{'author'} eq $IN{'authorname'}) {
	$gmvalidated = 'foundname';
	## THE STORED PASSWORD IS BEING PASSED AS SALT, INCASE SALT WAS ADDED BY PROGRAM, 
	# THEN HAVE SAME SALT
	my $crypted = crypt($IN{'authorpassword'}, $selectedauthor->{'password'});
	if ( ($selectedauthor->{'password'} eq $crypted) || 
		($selectedauthor->{'password'} eq $IN{'authorpassword'}) )  {
		$gmvalidated = Gm_Constants::YES;
		if ($selectedauthor->{'postnew'} eq Gm_Constants::Y ) { $gmentryaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'editentries'} eq Gm_Constants::Y ) { $gmentryeditaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'editentries'} eq 'O') { $gmentryeditaccess = 'mineonly'; }
		if ($selectedauthor->{'editconfigs'} eq Gm_Constants::Y ) { $gmconfigurationaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'edittemplates'} eq Gm_Constants::Y ) { $gmtemplateaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'edittemplates'} eq 'O') { $gmtemplateaccess = 'hfsonly'; }
		if ($selectedauthor->{'editauthors'} eq Gm_Constants::Y ) { $gmauthoraccess = Gm_Constants::YES; }
		if ($selectedauthor->{'rebuild'} eq Gm_Constants::Y ) { $gmrebuildaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'viewcplog'} eq Gm_Constants::Y ) { $gmcplogaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'bookmarklets'} eq Gm_Constants::Y ) { $gmbookmarkletaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'upload'} eq Gm_Constants::Y ) { $gmuploadaccess = Gm_Constants::YES; }
		if ($selectedauthor->{'viewadmin'} eq Gm_Constants::Y ) { $gmloginaccess = Gm_Constants::YES; }
	}
}

if ($gmvalidated eq 'foundname') {
	$loginnotice = qq(<B><FONT COLOR="#0000FF">The password you entered for that author is incorrect.  Please try again.</font></B><P>);
	gm_writetocplog("<B><FONT COLOR=\"#FF0000\">Invalid login attempt:</font></B> Incorrect password ($IN{'authorpassword'}) for $IN{'authorname'}");
	&gm_login;
}

if ($gmvalidated ne Gm_Constants::YES) {
	$loginnotice = qq(<B><FONT COLOR="#0000FF">No such author is registered.  Please try again.</font></B><P>);
	gm_writetocplog("<B><FONT COLOR=\"#FF0000\">Invalid login attempt:</font></B> No such author as $IN{'authorname'} ($IN{'authorpassword'}) registered");
	&gm_login;
}

return( $selectedauthor );
}

# --------------------------
# check if this IP is banned
# --------------------------
# DEPRECATED BY: Gm_Core::processBanCheck
sub gm_bancheck {

## Only used by gm_validate, can be removed when that is

my $gmbanlist = Gm_Storage::getBanlist( errHandler=>\&Gm_Web::displayAdminErrorExit );

$currentip = $ENV{'REMOTE_ADDR'};

if ( scalar( keys(%$gmbanlist)) > 0 ) {
	foreach my $gmbanlistline ( keys(%$gmbanlist)) {
		($checkthisip, $checkthisiphost, $checkthisperson) = 
			($gmbanlist->{$gmbanlistline}{'ip'}, $gmbanlist->{$gmbanlistline}{'host'}, 
			 $gmbanlist->{$gmbanlistline}{'label'} );
			 
		if (($currentip =~ m/$checkthisip/) && ($checkthisip ne Gm_Constants::EMPTY)) {
			#cp log will check if should actually log
			my $cpMsg = "<font color=\"#FF0000\"><b>A banned IP ($checkthisip";
			if ($checkthisperson ne Gm_Constants::EMPTY) {
				$cpMsg .= ", \"$checkthisperson\""; 
			}
			$cpMsg .= ") attempted to access this program</b></font>";
			gm_writetocplog( $cpMsg );

			## Tell them why
			&gm_dangermouse("You have been banned from accessing this program.<br />(IP: $currentip)");
		}
	}
}

}

# ---------------
# write to cp log
# ---------------
## Write to Control Panel Log
# shorthand to write to the control panel log
# ARGS1 = message to write to control panel
# DEPRECATED: Gm_Core::writeToCplog()
sub gm_writetocplog {
	my $writetologtext = shift;

	if ($keeplog eq Gm_Constants::YES) {
		my ($gmdate) = Gm_Utils::getStdDate( $serveroffset );
		if( Gm_Security::hackWebTest( $writetologtext ) ){
			$writetologtext = '<font COLOR="#dd0000">[Aborted log - Hack Attempt]</font> by '.$ENV{'REMOTE_ADDR'};
		}
	
		Gm_Storage::addLogMessage( msg=>"<font size=\"1\">[$gmdate] [$authorIP]".
		"</font> $writetologtext",
		errHandler=>\&Gm_Web::displayAdminErrorExit );
	}
}   


# -----------------------------
# danger will robinson, danger!
# -----------------------------
### DEPRICATED, USE Gm_Web::displayAdminErrorExit INSTEAD
sub gm_dangermouse {
	my $dangerwarning = shift(@_);
	Gm_Web::displayAdminErrorExit( $dangerwarning );
}

1;


# ------------------------
# front page - log options
# ------------------------
## DEPRECATED BY: viewBanList in gm.cgi
sub gm_frontpage {

&gm_readconfig;

if (($cgilocalpath eq Gm_Constants::EMPTY) || ($cgiwebpath eq Gm_Constants::EMPTY) || ($LogPath eq Gm_Constants::EMPTY) || ($EntriesPath eq Gm_Constants::EMPTY) || ($LogWebPath eq Gm_Constants::EMPTY) || ($EntriesWebPath eq Gm_Constants::EMPTY)) {

	if (($cgilocalpath eq Gm_Constants::EMPTY) && ($LogPath ne Gm_Constants::EMPTY)) { $cgilocalpath = $LogPath; }
	if (($cgiwebpath eq Gm_Constants::EMPTY) && ($LogWebPath ne Gm_Constants::EMPTY)) { $cgiwebpath = $LogWebPath; }

	if ($cgilocalpath eq Gm_Constants::EMPTY) {
		if ($ENV{'SCRIPT_FILENAME'}) { $cgilocalpath = $ENV{'SCRIPT_FILENAME'}; }
		elsif ($ENV{'PATH_TRANSLATED'}) {
			$cgilocalpath = $ENV{'PATH_TRANSLATED'};
			$cgilocalpath =~ s/\\/\//g; 
		}
		@cgilocalpathtemp = split(/\//, $cgilocalpath);
		pop(@cgilocalpathtemp);
		$cgilocalpath = join("\/", @cgilocalpathtemp);
		# added 1.3.1 - 1/20/05 flipped cracker
		$loglocalpath = $cgilocalpath;
		$loglocalpath =~ s/\/cgi-bin//g;
		# end additions
	}

	@cgipath = split(/\//, $cgilocalpath);
	$cgiwebpathextension = pop(@cgipath);
	# added 1.3.1 - 1/20/05 flipped cracker
	@logpath = split(/\//, $loglocalpath);
	$logwebpathextension = pop(@logpath);
	if ($logwebpathextension eq "public_html") { $logwebpathextensionnew = Gm_Constants::EMPTY; }
	 else { 
	   $logwebpathextensionnew = "/";
	   $logwebpathextensionnew .= $logwebpathextension;
	 }
	# end additions

	if ($cgiwebpath eq Gm_Constants::EMPTY) { $cgiwebpath = "http://$ENV{'HTTP_HOST'}/$cgiwebpathextension"; }

	if ($LogPath eq Gm_Constants::EMPTY) { $LogPath = $loglocalpath; }
	if ($EntriesPath eq Gm_Constants::EMPTY) { $EntriesPath = ("$loglocalpath" . "/archives"); }
	if ($LogWebPath eq Gm_Constants::EMPTY) { $LogWebPath = "http://$ENV{'HTTP_HOST'}$logwebpathextensionnew"; }
	if ($EntriesWebPath eq Gm_Constants::EMPTY) { $EntriesWebPath = "http://$ENV{'HTTP_HOST'}$logwebpathextensionnew/archives"; }

	&gm_writeconfig;

}

&gm_validate;

if ($gmloginaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to log in without authorization");
	$loginnotice = qq(<B><FONT COLOR="#FF0000">You don't have access to log in.</FONT></B><P>);
	&gm_login;
}

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Main Menu</FONT></B><P>); }

if (($IN{'authorname'} eq "Alice") && ($IN{'authorpassword'} eq "wonderland")) {
	$setnameandpwcookie = Gm_Constants::EMPTY;
} else {
	$setnameandpwcookie = "<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"JavaScript\">\n<!--//\nvar now = new Date();\nfixDate(now);\nnow.setTime(now.getTime() + 365 * 24 * 60 * 60 * 1000);\nsetCookie(\"gmcookiename\", \"$IN{'authorname'}\", now);\nsetCookie(\"$cookiename\", \"$IN{'authorpassword'}\", now);\n//-->\n</SCRIPT>";
}

if ($cookiesallowed eq Gm_Constants::NO) {
	$setnameandpwcookie = Gm_Constants::EMPTY;
}

$visityoursitelink = Gm_Constants::EMPTY;

# THIS SHOULD BE LINK THAT LOOKS LIKE BUTTON, SEE MULTIEDIT
# unless (!(open(CHECKMATE,"<$LogPath/$indexfilename"))) {
unless (! -e "$LogPath/$indexfilename"  ){
	&gm_readcounter;
	unless ($newentrynumber eq "0") {
		$indexfilenamesmartcheck = "/$indexfilename";
		$indexfilenameprefix = substr($indexfilename, 0, 6);
		if ($indexfilenameprefix eq "index.") { $indexfilenamesmartcheck = "/"; }
		$visityoursitelink = qq(<FORM ACTION="$LogWebPath$indexfilenamesmartcheck" TARGET="NEW">\n<TR><TD VALIGN=TOP ALIGN=CENTER COLSPAN=2>$gmfonttag<FONT SIZE=1><INPUT TYPE=SUBMIT CLASS="button" VALUE="Visit Your Site" STYLE="background: #D0FFD0; width: 500"><BR>Open your weblog/journal in a new browser window.</FONT></FONT></TD></TR>\n</FORM>);
	}
}
# close(CHECKMATE);

## TODO THIS SHOULD UTILIZE A PRINT_ADMIN_SCREEN TYPE FUNCTION
print Gm_Web::createRequestHeader();
print<<GMFRONTPAGE;

$gmheadtag

$gmframetop
$statusnote
$setnameandpwcookie

<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 WIDTH=520>
<TR><TD VALIGN=TOP ALIGN=CENTER COLSPAN=2>
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
$gmfonttag<FONT SIZE=1>
<INPUT type="hidden" name="section" value="entries">
<INPUT TYPE=SUBMIT CLASS="button" NAME="new" VALUE="Add A New Entry" STYLE="background: #D0FFD0; width: 500">
</form>
<BR>Post a new entry to your weblog/journal.</FONT></FONT></TD></TR>

<TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag
<FONT SIZE=1>
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Configuration"><BR>
Your site's settings and options.</FONT></FONT></TD>
<TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="entries" VALUE="Edit An Entry"><BR>
Edit entries and edit/delete comments.</FONT></FONT></TD></TR>

<TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag
<FONT SIZE=1><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Templates"><BR>
Change your site's layout and appearance.</FONT></FONT></TD>
<TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="authors" VALUE="Edit Authors"><BR>
Edit or add authors to post to your site.</FONT></FONT></TD></TR>

<TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Files"><BR>
Regenerate part or all of your site.</FONT></FONT></TD>
<TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="cplog" VALUE="View Control Panel Log"><BR>
A record of how your site's been used.</FONT></FONT></TD></TR>

<TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="bookmarklet" VALUE="Add Bookmarklets"><BR>
Post entries with one click (IE 5+ only).</FONT></FONT></TD>
<TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Upload Files"><BR>
Upload images or other files to your site.</FONT></FONT></TD></TR>

<TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="banip" VALUE="Edit Banned IP List"><BR>
Ban someone from using your site.</FONT></FONT></TD>
<TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>$gmfonttag<FONT SIZE=1>
<INPUT TYPE=SUBMIT CLASS="button" NAME="relogin" VALUE="Re-Login"><BR>
Re-enter as another author.</FONT></FONT></TD></TR>

</FORM>

$visityoursitelink

</TABLE>
<P>
$gmframebottom

</BODY>
</HTML>

GMFRONTPAGE

$statusnote = Gm_Constants::EMPTY;

exit;

}

# ----------------
# templates editor
# ----------------

sub gm_edittemplates {

&gm_validate;

if ($gmtemplateaccess eq Gm_Constants::NO) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the templates.</FONT></B><P>);
	&gm_frontpage;
}

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Edit Templates</FONT></B><BR><FONT SIZE=1>Select a group of templates to edit.  Templates control<BR>the layout & format of every aspect of your weblog/journal.</FONT><P>); }

if ($gmtemplateaccess eq "hfsonly") {
	$statusnote .= "<B>You only have access to edit the header, footer & sidebar templates.</B><P>";
}

print<<GMEDITTEMPLATESMENU;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Main Index-Related Templates" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Archive-Related Templates" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Entry Page-Related Templates" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Karma & Comments-Related Templates" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Header, Footer & Sidebar Templates" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Miscellaneous Templates" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="width: 320; background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMEDITTEMPLATESMENU

$statusnote = Gm_Constants::EMPTY;

exit;

}

# -------------------------------
# edit template group: main index
# -------------------------------

sub gm_editmainindextemplates {

&gm_validate;

if (($gmtemplateaccess eq Gm_Constants::NO) || ($gmtemplateaccess eq "hfsonly")) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the main index templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the main index templates.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readtemplates;

&gm_delousealltemplates;

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Editing Main Index-Related Templates</FONT></B><BR><FONT SIZE=1>These are the templates that affect the layout and appearance of your main index.</FONT><P>); }

if ($gmrebuildaccess eq Gm_Constants::YES) {
	if ($automaticrebuilddefault eq Gm_Constants::YES) {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="index" CHECKED> Automatically rebuild main index after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	} else {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="index"> Automatically rebuild main index after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	}
}

&gm_readcounter;
if ($newentrynumber eq "0") { $autorebuildcheckbox = Gm_Constants::EMPTY; }

print<<GMEDITMAININDEXTEMPLATES;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="modifiedtemplategroup" VALUE="main index">
<INPUT TYPE=HIDDEN NAME="newentrypagetemplate" VALUE="$gmentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveindextemplate" VALUE="$gmarchiveindextemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrypagetemplate" VALUE="$gmarchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrytemplate" VALUE="$gmarchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newcommentstemplate" VALUE="$gmcommentstemplate">
<INPUT TYPE=HIDDEN NAME="newcommentsformtemplate" VALUE="$gmcommentsformtemplate">
<INPUT TYPE=HIDDEN NAME="newparaseparationtemplate" VALUE="$gmparaseparationtemplate">
<INPUT TYPE=HIDDEN NAME="newkarmaformtemplate" VALUE="$gmkarmaformtemplate">
<INPUT TYPE=HIDDEN NAME="newlinktargettemplate" VALUE="$gmlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newkarmalinktemplate" VALUE="$gmkarmalinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentslinktemplate" VALUE="$gmcommentslinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthoremailtemplate" VALUE="$gmcommentauthoremailtemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthorhomepagetemplate" VALUE="$gmcommentauthorhomepagetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentdividertemplate" VALUE="$gmcommentdividertemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagetemplate" VALUE="$gmmoreentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrypagetemplate" VALUE="$gmmorearchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newpreviouslinktemplate" VALUE="$gmpreviouslinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextlinktemplate" VALUE="$gmnextlinktemplate">
<INPUT TYPE=HIDDEN NAME="newpreviousmorelinktemplate" VALUE="$gmpreviousmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextmorelinktemplate" VALUE="$gmnextmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newarchivemasterindextemplate" VALUE="$gmarchivemasterindextemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinktemplate" VALUE="$gmlogarchiveslinktemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinktemplate" VALUE="$gmentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagelinktemplate" VALUE="$gmmoreentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkseparatortemplate" VALUE="$gmlogarchiveslinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkseparatortemplate" VALUE="$gmentrypagelinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkmonthseparatortemplate" VALUE="$gmentrypagelinkmonthseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkdayseparatortemplate" VALUE="$gmentrypagelinkdayseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkyearseparatortemplate" VALUE="$gmentrypagelinkyearseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newheadertemplate" VALUE="$gmheadertemplate">
<INPUT TYPE=HIDDEN NAME="newfootertemplate" VALUE="$gmfootertemplate">
<INPUT TYPE=HIDDEN NAME="newsidebartemplate" VALUE="$gmsidebartemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentryseparatortemplate" VALUE="$gmarchiveentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrytemplate" VALUE="$gmmorearchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newdatearchivetemplate" VALUE="$gmdatearchivetemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkweeklytemplate" VALUE="$gmlogarchiveslinkweeklytemplate">
<INPUT TYPE=HIDDEN NAME="newcustomonetemplate" VALUE="$gmcustomonetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtwotemplate" VALUE="$gmcustomtwotemplate">
<INPUT TYPE=HIDDEN NAME="newcustomthreetemplate" VALUE="$gmcustomthreetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfourtemplate" VALUE="$gmcustomfourtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfivetemplate" VALUE="$gmcustomfivetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomsixtemplate" VALUE="$gmcustomsixtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomseventemplate" VALUE="$gmcustomseventemplate">
<INPUT TYPE=HIDDEN NAME="newcustomeighttemplate" VALUE="$gmcustomeighttemplate">
<INPUT TYPE=HIDDEN NAME="newcustomninetemplate" VALUE="$gmcustomninetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtentemplate" VALUE="$gmcustomtentemplate">
<INPUT TYPE=HIDDEN NAME="newpopuppagetemplate" VALUE="$gmpopuppagetemplate">
<INPUT TYPE=HIDDEN NAME="newpopupcodetemplate" VALUE="$gmpopupcodetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchformtemplate" VALUE="$gmsearchformtemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultspagetemplate" VALUE="$gmsearchresultspagetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultsentrytemplate" VALUE="$gmsearchresultsentrytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartablebeginningtemplate" VALUE="$gmcalendartablebeginningtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartableendingtemplate" VALUE="$gmcalendartableendingtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarblankcelltemplate" VALUE="$gmcalendarblankcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelltemplate" VALUE="$gmcalendarfullcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelllinktemplate" VALUE="$gmcalendarfullcelllinktemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaytemplate" VALUE="$gmcalendarweekfulldaytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaylinktemplate" VALUE="$gmcalendarweekfulldaylinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewdividertemplate" VALUE="$gmcommentpreviewdividertemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewformtemplate" VALUE="$gmcommentpreviewformtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinknocommentstemplate" VALUE="$gmsmartlinknocommentstemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkonecommenttemplate" VALUE="$gmsmartlinkonecommenttemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkmanycommentstemplate" VALUE="$gmsmartlinkmanycommentstemplate">
<INPUT TYPE=HIDDEN NAME="newlinebreaktemplate" VALUE="$gmlinebreaktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentlinktargettemplate" VALUE="$gmcommentlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymoodtemplate" VALUE="$gmsmartentrymoodtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymusictemplate" VALUE="$gmsmartentrymusictemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfooterarchivetemplate" VALUE="$gmdategroupingfooterarchivetemplate">
<INPUT TYPE=HIDDEN NAME="newcookiescodetemplate" VALUE="$gmcookiescodetemplate">
<INPUT TYPE=HIDDEN NAME="newsmartemoticonscodetemplate" VALUE="$gmsmartemoticonscodetemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorheadertemplate" VALUE="$gmusererrorheadertemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorfootertemplate" VALUE="$gmusererrorfootertemplate">

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Main Index Template</B><BR><FONT SIZE=1>The overall template for your main index page&#151;typically the first page that people will see on your weblog/journal.  The {{logbody}} variable is the placeholder that tells Greymatter where you want the body of your log to be inserted, so it must be included somewhere in this template.  The format of the log body is controlled through the templates below.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newindextemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmindextemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<tr><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Index Entry Templates</B><BR><FONT SIZE=1>These templates control how individual entries are listed in the body of your log.  The left template is the format of standard entry listings, and the right template is the format of extended entry listings (entries that contain "more" text).</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Index Entry Template: Standard Entries</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Index Entry Template: Extended Entries</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentrytemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmentrytemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newmoreentrytemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmmoreentrytemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="entrylistingmorecheck" VALUE="yes"> Make this the same as the template on the left</FONT></FONT></TD></TR></TABLE></TD></TR>

<tr><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>"Stay At Top" Index Entry Template</B><BR><FONT SIZE=1>Like the index entry templates above, except this will apply to any entry you've marked to stay at the top of your main log (only one entry at a time can be marked as such); use this for any way you might wish to set that apart.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newstayattoptemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmstayattoptemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="entrylistingstayattopcheck" VALUE="yes"> Make this the same as the standard index entry template</FONT></TD></TR></TABLE></TD></TR>

<tr><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Date Grouping Header Template</B><BR><FONT SIZE=1>When your log is generated, the entry listings for each day are prefaced with a date header; this controls how that date header appears.  Leave this blank if you don't want to group your entry listings in this way. DO NOT put {{entry*}}, {{comment*}}, or {{time*}} variables here.<BR>&#160;</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Date Grouping Footer Template</B><BR><FONT SIZE=1>This is the complement to the Date Grouping Template. if you open a tag in the Date Grouping Template (such as a div or td) you can place the closing tag here. That allows you to contain a date grouping inside an element. All date variables that are supported in the Date Grouping Header Template are supported here as well.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newdatetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmdatetemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newdategroupingfootertemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmdategroupingfootertemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<tr><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><tr><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry Separator Template</B><BR><FONT SIZE=1>If you wish, you can have your entry listings divided with a special separator when your log is generated.  Leave this blank if you don't want to include a separator. Works only between multiple entries on a single day.<BR>&#160;</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentryseparatortemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmentryseparatortemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

</TABLE>
$autorebuildcheckbox
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Template Changes"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Templates Menu">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P> 
$gmframebottom

</BODY>
</HTML>

GMEDITMAININDEXTEMPLATES

$statusnote = Gm_Constants::EMPTY;

exit;

}

# -----------------------------
# edit template group: archives
# -----------------------------

sub gm_editarchivetemplates {

&gm_validate;

if (($gmtemplateaccess eq Gm_Constants::NO) || ($gmtemplateaccess eq "hfsonly")) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the archive templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the archive templates.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readtemplates;

&gm_delousealltemplates;

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Editing Archive-Related Templates</FONT></B><BR><FONT SIZE=1>These are the templates that affect the layout and appearance of your archives.</FONT><P>); }

$autorebuildcheckbox = Gm_Constants::EMPTY;

if ($gmrebuildaccess eq Gm_Constants::YES) {
	if ($automaticrebuilddefault eq Gm_Constants::YES) {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="archiveindexes" CHECKED> Automatically rebuild archive master index and log indexes after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	} else {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="archiveindexes"> Automatically rebuild archive master index and log indexes after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	}
}

&gm_readcounter;
if ($newentrynumber eq "0") { $autorebuildcheckbox = Gm_Constants::EMPTY; }

print<<GMEDITARCHIVETEMPLATES;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="modifiedtemplategroup" VALUE="archive">
<INPUT TYPE=HIDDEN NAME="newindextemplate" VALUE="$gmindextemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagetemplate" VALUE="$gmentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrypagetemplate" VALUE="$gmarchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newentrytemplate" VALUE="$gmentrytemplate">
<INPUT TYPE=HIDDEN NAME="newstayattoptemplate" VALUE="$gmstayattoptemplate">
<INPUT TYPE=HIDDEN NAME="newdatetemplate" VALUE="$gmdatetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentstemplate" VALUE="$gmcommentstemplate">
<INPUT TYPE=HIDDEN NAME="newcommentsformtemplate" VALUE="$gmcommentsformtemplate">
<INPUT TYPE=HIDDEN NAME="newparaseparationtemplate" VALUE="$gmparaseparationtemplate">
<INPUT TYPE=HIDDEN NAME="newkarmaformtemplate" VALUE="$gmkarmaformtemplate">
<INPUT TYPE=HIDDEN NAME="newlinktargettemplate" VALUE="$gmlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfootertemplate" VALUE="$gmdategroupingfootertemplate">
<INPUT TYPE=HIDDEN NAME="newkarmalinktemplate" VALUE="$gmkarmalinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentslinktemplate" VALUE="$gmcommentslinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthoremailtemplate" VALUE="$gmcommentauthoremailtemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthorhomepagetemplate" VALUE="$gmcommentauthorhomepagetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentdividertemplate" VALUE="$gmcommentdividertemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrytemplate" VALUE="$gmmoreentrytemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagetemplate" VALUE="$gmmoreentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrypagetemplate" VALUE="$gmmorearchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newpreviouslinktemplate" VALUE="$gmpreviouslinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextlinktemplate" VALUE="$gmnextlinktemplate">
<INPUT TYPE=HIDDEN NAME="newpreviousmorelinktemplate" VALUE="$gmpreviousmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextmorelinktemplate" VALUE="$gmnextmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinktemplate" VALUE="$gmlogarchiveslinktemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinktemplate" VALUE="$gmentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagelinktemplate" VALUE="$gmmoreentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkseparatortemplate" VALUE="$gmlogarchiveslinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkseparatortemplate" VALUE="$gmentrypagelinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkmonthseparatortemplate" VALUE="$gmentrypagelinkmonthseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkdayseparatortemplate" VALUE="$gmentrypagelinkdayseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkyearseparatortemplate" VALUE="$gmentrypagelinkyearseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newheadertemplate" VALUE="$gmheadertemplate">
<INPUT TYPE=HIDDEN NAME="newfootertemplate" VALUE="$gmfootertemplate">
<INPUT TYPE=HIDDEN NAME="newsidebartemplate" VALUE="$gmsidebartemplate">
<INPUT TYPE=HIDDEN NAME="newentryseparatortemplate" VALUE="$gmentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkweeklytemplate" VALUE="$gmlogarchiveslinkweeklytemplate">
<INPUT TYPE=HIDDEN NAME="newcustomonetemplate" VALUE="$gmcustomonetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtwotemplate" VALUE="$gmcustomtwotemplate">
<INPUT TYPE=HIDDEN NAME="newcustomthreetemplate" VALUE="$gmcustomthreetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfourtemplate" VALUE="$gmcustomfourtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfivetemplate" VALUE="$gmcustomfivetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomsixtemplate" VALUE="$gmcustomsixtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomseventemplate" VALUE="$gmcustomseventemplate">
<INPUT TYPE=HIDDEN NAME="newcustomeighttemplate" VALUE="$gmcustomeighttemplate">
<INPUT TYPE=HIDDEN NAME="newcustomninetemplate" VALUE="$gmcustomninetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtentemplate" VALUE="$gmcustomtentemplate">
<INPUT TYPE=HIDDEN NAME="newpopuppagetemplate" VALUE="$gmpopuppagetemplate">
<INPUT TYPE=HIDDEN NAME="newpopupcodetemplate" VALUE="$gmpopupcodetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchformtemplate" VALUE="$gmsearchformtemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultspagetemplate" VALUE="$gmsearchresultspagetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultsentrytemplate" VALUE="$gmsearchresultsentrytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartablebeginningtemplate" VALUE="$gmcalendartablebeginningtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartableendingtemplate" VALUE="$gmcalendartableendingtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarblankcelltemplate" VALUE="$gmcalendarblankcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelltemplate" VALUE="$gmcalendarfullcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelllinktemplate" VALUE="$gmcalendarfullcelllinktemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaytemplate" VALUE="$gmcalendarweekfulldaytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaylinktemplate" VALUE="$gmcalendarweekfulldaylinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewdividertemplate" VALUE="$gmcommentpreviewdividertemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewformtemplate" VALUE="$gmcommentpreviewformtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinknocommentstemplate" VALUE="$gmsmartlinknocommentstemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkonecommenttemplate" VALUE="$gmsmartlinkonecommenttemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkmanycommentstemplate" VALUE="$gmsmartlinkmanycommentstemplate">
<INPUT TYPE=HIDDEN NAME="newlinebreaktemplate" VALUE="$gmlinebreaktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentlinktargettemplate" VALUE="$gmcommentlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymoodtemplate" VALUE="$gmsmartentrymoodtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymusictemplate" VALUE="$gmsmartentrymusictemplate">
<INPUT TYPE=HIDDEN NAME="newcookiescodetemplate" VALUE="$gmcookiescodetemplate">
<INPUT TYPE=HIDDEN NAME="newsmartemoticonscodetemplate" VALUE="$gmsmartemoticonscodetemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorheadertemplate" VALUE="$gmusererrorheadertemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorfootertemplate" VALUE="$gmusererrorfootertemplate">

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Archive Master Index Template</B><BR><FONT SIZE=1>If you wish, you can keep a master index of your archives&#151;an index page in your entries/archives directory intended for linking to all the archives (both the monthly/weekly logs and the individual entry pages) of your site.  You can use variables such as {{logarchivelist}} and {{logentrylist}} here (or anywhere) to generate those list links; check the <a href="http://greymatterforum.proboards82.com/" title="read the manual" target="_blank">manual</a> for more information about those variables.  If you don't wish to keep an archive master index, you can disable it in Configuration.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newarchivemasterindextemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmarchivemasterindextemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Archive Log Index Template</B><BR><FONT SIZE=1>Archive log index files are the archives of your log; this is like the main index except that the log archives are generated in monthly or weekly installments, each installment showing the full log for that given month or week.  As with the main index, {{logbody}} (or {{archivebody}}) is the placeholder that tells Greymatter where to put the body of your log.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newarchiveindextemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmarchiveindextemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="archivelogindexcheck" VALUE="yes"> Make this the same as the main index template</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Log Archive Entry Templates</B><BR><FONT SIZE=1>These templates control how individual entries are listed in the body of your log; these work the same as the main index versions, except this controls how they appear in the log archives instead.  The left template is the format of standard entry listings, and the right template is the format of extended entry listings (entries that contain "more" text).</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Archive Entry Template: Standard Entries</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Archive Entry Template: Extended Entries</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newarchiveentrytemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmarchiveentrytemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="archiveentrylistingcheck" VALUE="yes"> Make this the same as the main index version</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newmorearchiveentrytemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmmorearchiveentrytemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="archiveentrylistingmorecheck" VALUE="yes"> Make this the same as the main index version</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<tr><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><tr><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Archive Entry Separator Template</B><BR><FONT SIZE=1>If you wish, you can have your entry listings divided with a special separator when your log is generated.  This works the same as it does on the main index, except this is the separator for entries in your log archives.  Leave this blank if you don't want to include a separator.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newarchiveentryseparatortemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmarchiveentryseparatortemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="archiveentryseparatorcheck" VALUE="yes"> Make this the same as the main index version</FONT></FONT></TD></TR></TABLE></TD></TR>

<tr><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Archive Date Grouping Header Template</B><BR><FONT SIZE=1>When your log is generated, the entry listings for each day are prefaced with a date header; this controls how that date header appears.  This works the same as it does on the main index, except this is how the date header will appear in your log archives.  Leave this blank if you don't want to group your entry listings in this way.<BR>&#160;<BR>&#160;</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Archive Date Grouping Footer Template</B><BR><FONT SIZE=1>This is the complement to the Date Grouping Template. if you open a tag in the Date Grouping Template (such as a div or td) you can place the closing tag here. That allows you to contain a date grouping inside an element. All date variables that are supported in the Date Grouping Header Template are supported here as well. This works the same as it does on the main index, except this is how the date header will appear in your log archives.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newdatearchivetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmdatearchivetemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="archivedateheadercheck" VALUE="yes"> Make this the same as the main index version</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newdategroupingfooterarchivetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmdategroupingfooterarchivetemplate</TEXTAREA>$gmfonttag</FONT><br>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="archivedatefootercheck" VALUE="yes"> Make this the same as the main index version</FONT></FONT></TD></FONT></FONT></TD></TR></TABLE></TD></TR>


</TABLE>
$autorebuildcheckbox
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Template Changes"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Templates Menu">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMEDITARCHIVETEMPLATES

$statusnote = Gm_Constants::EMPTY;

exit;

}

# --------------------------------
# edit template group: entry pages
# --------------------------------

sub gm_editentrypagetemplates {

&gm_validate;

if (($gmtemplateaccess eq Gm_Constants::NO) || ($gmtemplateaccess eq "hfsonly")) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the entry page templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the entry page templates.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readtemplates;

&gm_delousealltemplates;

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B><FONT COLOR="#000000">Editing Entry Page-Related Templates</FONT></B><BR><FONT SIZE=1>These are the templates that affect the layout and appearance of the pages for your individual entries (as opposed to the Index Entry templates, in the Main Index and Archive template groups, which customise how entries appear in the body of your log).  If you have "Generate pages for individual entries" disabled in Configuration, you can ignore these templates.</FONT></TD></TR></TABLE><P>); }

$autorebuildcheckbox = Gm_Constants::EMPTY;

if ($gmrebuildaccess eq Gm_Constants::YES) {
	if ($automaticrebuilddefault eq Gm_Constants::YES) {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="entrypages" CHECKED> 
		Automatically rebuild all entry pages after saving\n<BR>\n<FONT SIZE=1>
		After clicking Save, expect a wait of up to several minutes if leaving this box checked.
		<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	} else {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="entrypages"> Automatically rebuild all entry pages after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	}
}

&gm_readcounter;
if ($newentrynumber eq "0") { $autorebuildcheckbox = Gm_Constants::EMPTY; }

print<<GMEDITENTRYPAGETEMPLATES;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="modifiedtemplategroup" VALUE="entry page">
<INPUT TYPE=HIDDEN NAME="newindextemplate" VALUE="$gmindextemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveindextemplate" VALUE="$gmarchiveindextemplate">
<INPUT TYPE=HIDDEN NAME="newentrytemplate" VALUE="$gmentrytemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrytemplate" VALUE="$gmarchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newstayattoptemplate" VALUE="$gmstayattoptemplate">
<INPUT TYPE=HIDDEN NAME="newdatetemplate" VALUE="$gmdatetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentstemplate" VALUE="$gmcommentstemplate">
<INPUT TYPE=HIDDEN NAME="newcommentsformtemplate" VALUE="$gmcommentsformtemplate">
<INPUT TYPE=HIDDEN NAME="newparaseparationtemplate" VALUE="$gmparaseparationtemplate">
<INPUT TYPE=HIDDEN NAME="newkarmaformtemplate" VALUE="$gmkarmaformtemplate">
<INPUT TYPE=HIDDEN NAME="newlinktargettemplate" VALUE="$gmlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfootertemplate" VALUE="$gmdategroupingfootertemplate">
<INPUT TYPE=HIDDEN NAME="newkarmalinktemplate" VALUE="$gmkarmalinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentslinktemplate" VALUE="$gmcommentslinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthoremailtemplate" VALUE="$gmcommentauthoremailtemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthorhomepagetemplate" VALUE="$gmcommentauthorhomepagetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentdividertemplate" VALUE="$gmcommentdividertemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrytemplate" VALUE="$gmmoreentrytemplate">
<INPUT TYPE=HIDDEN NAME="newpreviouslinktemplate" VALUE="$gmpreviouslinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextlinktemplate" VALUE="$gmnextlinktemplate">
<INPUT TYPE=HIDDEN NAME="newpreviousmorelinktemplate" VALUE="$gmpreviousmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextmorelinktemplate" VALUE="$gmnextmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newarchivemasterindextemplate" VALUE="$gmarchivemasterindextemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinktemplate" VALUE="$gmlogarchiveslinktemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinktemplate" VALUE="$gmentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagelinktemplate" VALUE="$gmmoreentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkseparatortemplate" VALUE="$gmlogarchiveslinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkseparatortemplate" VALUE="$gmentrypagelinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkmonthseparatortemplate" VALUE="$gmentrypagelinkmonthseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkdayseparatortemplate" VALUE="$gmentrypagelinkdayseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkyearseparatortemplate" VALUE="$gmentrypagelinkyearseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newheadertemplate" VALUE="$gmheadertemplate">
<INPUT TYPE=HIDDEN NAME="newfootertemplate" VALUE="$gmfootertemplate">
<INPUT TYPE=HIDDEN NAME="newsidebartemplate" VALUE="$gmsidebartemplate">
<INPUT TYPE=HIDDEN NAME="newentryseparatortemplate" VALUE="$gmentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentryseparatortemplate" VALUE="$gmarchiveentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrytemplate" VALUE="$gmmorearchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newdatearchivetemplate" VALUE="$gmdatearchivetemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkweeklytemplate" VALUE="$gmlogarchiveslinkweeklytemplate">
<INPUT TYPE=HIDDEN NAME="newcustomonetemplate" VALUE="$gmcustomonetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtwotemplate" VALUE="$gmcustomtwotemplate">
<INPUT TYPE=HIDDEN NAME="newcustomthreetemplate" VALUE="$gmcustomthreetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfourtemplate" VALUE="$gmcustomfourtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfivetemplate" VALUE="$gmcustomfivetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomsixtemplate" VALUE="$gmcustomsixtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomseventemplate" VALUE="$gmcustomseventemplate">
<INPUT TYPE=HIDDEN NAME="newcustomeighttemplate" VALUE="$gmcustomeighttemplate">
<INPUT TYPE=HIDDEN NAME="newcustomninetemplate" VALUE="$gmcustomninetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtentemplate" VALUE="$gmcustomtentemplate">
<INPUT TYPE=HIDDEN NAME="newpopuppagetemplate" VALUE="$gmpopuppagetemplate">
<INPUT TYPE=HIDDEN NAME="newpopupcodetemplate" VALUE="$gmpopupcodetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchformtemplate" VALUE="$gmsearchformtemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultspagetemplate" VALUE="$gmsearchresultspagetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultsentrytemplate" VALUE="$gmsearchresultsentrytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartablebeginningtemplate" VALUE="$gmcalendartablebeginningtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartableendingtemplate" VALUE="$gmcalendartableendingtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarblankcelltemplate" VALUE="$gmcalendarblankcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelltemplate" VALUE="$gmcalendarfullcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelllinktemplate" VALUE="$gmcalendarfullcelllinktemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaytemplate" VALUE="$gmcalendarweekfulldaytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaylinktemplate" VALUE="$gmcalendarweekfulldaylinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewdividertemplate" VALUE="$gmcommentpreviewdividertemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewformtemplate" VALUE="$gmcommentpreviewformtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinknocommentstemplate" VALUE="$gmsmartlinknocommentstemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkonecommenttemplate" VALUE="$gmsmartlinkonecommenttemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkmanycommentstemplate" VALUE="$gmsmartlinkmanycommentstemplate">
<INPUT TYPE=HIDDEN NAME="newlinebreaktemplate" VALUE="$gmlinebreaktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentlinktargettemplate" VALUE="$gmcommentlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymoodtemplate" VALUE="$gmsmartentrymoodtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymusictemplate" VALUE="$gmsmartentrymusictemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfooterarchivetemplate" VALUE="$gmdategroupingfooterarchivetemplate">
<INPUT TYPE=HIDDEN NAME="newcookiescodetemplate" VALUE="$gmcookiescodetemplate">
<INPUT TYPE=HIDDEN NAME="newsmartemoticonscodetemplate" VALUE="$gmsmartemoticonscodetemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorheadertemplate" VALUE="$gmusererrorheadertemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorfootertemplate" VALUE="$gmusererrorfootertemplate">

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Entry Page Template: Current Standard Entries</B><BR><FONT SIZE=1>This template controls how the individual pages for your current regular entries (non-archived entries without "more" text) will be formatted.  The {{entrymainbody}} and {{entrymorebody}} variables specify where the body of your standard and extended text (if any) will respectively appear.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newentrypagetemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmentrypagetemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Entry Page Template: Current Extended Entries</B><BR><FONT SIZE=1>Like the above, except this applies to current extended entries (non-archived entries *with* "more" text).</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newmoreentrypagetemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmmoreentrypagetemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="entrymorepagecheck" VALUE="yes"> Make this the same as the above template (current standard entries)</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Entry Page Template: Archived Standard Entries</B><BR><FONT SIZE=1>Like the above, except this applies to archived entries (entries too old to be listed on the main log) without "more" text.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newarchiveentrypagetemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmarchiveentrypagetemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="entryarchivepagecheck" VALUE="yes"> Make this the same as the top template (current standard entries)</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Entry Page Template: Archived Extended Entries</B><BR><FONT SIZE=1>Like the above, except this applies to archived entries (entries too old to be listed on the main log) *with* "more" text.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newmorearchiveentrypagetemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmmorearchiveentrypagetemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="entrymorearchivepagecheck" VALUE="yes"> Make this the same as the previous template (archived standard entries)</FONT></TD></TR>

</TABLE>
$autorebuildcheckbox
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Template Changes"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Templates Menu">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMEDITENTRYPAGETEMPLATES

$statusnote = Gm_Constants::EMPTY;

exit;

}

# -------------------------------------
# edit template group: karma & comments
# -------------------------------------

sub gm_editkarmacommentstemplates {

&gm_validate;

if (($gmtemplateaccess eq Gm_Constants::NO) || ($gmtemplateaccess eq "hfsonly")) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the karma & comments templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the karma & comments templates.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readtemplates;

&gm_delousealltemplates;

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Editing Karma & Comments-Related Templates</FONT></B><BR><FONT SIZE=1>These are the templates that affect all elements relating to karma voting and comment posting; if you have<BR>either or both of those disabled, you can ignore the templates relating to them.  All these templates<BR>affect things that will not appear on entries for which karma voting and/or comment posting is disabled.</FONT><P>); }

$autorebuildcheckbox = Gm_Constants::EMPTY;

if ($gmrebuildaccess eq Gm_Constants::YES) {
	if ($automaticrebuilddefault eq Gm_Constants::YES) {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="everything" CHECKED> Automatically rebuild all files after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	} else {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="everything"> Automatically rebuild all files after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	}
}

&gm_readcounter;
if ($newentrynumber eq "0") { $autorebuildcheckbox = Gm_Constants::EMPTY; }

print<<GMEDITKARMACOMMENTSTEMPLATES;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="modifiedtemplategroup" VALUE="karma & comments">
<INPUT TYPE=HIDDEN NAME="newindextemplate" VALUE="$gmindextemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagetemplate" VALUE="$gmentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveindextemplate" VALUE="$gmarchiveindextemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrypagetemplate" VALUE="$gmarchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newentrytemplate" VALUE="$gmentrytemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrytemplate" VALUE="$gmarchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newstayattoptemplate" VALUE="$gmstayattoptemplate">
<INPUT TYPE=HIDDEN NAME="newdatetemplate" VALUE="$gmdatetemplate">
<INPUT TYPE=HIDDEN NAME="newparaseparationtemplate" VALUE="$gmparaseparationtemplate">
<INPUT TYPE=HIDDEN NAME="newlinktargettemplate" VALUE="$gmlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfootertemplate" VALUE="$gmdategroupingfootertemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrytemplate" VALUE="$gmmoreentrytemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagetemplate" VALUE="$gmmoreentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrypagetemplate" VALUE="$gmmorearchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newpreviouslinktemplate" VALUE="$gmpreviouslinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextlinktemplate" VALUE="$gmnextlinktemplate">
<INPUT TYPE=HIDDEN NAME="newpreviousmorelinktemplate" VALUE="$gmpreviousmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextmorelinktemplate" VALUE="$gmnextmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newarchivemasterindextemplate" VALUE="$gmarchivemasterindextemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinktemplate" VALUE="$gmlogarchiveslinktemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinktemplate" VALUE="$gmentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagelinktemplate" VALUE="$gmmoreentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkseparatortemplate" VALUE="$gmlogarchiveslinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkseparatortemplate" VALUE="$gmentrypagelinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkmonthseparatortemplate" VALUE="$gmentrypagelinkmonthseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkdayseparatortemplate" VALUE="$gmentrypagelinkdayseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkyearseparatortemplate" VALUE="$gmentrypagelinkyearseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newheadertemplate" VALUE="$gmheadertemplate">
<INPUT TYPE=HIDDEN NAME="newfootertemplate" VALUE="$gmfootertemplate">
<INPUT TYPE=HIDDEN NAME="newsidebartemplate" VALUE="$gmsidebartemplate">
<INPUT TYPE=HIDDEN NAME="newentryseparatortemplate" VALUE="$gmentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentryseparatortemplate" VALUE="$gmarchiveentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrytemplate" VALUE="$gmmorearchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newdatearchivetemplate" VALUE="$gmdatearchivetemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkweeklytemplate" VALUE="$gmlogarchiveslinkweeklytemplate">
<INPUT TYPE=HIDDEN NAME="newcustomonetemplate" VALUE="$gmcustomonetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtwotemplate" VALUE="$gmcustomtwotemplate">
<INPUT TYPE=HIDDEN NAME="newcustomthreetemplate" VALUE="$gmcustomthreetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfourtemplate" VALUE="$gmcustomfourtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfivetemplate" VALUE="$gmcustomfivetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomsixtemplate" VALUE="$gmcustomsixtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomseventemplate" VALUE="$gmcustomseventemplate">
<INPUT TYPE=HIDDEN NAME="newcustomeighttemplate" VALUE="$gmcustomeighttemplate">
<INPUT TYPE=HIDDEN NAME="newcustomninetemplate" VALUE="$gmcustomninetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtentemplate" VALUE="$gmcustomtentemplate">
<INPUT TYPE=HIDDEN NAME="newpopuppagetemplate" VALUE="$gmpopuppagetemplate">
<INPUT TYPE=HIDDEN NAME="newpopupcodetemplate" VALUE="$gmpopupcodetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchformtemplate" VALUE="$gmsearchformtemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultspagetemplate" VALUE="$gmsearchresultspagetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultsentrytemplate" VALUE="$gmsearchresultsentrytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartablebeginningtemplate" VALUE="$gmcalendartablebeginningtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartableendingtemplate" VALUE="$gmcalendartableendingtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarblankcelltemplate" VALUE="$gmcalendarblankcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelltemplate" VALUE="$gmcalendarfullcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelllinktemplate" VALUE="$gmcalendarfullcelllinktemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaytemplate" VALUE="$gmcalendarweekfulldaytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaylinktemplate" VALUE="$gmcalendarweekfulldaylinktemplate">
<INPUT TYPE=HIDDEN NAME="newlinebreaktemplate" VALUE="$gmlinebreaktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentlinktargettemplate" VALUE="$gmcommentlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymoodtemplate" VALUE="$gmsmartentrymoodtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymusictemplate" VALUE="$gmsmartentrymusictemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfooterarchivetemplate" VALUE="$gmdategroupingfooterarchivetemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorheadertemplate" VALUE="$gmusererrorheadertemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorfootertemplate" VALUE="$gmusererrorfootertemplate">

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{karmalink}} and {{commentslink}} Templates</B><BR><FONT SIZE=1>These templates are what will appear wherever the {{karmalink}} and {{commentslink}} are used, but only when called for; the contents of {{commentslink}} will only appear on entries for which comments can be posted to, and the same with {{karmalink}}.  The default approach is to use {{karmalink}} to contain the links for voting on karma and {{commentslink}} for a link to your entry's comments, but you can use these templates to set anything that will appear, wherever you insert their respective variables, only for entries with karma or comments enabled respectively.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{karmalink}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{commentslink}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newkarmalinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmkarmalinktemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentslinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentslinktemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Comment Appearance Template</B><BR><FONT SIZE=1>Whenever comments are added to your entries, this is the template which the comments will be formatted by.<BR>&#160;<BR>&#160;</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{entrycommentsform}} Posting Form</B><BR><FONT SIZE=1>This is the form  by which visitors can add comments (appearing whereever {{entrycommentsform}} is used).  You can change the form's design, but the "NAME", "VALUE" and "ACTION" values must remain the same.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentstemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentstemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentsformtemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentsformtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{smartemoticonscode}} Template</B><BR><FONT SIZE=1>The {{smartemoticonscode}} template (whatever you set below) will only appear if you have allowed emoticons to be posted in comments in your config settings.<BR>&#160;</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{cookiescode}} Template</B><BR><FONT SIZE=1>The {{cookiescode}} template allows you to define a Javascript that allows setting cookies on your commenters--this supports remembering the details that commenters provide on your site.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsmartemoticonscodetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmsmartemoticonscodetemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcookiescodetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcookiescodetemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{commentdivider}} Template</B><BR><FONT SIZE=1>The {{commentdivider}} variable (whatever you set below) will only appear if at least one comment has been posted to that entry; for example, if you want to have something that says "This entry has received X comments" in an entry, but don't want that to appear if there haven't been any comments posted to it yet.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#C0C0C0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{karmaform}} Template</B><BR><FONT SIZE=1>Just like {{karmalink}} above, this will only appear on karma-enabled entries; this is intended to allow a handling of karma voting on individual entry pages distinct from the main log, if you wish to do that.<BR>&#160;<BR>&#160;</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentdividertemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentdividertemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newkarmaformtemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmkarmaformtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Comment Previewing Templates</B><BR><FONT SIZE=1>If you allow visitors to preview their comments before posting them (to enable this, add a &lt;INPUT TYPE=SUBMIT NAME="gmpostpreview" VALUE="Preview Your Comment"&gt; button [the "value" text can be changed to whatever you wish, as long as you keep the NAME="gmpostpreview" part] to your entry comments form, if it's not there already), these templates control what special information will appear (the comment is shown to the user as it would appear in your entry's page).  The Preview Divider is what will appear in the preview where {{commentdivider}} (see above) is, and the Confirmation Form takes the place of {{entrycommentsform}} above.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Preview Divider Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Confirmation Form Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentpreviewdividertemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentpreviewdividertemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentpreviewformtemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentpreviewformtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=3><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{commentstatussmart}} Templates</B><BR><FONT SIZE=1>If you wish, you can customise the text or other output that {{commentstatussmart}} generates when there are no comments, only one comment, or more than one comment, respectively.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=33%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Output for<BR>no comments</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=34%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Output for<BR>one comment</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=33%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Output for two<BR>or more comments</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsmartlinknocommentstemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmsmartlinknocommentstemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsmartlinkonecommenttemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmsmartlinkonecommenttemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsmartlinkmanycommentstemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmsmartlinkmanycommentstemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{commentauthoremail}} and {{commentauthorhomepage}} Templates</B><BR><FONT SIZE=1>When used in the Comment Appearance template, these varibles are what will appear whenever an e-mail or homepage address, respectively, has been given by that author of that comment; this is useful, for example, if you want to set up little icons or somesuch that will appear with someone's comment when they give their e-mail or homepage address.  The simplest approach, though, is to ignore these altogether and use {{commentauthorsmartlink}} instead.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{commentauthoremail}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{commentauthorhomepage}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentauthoremailtemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentauthoremailtemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentauthorhomepagetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmcommentauthorhomepagetemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

</TABLE>
$autorebuildcheckbox
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Template Changes"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Templates Menu">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMEDITKARMACOMMENTSTEMPLATES

$statusnote = Gm_Constants::EMPTY;

exit;

}

# ---------------------------------------------
# edit template group: header, footer & sidebar
# ---------------------------------------------

sub gm_editheaderfootertemplates {

&gm_validate;

if ($gmtemplateaccess eq Gm_Constants::NO) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the header, footer & sidebar templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the header, footer & sidebar templates.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readtemplates;

&gm_delousealltemplates;

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B><FONT COLOR="#000000">Editing Header, Footer & Sidebar (& Custom) Templates</FONT></B><BR><FONT SIZE=1>If you want to have something&#151;certain text, graphics, formatting, etc.&#151;that appears across all your pages, but you don't want to have to modify all the templates each time you change them, simply use the Header, Footer and Sidebar templates below, or any of the ten custom templates.  Their contents will be inserted wherever the respective variables appear in your templates.</FONT></TD></TR></TABLE><P>); }

$autorebuildcheckbox = Gm_Constants::EMPTY;

if ($gmrebuildaccess eq Gm_Constants::YES) {
	if ($automaticrebuilddefault eq Gm_Constants::YES) {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="everything" CHECKED> Automatically rebuild all files after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	} else {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="everything"> Automatically rebuild all files after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	}
}

&gm_readcounter;
if ($newentrynumber eq "0") { $autorebuildcheckbox = Gm_Constants::EMPTY; }

print<<GMEDITHEADERFOOTERTEMPLATES;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="modifiedtemplategroup" VALUE="header, footer & sidebar">
<INPUT TYPE=HIDDEN NAME="newindextemplate" VALUE="$gmindextemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagetemplate" VALUE="$gmentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveindextemplate" VALUE="$gmarchiveindextemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrypagetemplate" VALUE="$gmarchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newentrytemplate" VALUE="$gmentrytemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrytemplate" VALUE="$gmarchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newstayattoptemplate" VALUE="$gmstayattoptemplate">
<INPUT TYPE=HIDDEN NAME="newdatetemplate" VALUE="$gmdatetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentstemplate" VALUE="$gmcommentstemplate">
<INPUT TYPE=HIDDEN NAME="newcommentsformtemplate" VALUE="$gmcommentsformtemplate">
<INPUT TYPE=HIDDEN NAME="newparaseparationtemplate" VALUE="$gmparaseparationtemplate">
<INPUT TYPE=HIDDEN NAME="newkarmaformtemplate" VALUE="$gmkarmaformtemplate">
<INPUT TYPE=HIDDEN NAME="newlinktargettemplate" VALUE="$gmlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfootertemplate" VALUE="$gmdategroupingfootertemplate">
<INPUT TYPE=HIDDEN NAME="newkarmalinktemplate" VALUE="$gmkarmalinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentslinktemplate" VALUE="$gmcommentslinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthoremailtemplate" VALUE="$gmcommentauthoremailtemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthorhomepagetemplate" VALUE="$gmcommentauthorhomepagetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentdividertemplate" VALUE="$gmcommentdividertemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrytemplate" VALUE="$gmmoreentrytemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagetemplate" VALUE="$gmmoreentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrypagetemplate" VALUE="$gmmorearchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newpreviouslinktemplate" VALUE="$gmpreviouslinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextlinktemplate" VALUE="$gmnextlinktemplate">
<INPUT TYPE=HIDDEN NAME="newpreviousmorelinktemplate" VALUE="$gmpreviousmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newnextmorelinktemplate" VALUE="$gmnextmorelinktemplate">
<INPUT TYPE=HIDDEN NAME="newarchivemasterindextemplate" VALUE="$gmarchivemasterindextemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinktemplate" VALUE="$gmlogarchiveslinktemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinktemplate" VALUE="$gmentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagelinktemplate" VALUE="$gmmoreentrypagelinktemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkseparatortemplate" VALUE="$gmlogarchiveslinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkseparatortemplate" VALUE="$gmentrypagelinkseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkmonthseparatortemplate" VALUE="$gmentrypagelinkmonthseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkdayseparatortemplate" VALUE="$gmentrypagelinkdayseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagelinkyearseparatortemplate" VALUE="$gmentrypagelinkyearseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newentryseparatortemplate" VALUE="$gmentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentryseparatortemplate" VALUE="$gmarchiveentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrytemplate" VALUE="$gmmorearchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newdatearchivetemplate" VALUE="$gmdatearchivetemplate">
<INPUT TYPE=HIDDEN NAME="newlogarchiveslinkweeklytemplate" VALUE="$gmlogarchiveslinkweeklytemplate">
<INPUT TYPE=HIDDEN NAME="newpopuppagetemplate" VALUE="$gmpopuppagetemplate">
<INPUT TYPE=HIDDEN NAME="newpopupcodetemplate" VALUE="$gmpopupcodetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchformtemplate" VALUE="$gmsearchformtemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultspagetemplate" VALUE="$gmsearchresultspagetemplate">
<INPUT TYPE=HIDDEN NAME="newsearchresultsentrytemplate" VALUE="$gmsearchresultsentrytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartablebeginningtemplate" VALUE="$gmcalendartablebeginningtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendartableendingtemplate" VALUE="$gmcalendartableendingtemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarblankcelltemplate" VALUE="$gmcalendarblankcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelltemplate" VALUE="$gmcalendarfullcelltemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarfullcelllinktemplate" VALUE="$gmcalendarfullcelllinktemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaytemplate" VALUE="$gmcalendarweekfulldaytemplate">
<INPUT TYPE=HIDDEN NAME="newcalendarweekfulldaylinktemplate" VALUE="$gmcalendarweekfulldaylinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewdividertemplate" VALUE="$gmcommentpreviewdividertemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewformtemplate" VALUE="$gmcommentpreviewformtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinknocommentstemplate" VALUE="$gmsmartlinknocommentstemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkonecommenttemplate" VALUE="$gmsmartlinkonecommenttemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkmanycommentstemplate" VALUE="$gmsmartlinkmanycommentstemplate">
<INPUT TYPE=HIDDEN NAME="newlinebreaktemplate" VALUE="$gmlinebreaktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentlinktargettemplate" VALUE="$gmcommentlinktargettemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymoodtemplate" VALUE="$gmsmartentrymoodtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartentrymusictemplate" VALUE="$gmsmartentrymusictemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfooterarchivetemplate" VALUE="$gmdategroupingfooterarchivetemplate">
<INPUT TYPE=HIDDEN NAME="newcookiescodetemplate" VALUE="$gmcookiescodetemplate">
<INPUT TYPE=HIDDEN NAME="newsmartemoticonscodetemplate" VALUE="$gmsmartemoticonscodetemplate">


<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Header Template</B><BR><FONT SIZE=1>Whatever you put here will appear wherever {{header}} is used in your other templates.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newheadertemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmheadertemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Footer Template</B><BR><FONT SIZE=1>Whatever you put here will appear wherever {{footer}} is used in your other templates.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newfootertemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmfootertemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Sidebar Template</B><BR><FONT SIZE=1>Whatever you put here will appear wherever {{sidebar}} is used in your other templates.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT><TEXTAREA NAME="newsidebartemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">$gmsidebartemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2>
<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0">
  <TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Miscellaneous Custom Templates</B><BR>
    <FONT SIZE=1>Whatever you put in any of the templates below will appear wherever their 
    respective variables are used.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE>
    </TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>
    <TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD>
    <TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF">
    <TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{customone}} Template</B>
    </FONT></TD></TR></TABLE></TD></TR></TABLE></TD>
    <TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>
    <TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD>
    <TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF">
    <TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{customtwo}} Template</B></FONT>
    </TD></TR></TABLE></TD></TR></TABLE>
    </TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT>
      <TEXTAREA NAME="newcustomonetemplate" COLS=41 ROWS=20 WRAP=VIRTUAL 
      STYLE="width: 355">$gmcustomonetemplate</TEXTAREA>$gmfonttag</FONT></TD>
      <TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcustomtwotemplate" 
      COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">$gmcustomtwotemplate</TEXTAREA>
      $gmfonttag</FONT></FONT></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>
      <TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000">
      <TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF">
      <TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{customthree}} Template</B></FONT>
      </TD></TR></TABLE></TD></TR></TABLE></TD>
      <TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>
      <TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000">
      <TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF">
      <TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{customfour}} Template</B>
      </FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcustomthreetemplate" 
      COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">$gmcustomthreetemplate</TEXTAREA>
      $gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT>
      <TEXTAREA NAME="newcustomfourtemplate" COLS=41 ROWS=20 WRAP=VIRTUAL 
      STYLE="width: 355">$gmcustomfourtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 
      CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 
      CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>
      $gmfonttag<B>{{customfive}} Template</B></FONT></TD></TR></TABLE></TD></TR>
      </TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 
      CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 
      WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag
      <B>{{customsix}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcustomfivetemplate" 
      COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">$gmcustomfivetemplate</TEXTAREA>
      $gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA 
      NAME="newcustomsixtemplate" COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">
      $gmcustomsixtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>
      <TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD>
      <TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF">
      <TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{customseven}} Template</B>
      </FONT></TD></TR></TABLE></TD></TR></TABLE></TD>
      <TD VALIGN=TOP ALIGN=CENTER WIDTH=50%>
      <TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000">
      <TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF">
      <TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{customeight}} Template</B>
      </FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcustomseventemplate" 
      COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">$gmcustomseventemplate</TEXTAREA>
      $gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA 
      NAME="newcustomeighttemplate" COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">
      $gmcustomeighttemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR>
      <TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 
      CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 
      CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>
      $gmfonttag<B>{{customnine}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD>
      <TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 
      CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 
      CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>
      $gmfonttag<B>{{customten}} Template</B></FONT></TD></TR></TABLE></TD></TR>
      </TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA 
      NAME="newcustomninetemplate" COLS=41 ROWS=20 WRAP=VIRTUAL STYLE="width: 355">
      $gmcustomninetemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER>
      </FONT><TEXTAREA NAME="newcustomtentemplate" COLS=41 ROWS=20 WRAP=VIRTUAL 
      STYLE="width: 355">$gmcustomtentemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR>
      </TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag
<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>
$gmfonttag<B>User Error Header Template</B><BR><FONT SIZE=1>Whatever you put here will appear whenever an error
or alert is presented to the user (this will not change how the admin errors are displayed, just
errors such as not entering a Name on the comment form). <b>Note</b> that no template tags will
work withen this template (they will display as {{template}}).
</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT>
<TEXTAREA NAME="newgmusererrorheadertemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">
$gmusererrorheadertemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2>$gmfonttag
<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>
$gmfonttag<B>User Error Footer Template</B><BR><FONT SIZE=1>Whatever you put here will appear whenever an error
or alert is presented to the user (this will not change how the admin errors are displayed, just
errors such as not entering a Name on the comment form).  Close any tags opened by the 
Error Header Template. <b>Note</b> that no template tags will
work withen this template (they will display as {{template}}).
</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE><P></FONT>
<TEXTAREA NAME="newgmusererrorfootertemplate" COLS=86 ROWS=30 WRAP=VIRTUAL STYLE="width: 720">
$gmusererrorfootertemplate</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

</TABLE>
$autorebuildcheckbox
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Template Changes"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Templates Menu">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMEDITHEADERFOOTERTEMPLATES

$statusnote = Gm_Constants::EMPTY;

exit;

}

# ----------------------------------
# edit template group: miscellaneous
# ----------------------------------

sub gm_editmisctemplates {

&gm_validate;

if (($gmtemplateaccess eq Gm_Constants::NO) || ($gmtemplateaccess eq "hfsonly")) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the miscellaneous templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the miscellaneous templates.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readtemplates;

&gm_delousealltemplates;

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Editing Miscellaneous Templates</FONT></B><BR><FONT SIZE=1>All the templates affecting things that didn't fit into the other categories.</FONT><P>); }

$autorebuildcheckbox = Gm_Constants::EMPTY;

if ($gmrebuildaccess eq Gm_Constants::YES) {
	if ($automaticrebuilddefault eq Gm_Constants::YES) {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="everything" CHECKED> Automatically rebuild all files after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	} else {
		$autorebuildcheckbox = qq(<P>\n<INPUT TYPE=CHECKBOX NAME="autorebuild" VALUE="everything"> Automatically rebuild all files after saving\n<BR>\n<FONT SIZE=1>After clicking Save, expect a wait of up to several minutes if leaving this box checked.<BR>DO NOT interrupt Greymatter while it's rebuilding!</FONT>);
	}
}

&gm_readcounter;
if ($newentrynumber eq "0") { $autorebuildcheckbox = Gm_Constants::EMPTY; }

print<<GMEDITMISCTEMPLATES;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="modifiedtemplategroup" VALUE="miscellaneous">
<INPUT TYPE=HIDDEN NAME="newindextemplate" VALUE="$gmindextemplate">
<INPUT TYPE=HIDDEN NAME="newentrypagetemplate" VALUE="$gmentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveindextemplate" VALUE="$gmarchiveindextemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrypagetemplate" VALUE="$gmarchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newentrytemplate" VALUE="$gmentrytemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentrytemplate" VALUE="$gmarchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newstayattoptemplate" VALUE="$gmstayattoptemplate">
<INPUT TYPE=HIDDEN NAME="newdatetemplate" VALUE="$gmdatetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentstemplate" VALUE="$gmcommentstemplate">
<INPUT TYPE=HIDDEN NAME="newcommentsformtemplate" VALUE="$gmcommentsformtemplate">
<INPUT TYPE=HIDDEN NAME="newkarmaformtemplate" VALUE="$gmkarmaformtemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfootertemplate" VALUE="$gmdategroupingfootertemplate">
<INPUT TYPE=HIDDEN NAME="newkarmalinktemplate" VALUE="$gmkarmalinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentslinktemplate" VALUE="$gmcommentslinktemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthoremailtemplate" VALUE="$gmcommentauthoremailtemplate">
<INPUT TYPE=HIDDEN NAME="newcommentauthorhomepagetemplate" VALUE="$gmcommentauthorhomepagetemplate">
<INPUT TYPE=HIDDEN NAME="newcommentdividertemplate" VALUE="$gmcommentdividertemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrytemplate" VALUE="$gmmoreentrytemplate">
<INPUT TYPE=HIDDEN NAME="newmoreentrypagetemplate" VALUE="$gmmoreentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrypagetemplate" VALUE="$gmmorearchiveentrypagetemplate">
<INPUT TYPE=HIDDEN NAME="newarchivemasterindextemplate" VALUE="$gmarchivemasterindextemplate">
<INPUT TYPE=HIDDEN NAME="newheadertemplate" VALUE="$gmheadertemplate">
<INPUT TYPE=HIDDEN NAME="newfootertemplate" VALUE="$gmfootertemplate">
<INPUT TYPE=HIDDEN NAME="newsidebartemplate" VALUE="$gmsidebartemplate">
<INPUT TYPE=HIDDEN NAME="newentryseparatortemplate" VALUE="$gmentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newarchiveentryseparatortemplate" VALUE="$gmarchiveentryseparatortemplate">
<INPUT TYPE=HIDDEN NAME="newmorearchiveentrytemplate" VALUE="$gmmorearchiveentrytemplate">
<INPUT TYPE=HIDDEN NAME="newdatearchivetemplate" VALUE="$gmdatearchivetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomonetemplate" VALUE="$gmcustomonetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtwotemplate" VALUE="$gmcustomtwotemplate">
<INPUT TYPE=HIDDEN NAME="newcustomthreetemplate" VALUE="$gmcustomthreetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfourtemplate" VALUE="$gmcustomfourtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomfivetemplate" VALUE="$gmcustomfivetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomsixtemplate" VALUE="$gmcustomsixtemplate">
<INPUT TYPE=HIDDEN NAME="newcustomseventemplate" VALUE="$gmcustomseventemplate">
<INPUT TYPE=HIDDEN NAME="newcustomeighttemplate" VALUE="$gmcustomeighttemplate">
<INPUT TYPE=HIDDEN NAME="newcustomninetemplate" VALUE="$gmcustomninetemplate">
<INPUT TYPE=HIDDEN NAME="newcustomtentemplate" VALUE="$gmcustomtentemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewdividertemplate" VALUE="$gmcommentpreviewdividertemplate">
<INPUT TYPE=HIDDEN NAME="newcommentpreviewformtemplate" VALUE="$gmcommentpreviewformtemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinknocommentstemplate" VALUE="$gmsmartlinknocommentstemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkonecommenttemplate" VALUE="$gmsmartlinkonecommenttemplate">
<INPUT TYPE=HIDDEN NAME="newsmartlinkmanycommentstemplate" VALUE="$gmsmartlinkmanycommentstemplate">
<INPUT TYPE=HIDDEN NAME="newdategroupingfooterarchivetemplate" VALUE="$gmdategroupingfooterarchivetemplate">
<INPUT TYPE=HIDDEN NAME="newcookiescodetemplate" VALUE="$gmcookiescodetemplate">
<INPUT TYPE=HIDDEN NAME="newsmartemoticonscodetemplate" VALUE="$gmsmartemoticonscodetemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorheadertemplate" VALUE="$gmusererrorheadertemplate">
<INPUT TYPE=HIDDEN NAME="newgmusererrorfootertemplate" VALUE="$gmusererrorfootertemplate">

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=720>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{previouslink}} And {{nextlink}} Templates</B><BR><FONT SIZE=1>If there is a previous or next entry (ignoring closed entries, of course) preceding or following the given entry, these will appear; these variables are intended for use in the entry page templates, for including links to the previous or next entry (if applicable).  {{previousmorelink}} and {{nextmorelink}} work the same way, except that they link only to the previous or next extended entry (entries with "more" text).</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{previouslink}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{nextlink}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newpreviouslinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmpreviouslinktemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newnextlinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmnextlinktemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{previousmorelink}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{nextmorelink}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newpreviousmorelinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmpreviousmorelinktemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="previousmorelinkcheck" VALUE="yes"> Make this the same as the {{previouslink}} template</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newnextmorelinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmnextmorelinktemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="nextmorelinkcheck" VALUE="yes"> Make this the same as the {{nextlink}} template</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>List Variable Templates</B><BR><FONT SIZE=1>The variables {{logarchivelist}} and {{logentrylist}} (and the variants thereof; check the <a href="http://greymatterforum.proboards82.com/" title="read the manual" target="_blank">manual</a> for more information) are used for automatically generating lists of links&#151;whether on your archive master index, or anywhere else&#151;to your log archives and your individual entry pages; these templates set the formatting of those links.  The first two templates apply to the {{logentrylist}} variable and its variants, formatting the links to standard and extended entries respectively; the Log Archive Links Templates apply to the {{logarchivelist}} variable, which generates links to the monthly/weekly log archive files (whichever of the two is used depends on whether you have weekly or monthly archiving enabled).</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Log Archives Link Template: Weekly</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Log Archives Link Template: Monthly</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newlogarchiveslinkweeklytemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmlogarchiveslinkweeklytemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newlogarchiveslinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmlogarchiveslinktemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry List Link Template: Standard</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry List Link Template: Extended</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentrypagelinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmentrypagelinktemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newmoreentrypagelinktemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmmoreentrypagelinktemplate</TEXTAREA>$gmfonttag</FONT><BR>$gmfonttag<FONT SIZE=1><INPUT TYPE=CHECKBOX NAME="moreentrylistlinkcheck" VALUE="yes"> Make this the same as the template on the left</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>List Variable Templates: Link Separators</B><BR><FONT SIZE=1>Going along with the list variable templates above, these specify how the links are to be separated when the lists are built for their respective variables.  Use the day, month, and year separators for entry lists if you wish to separate the listings for each individual day, month, or year; leave them blank to keep the entry lists continuous.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry List Link Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Log Archives Link Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentrypagelinkseparatortemplate" COLS=41 ROWS=5 WRAP=VIRTUAL STYLE="width: 355">$gmentrypagelinkseparatortemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newlogarchiveslinkseparatortemplate" COLS=41 ROWS=5 WRAP=VIRTUAL STYLE="width: 355">$gmlogarchiveslinkseparatortemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=33%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry List:<BR>Day Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=34%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry List:<BR>Month Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=33%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Entry List:<BR>Year Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentrypagelinkdayseparatortemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmentrypagelinkdayseparatortemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentrypagelinkmonthseparatortemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmentrypagelinkmonthseparatortemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newentrypagelinkyearseparatortemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmentrypagelinkyearseparatortemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Search Templates</B><BR><FONT SIZE=1>These templates control the built-in ability for visitors to search through your site entries (just add {{searchform}} to a template to insert the search form there).  The Search Form template is the form by which visitors can perform the search; the Search Item Results template formats the appearance of each item returned by the search result; and finally, the Search Results Page template is for the full page that your visitors will see displaying all the search results.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Search Form Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Search Item Results Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsearchformtemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmsearchformtemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsearchresultsentrytemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmsearchresultsentrytemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD COLSPAN=2><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Search Results Page Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER COLSPAN=2></FONT><TEXTAREA NAME="newsearchresultspagetemplate" COLS=86 ROWS=15 WRAP=VIRTUAL STYLE="width: 720">$gmsearchresultspagetemplate</TEXTAREA>$gmfonttag</FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Calendar Templates</B><BR><FONT SIZE=1>These control the layout and appearance of monthly or weekly calendars made with the 	{{calendar}} or {{calendarweek}} variables respectively.  The first five are for monthly calendars (with 	{{calendar}}); you can specify the formatting of the beginning and end of the table, and how each kind of cell (cells without a day, cells with an unlinked day, and cells with a linked day) will appear.  The last two are for weekly calendars ({{calendarweek}}) and their linked or unlinked days.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendar}}: Beginning of table</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendar}}: Ending of table</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendartablebeginningtemplate" COLS=41 ROWS=5 WRAP=VIRTUAL STYLE="width: 355">$gmcalendartablebeginningtemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendartableendingtemplate" COLS=41 ROWS=5 WRAP=VIRTUAL STYLE="width: 355">$gmcalendartableendingtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=33%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendar}}:<BR>Blank cell</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=34%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendar}}:<BR>Day cell without link</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=33%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=229 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendar}}:<BR>Day cell with link</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendarblankcelltemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmcalendarblankcelltemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendarfullcelltemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmcalendarfullcelltemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendarfullcelllinktemplate" COLS=26 ROWS=5 WRAP=VIRTUAL STYLE="width: 233">$gmcalendarfullcelllinktemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendarweek}}: Day without link</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{calendarweek}}: Day with link</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendarweekfulldaytemplate" COLS=41 ROWS=5 WRAP=VIRTUAL STYLE="width: 355">$gmcalendarweekfulldaytemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcalendarweekfulldaylinktemplate" COLS=41 ROWS=5 WRAP=VIRTUAL STYLE="width: 355">$gmcalendarweekfulldaylinktemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{popup}} Templates</B><BR><FONT SIZE=1>These templates control the code associated with the {{popup}} variable for making popup windows; the Popup Code template is for the code that calls the window, and the Popup Window template is for the HTML file to be generated for the window.  (The popup-related variables&#151;{{popuptitle}} etc.&#151;will only work in these two templates.)</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Popup Code Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Popup Window Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newpopupcodetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmpopupcodetemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newpopuppagetemplate" COLS=41 ROWS=10 WRAP=VIRTUAL STYLE="width: 355">$gmpopuppagetemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>Line & Paragraph Separators</B><BR><FONT SIZE=1>The line separator is whatever will be inserted whenever there's a line break in the body of an entry's text; the paragraph separator is used for a double-line break (a paragraph break).  These apply both to entries and to comments.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Line Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Paragraph Separator</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newlinebreaktemplate" COLS=41 ROWS=3 WRAP=VIRTUAL STYLE="width: 355">$gmlinebreaktemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newparaseparationtemplate" COLS=41 ROWS=3 WRAP=VIRTUAL STYLE="width: 355">$gmparaseparationtemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER COLSPAN=2> &#160; </TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{smartentrymood}} and {{smartentrymusic}} templates</B><BR><FONT SIZE=1>These templates allow you to define your own labels for the entry mood and entry music fields. If you leave music or mood field blank for an entry, this label will not be displayed.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{smartentrymood}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>{{smartentrymusic}} Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsmartentrymoodtemplate" COLS=41 ROWS=3 WRAP=VIRTUAL STYLE="width: 355">$gmsmartentrymoodtemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newsmartentrymusictemplate" COLS=41 ROWS=3 WRAP=VIRTUAL STYLE="width: 355">$gmsmartentrymusictemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

<TR><TD VALIGN=BOTTOM ALIGN=CENTER COLSPAN=2><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=10 WIDTH=100%><TR><TD COLSPAN=2><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#C0C0C0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B>{{authorsmartlink}} target and {{commentauthorsmartlink}} target</B><BR><FONT SIZE=1>if you'd like commenter's homepages to open in a new window, you can set a target="_blank" in these templates, or you can use these to target those links into one of your other named frames.</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Author Smartlink Target Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD><TD VALIGN=TOP ALIGN=CENTER WIDTH=50%><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=351 BGCOLOR="#E0F0FF"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<B>Comment Smartlink Target Template</B></FONT></TD></TR></TABLE></TD></TR></TABLE></TD></TR><TR><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newlinktargettemplate" COLS=41 ROWS=3 WRAP=VIRTUAL STYLE="width: 355">$gmlinktargettemplate</TEXTAREA>$gmfonttag</FONT></TD><TD VALIGN=TOP ALIGN=CENTER></FONT><TEXTAREA NAME="newcommentlinktargettemplate" COLS=41 ROWS=3 WRAP=VIRTUAL STYLE="width: 355">$gmcommentlinktargettemplate</TEXTAREA>$gmfonttag</FONT></FONT></TD></TR></TABLE></TD></TR>

</TABLE>
$autorebuildcheckbox
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Template Changes"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Templates Menu">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMEDITMISCTEMPLATES

$statusnote = Gm_Constants::EMPTY;

exit;

}

# -------------------------
# save the template changes
# -------------------------

sub gm_savetemplatechanges {
&gm_validate;

if ($gmtemplateaccess eq Gm_Constants::NO) {
	gm_writetocplog("$IN{'authorname'} attempted to edit the templates without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to edit the templates.</FONT></B><P>);
	&gm_frontpage;
}

### TODO MAKE THE PARAM NAME SAME AS REAL TEMPLATE NAME, SO WE CAN LOOP THROUGH 
## HASH AND RELOUSE AND SET TEMPLATES
$IN{'newindextemplate'} = Gm_Utils::toStoreSafe($IN{'newindextemplate'});
$IN{'newentrypagetemplate'} = Gm_Utils::toStoreSafe($IN{'newentrypagetemplate'});
$IN{'newarchiveindextemplate'} = Gm_Utils::toStoreSafe($IN{'newarchiveindextemplate'});
$IN{'newarchiveentrypagetemplate'} = Gm_Utils::toStoreSafe($IN{'newarchiveentrypagetemplate'});
$IN{'newentrytemplate'} = Gm_Utils::toStoreSafe($IN{'newentrytemplate'});
$IN{'newarchiveentrytemplate'} = Gm_Utils::toStoreSafe($IN{'newarchiveentrytemplate'});
$IN{'newstayattoptemplate'} = Gm_Utils::toStoreSafe($IN{'newstayattoptemplate'});
$IN{'newdatetemplate'} = Gm_Utils::toStoreSafe($IN{'newdatetemplate'});
$IN{'newcommentstemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentstemplate'});
$IN{'newcommentsformtemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentsformtemplate'});
$IN{'newparaseparationtemplate'} = Gm_Utils::toStoreSafe($IN{'newparaseparationtemplate'});
$IN{'newkarmaformtemplate'} = Gm_Utils::toStoreSafe($IN{'newkarmaformtemplate'});
$IN{'newlinktargettemplate'} = Gm_Utils::toStoreSafe($IN{'newlinktargettemplate'});
$IN{'newdategroupingfootertemplate'} = Gm_Utils::toStoreSafe($IN{'newdategroupingfootertemplate'});
$IN{'newkarmalinktemplate'} = Gm_Utils::toStoreSafe($IN{'newkarmalinktemplate'});
$IN{'newcommentslinktemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentslinktemplate'});
$IN{'newcommentauthoremailtemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentauthoremailtemplate'});
$IN{'newcommentauthorhomepagetemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentauthorhomepagetemplate'});
$IN{'newcommentdividertemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentdividertemplate'});
$IN{'newmoreentrytemplate'} = Gm_Utils::toStoreSafe($IN{'newmoreentrytemplate'});
$IN{'newmoreentrypagetemplate'} = Gm_Utils::toStoreSafe($IN{'newmoreentrypagetemplate'});
$IN{'newmorearchiveentrypagetemplate'} = Gm_Utils::toStoreSafe($IN{'newmorearchiveentrypagetemplate'});
$IN{'newpreviouslinktemplate'} = Gm_Utils::toStoreSafe($IN{'newpreviouslinktemplate'});
$IN{'newnextlinktemplate'} = Gm_Utils::toStoreSafe($IN{'newnextlinktemplate'});
$IN{'newpreviousmorelinktemplate'} = Gm_Utils::toStoreSafe($IN{'newpreviousmorelinktemplate'});
$IN{'newnextmorelinktemplate'} = Gm_Utils::toStoreSafe($IN{'newnextmorelinktemplate'});
$IN{'newarchivemasterindextemplate'} = Gm_Utils::toStoreSafe($IN{'newarchivemasterindextemplate'});
$IN{'newlogarchiveslinktemplate'} = Gm_Utils::toStoreSafe($IN{'newlogarchiveslinktemplate'});
$IN{'newentrypagelinktemplate'} = Gm_Utils::toStoreSafe($IN{'newentrypagelinktemplate'});
$IN{'newmoreentrypagelinktemplate'} = Gm_Utils::toStoreSafe($IN{'newmoreentrypagelinktemplate'});
$IN{'newlogarchiveslinkseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newlogarchiveslinkseparatortemplate'});
$IN{'newentrypagelinkseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newentrypagelinkseparatortemplate'});
$IN{'newentrypagelinkmonthseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newentrypagelinkmonthseparatortemplate'});
$IN{'newentrypagelinkdayseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newentrypagelinkdayseparatortemplate'});
$IN{'newentrypagelinkyearseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newentrypagelinkyearseparatortemplate'});
$IN{'newheadertemplate'} = Gm_Utils::toStoreSafe($IN{'newheadertemplate'});
$IN{'newfootertemplate'} = Gm_Utils::toStoreSafe($IN{'newfootertemplate'});
$IN{'newsidebartemplate'} = Gm_Utils::toStoreSafe($IN{'newsidebartemplate'});
$IN{'newcustomlinktemplate'} = Gm_Constants::EMPTY;
$IN{'newentryseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newentryseparatortemplate'});
$IN{'newarchiveentryseparatortemplate'} = Gm_Utils::toStoreSafe($IN{'newarchiveentryseparatortemplate'});
$IN{'newmorearchiveentrytemplate'} = Gm_Utils::toStoreSafe($IN{'newmorearchiveentrytemplate'});
$IN{'newdatearchivetemplate'} = Gm_Utils::toStoreSafe($IN{'newdatearchivetemplate'});

$IN{'newlogarchiveslinkweeklytemplate'} = Gm_Utils::toStoreSafe($IN{'newlogarchiveslinkweeklytemplate'});
$IN{'newcustomonetemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomonetemplate'});
$IN{'newcustomtwotemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomtwotemplate'});
$IN{'newcustomthreetemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomthreetemplate'});
$IN{'newcustomfourtemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomfourtemplate'});
$IN{'newcustomfivetemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomfivetemplate'});
$IN{'newcustomsixtemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomsixtemplate'});
$IN{'newcustomseventemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomseventemplate'});
$IN{'newcustomeighttemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomeighttemplate'});
$IN{'newcustomninetemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomninetemplate'});
$IN{'newcustomtentemplate'} = Gm_Utils::toStoreSafe($IN{'newcustomtentemplate'});
$IN{'newpopuppagetemplate'} = Gm_Utils::toStoreSafe($IN{'newpopuppagetemplate'});
$IN{'newpopupcodetemplate'} = Gm_Utils::toStoreSafe($IN{'newpopupcodetemplate'});
$IN{'newsearchformtemplate'} = Gm_Utils::toStoreSafe($IN{'newsearchformtemplate'});
$IN{'newsearchresultspagetemplate'} = Gm_Utils::toStoreSafe($IN{'newsearchresultspagetemplate'});
$IN{'newsearchresultsentrytemplate'} = Gm_Utils::toStoreSafe($IN{'newsearchresultsentrytemplate'});
$IN{'newcalendartablebeginningtemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendartablebeginningtemplate'});
$IN{'newcalendartableendingtemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendartableendingtemplate'});
$IN{'newcalendarblankcelltemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendarblankcelltemplate'});
$IN{'newcalendarfullcelltemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendarfullcelltemplate'});
$IN{'newcalendarfullcelllinktemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendarfullcelllinktemplate'});
$IN{'newcalendarweekblankdaytemplate'} = Gm_Constants::EMPTY;
$IN{'newcalendarweekfulldaytemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendarweekfulldaytemplate'});
$IN{'newcalendarweekfulldaylinktemplate'} = Gm_Utils::toStoreSafe($IN{'newcalendarweekfulldaylinktemplate'});
$IN{'newcommentpreviewdividertemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentpreviewdividertemplate'});
$IN{'newcommentpreviewformtemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentpreviewformtemplate'});
$IN{'newsmartlinknocommentstemplate'} = Gm_Utils::toStoreSafe($IN{'newsmartlinknocommentstemplate'});
$IN{'newsmartlinkonecommenttemplate'} = Gm_Utils::toStoreSafe($IN{'newsmartlinkonecommenttemplate'});
$IN{'newsmartlinkmanycommentstemplate'} = Gm_Utils::toStoreSafe($IN{'newsmartlinkmanycommentstemplate'});
$IN{'newlinebreaktemplate'} = Gm_Utils::toStoreSafe($IN{'newlinebreaktemplate'});
$IN{'newcommentlinktargettemplate'} = Gm_Utils::toStoreSafe($IN{'newcommentlinktargettemplate'});
$IN{'newsmartentrymoodtemplate'} = Gm_Utils::toStoreSafe($IN{'newsmartentrymoodtemplate'});
$IN{'newsmartentrymusictemplate'} = Gm_Utils::toStoreSafe($IN{'newsmartentrymusictemplate'});
$IN{'newdategroupingfooterarchivetemplate'} = Gm_Utils::toStoreSafe($IN{'newdategroupingfooterarchivetemplate'});
$IN{'newcookiescodetemplate'} = Gm_Utils::toStoreSafe($IN{'newcookiescodetemplate'});
$IN{'newsmartemoticonscodetemplate'} = Gm_Utils::toStoreSafe($IN{'newsmartemoticonscodetemplate'});

$IN{'newgmusererrorheadertemplate'} = Gm_Utils::toStoreSafe($IN{'newgmusererrorheadertemplate'});
$IN{'newgmusererrorfootertemplate'} = Gm_Utils::toStoreSafe($IN{'newgmusererrorfootertemplate'});

if (($IN{'newcustomlinktemplate'} ne Gm_Constants::EMPTY) && ((substr($IN{'newcustomlinktemplate'}, 0, 1)) ne " ")) {
	$IN{'newcustomlinktemplate'} = " $IN{'newcustomlinktemplate'}";
}

if ($IN{'entrylistingmorecheck'} eq Gm_Constants::YES) { $IN{'newmoreentrytemplate'} = $IN{'newentrytemplate'}; }
if ($IN{'entrylistingstayattopcheck'} eq Gm_Constants::YES) { $IN{'newstayattoptemplate'} = $IN{'newentrytemplate'}; }
if ($IN{'archivelogindexcheck'} eq Gm_Constants::YES) { $IN{'newarchiveindextemplate'} = $IN{'newindextemplate'}; }
if ($IN{'archiveentrylistingcheck'} eq Gm_Constants::YES) { $IN{'newarchiveentrytemplate'} = $IN{'newentrytemplate'}; }
if ($IN{'archiveentrylistingmorecheck'} eq Gm_Constants::YES) { $IN{'newmorearchiveentrytemplate'} = $IN{'newmoreentrytemplate'}; }
if ($IN{'archivedateheadercheck'} eq Gm_Constants::YES) { $IN{'newdatearchivetemplate'} = $IN{'newdatetemplate'}; }
if ($IN{'archivedatefootercheck'} eq Gm_Constants::YES) { $IN{'newdategroupingfooterarchivetemplate'} = $IN{'newdategroupingfootertemplate'}; }
if ($IN{'archiveentryseparatorcheck'} eq Gm_Constants::YES) { $IN{'newarchiveentryseparatortemplate'} = $IN{'newentryseparatortemplate'}; }
if ($IN{'entrymorepagecheck'} eq Gm_Constants::YES) { $IN{'newmoreentrypagetemplate'} = $IN{'newentrypagetemplate'}; }
if ($IN{'entryarchivepagecheck'} eq Gm_Constants::YES) { $IN{'newarchiveentrypagetemplate'} = $IN{'newentrypagetemplate'}; }
if ($IN{'entrymorearchivepagecheck'} eq Gm_Constants::YES) { $IN{'newmorearchiveentrypagetemplate'} = $IN{'newarchiveentrypagetemplate'}; }
if ($IN{'previousmorelinkcheck'} eq Gm_Constants::YES) { $IN{'newpreviousmorelinktemplate'} = $IN{'newpreviouslinktemplate'}; }
if ($IN{'nextmorelinkcheck'} eq Gm_Constants::YES) { $IN{'newnextmorelinktemplate'} = $IN{'newnextlinktemplate'}; }
if ($IN{'moreentrylistlinkcheck'} eq Gm_Constants::YES) { $IN{'newmoreentrypagelinktemplate'} = $IN{'newentrypagelinktemplate'}; }


## Putting into hash to save
my %templs = ();
$templs{'gmindextemplate'} = $IN{'newindextemplate'};
$templs{'gmentrypagetemplate'} = $IN{'newentrypagetemplate'};
$templs{'gmarchiveindextemplate'} = $IN{'newarchiveindextemplate'};
$templs{'gmarchiveentrypagetemplate'} = $IN{'newarchiveentrypagetemplate'};
$templs{'gmentrytemplate'} = $IN{'newentrytemplate'};
$templs{'gmarchiveentrytemplate'} = $IN{'newarchiveentrytemplate'};
$templs{'gmstayattoptemplate'} = $IN{'newstayattoptemplate'};
$templs{'gmdatetemplate'} = $IN{'newdatetemplate'};
$templs{'gmcommentstemplate'} = $IN{'newcommentstemplate'};
$templs{'gmcommentsformtemplate'} = $IN{'newcommentsformtemplate'};
$templs{'gmparaseparationtemplate'} = $IN{'newparaseparationtemplate'};
$templs{'gmkarmaformtemplate'} = $IN{'newkarmaformtemplate'};
$templs{'gmlinktargettemplate'} = $IN{'newlinktargettemplate'};
$templs{'gmdategroupingfootertemplate'} = $IN{'newdategroupingfootertemplate'};
$templs{'gmkarmalinktemplate'} = $IN{'newkarmalinktemplate'};
$templs{'gmcommentslinktemplate'} = $IN{'newcommentslinktemplate'};
$templs{'gmcommentauthoremailtemplate'} = $IN{'newcommentauthoremailtemplate'};
$templs{'gmcommentauthorhomepagetemplate'} = $IN{'newcommentauthorhomepagetemplate'};
$templs{'gmcommentdividertemplate'} = $IN{'newcommentdividertemplate'};
$templs{'gmmoreentrytemplate'} = $IN{'newmoreentrytemplate'};
$templs{'gmmoreentrypagetemplate'} = $IN{'newmoreentrypagetemplate'};
$templs{'gmmorearchiveentrypagetemplate'} = $IN{'newmorearchiveentrypagetemplate'};
$templs{'gmpreviouslinktemplate'} = $IN{'newpreviouslinktemplate'};
$templs{'gmnextlinktemplate'} = $IN{'newnextlinktemplate'};
$templs{'gmpreviousmorelinktemplate'} = $IN{'newpreviousmorelinktemplate'};
$templs{'gmnextmorelinktemplate'} = $IN{'newnextmorelinktemplate'};
$templs{'gmarchivemasterindextemplate'} = $IN{'newarchivemasterindextemplate'};
$templs{'gmlogarchiveslinktemplate'} = $IN{'newlogarchiveslinktemplate'};
$templs{'gmentrypagelinktemplate'} = $IN{'newentrypagelinktemplate'};
$templs{'gmmoreentrypagelinktemplate'} = $IN{'newmoreentrypagelinktemplate'};
$templs{'gmlogarchiveslinkseparatortemplate'} = $IN{'newlogarchiveslinkseparatortemplate'};
$templs{'gmentrypagelinkseparatortemplate'} = $IN{'newentrypagelinkseparatortemplate'};
$templs{'gmentrypagelinkmonthseparatortemplate'} = $IN{'newentrypagelinkmonthseparatortemplate'};
$templs{'gmentrypagelinkdayseparatortemplate'} = $IN{'newentrypagelinkdayseparatortemplate'};
$templs{'gmentrypagelinkyearseparatortemplate'} = $IN{'newentrypagelinkyearseparatortemplate'};
$templs{'gmheadertemplate'} = $IN{'newheadertemplate'};
$templs{'gmfootertemplate'} = $IN{'newfootertemplate'};
$templs{'gmsidebartemplate'} = $IN{'newsidebartemplate'};
$templs{'gmentryseparatortemplate'} = $IN{'newentryseparatortemplate'};
$templs{'gmarchiveentryseparatortemplate'} = $IN{'newarchiveentryseparatortemplate'};
$templs{'gmmorearchiveentrytemplate'} = $IN{'newmorearchiveentrytemplate'};
$templs{'gmdatearchivetemplate'} = $IN{'newdatearchivetemplate'};
$templs{'gmlogarchiveslinkweeklytemplate'} = $IN{'newlogarchiveslinkweeklytemplate'};
$templs{'gmcustomonetemplate'} = $IN{'newcustomonetemplate'};
$templs{'gmcustomtwotemplate'} = $IN{'newcustomtwotemplate'};
$templs{'gmcustomthreetemplate'} = $IN{'newcustomthreetemplate'};
$templs{'gmcustomfourtemplate'} = $IN{'newcustomfourtemplate'};
$templs{'gmcustomfivetemplate'} = $IN{'newcustomfivetemplate'};
$templs{'gmcustomsixtemplate'} = $IN{'newcustomsixtemplate'};
$templs{'gmcustomseventemplate'} = $IN{'newcustomseventemplate'};
$templs{'gmcustomeighttemplate'} = $IN{'newcustomeighttemplate'};
$templs{'gmcustomninetemplate'} = $IN{'newcustomninetemplate'};
$templs{'gmcustomtentemplate'} = $IN{'newcustomtentemplate'};
$templs{'gmpopuppagetemplate'} = $IN{'newpopuppagetemplate'};
$templs{'gmpopupcodetemplate'} = $IN{'newpopupcodetemplate'};
$templs{'gmsearchformtemplate'} = $IN{'newsearchformtemplate'};
$templs{'gmsearchresultspagetemplate'} = $IN{'newsearchresultspagetemplate'};
$templs{'gmsearchresultsentrytemplate'} = $IN{'newsearchresultsentrytemplate'};
$templs{'gmcalendartablebeginningtemplate'} = $IN{'newcalendartablebeginningtemplate'};
$templs{'gmcalendartableendingtemplate'} = $IN{'newcalendartableendingtemplate'};
$templs{'gmcalendarblankcelltemplate'} = $IN{'newcalendarblankcelltemplate'};
$templs{'gmcalendarfullcelltemplate'} = $IN{'newcalendarfullcelltemplate'};
$templs{'gmcalendarfullcelllinktemplate'} = $IN{'newcalendarfullcelllinktemplate'};
$templs{'gmcalendarweekfulldaytemplate'} = $IN{'newcalendarweekfulldaytemplate'};
$templs{'gmcalendarweekfulldaylinktemplate'} = $IN{'newcalendarweekfulldaylinktemplate'};
$templs{'gmcommentpreviewdividertemplate'} = $IN{'newcommentpreviewdividertemplate'};
$templs{'gmcommentpreviewformtemplate'} = $IN{'newcommentpreviewformtemplate'};
$templs{'gmsmartlinknocommentstemplate'} = $IN{'newsmartlinknocommentstemplate'};
$templs{'gmsmartlinkonecommenttemplate'} = $IN{'newsmartlinkonecommenttemplate'};
$templs{'gmsmartlinkmanycommentstemplate'} = $IN{'newsmartlinkmanycommentstemplate'};
$templs{'gmlinebreaktemplate'} = $IN{'newlinebreaktemplate'};
$templs{'gmcommentlinktargettemplate'} = $IN{'newcommentlinktargettemplate'};
$templs{'gmsmartentrymoodtemplate'} = $IN{'newsmartentrymoodtemplate'};
$templs{'gmsmartentrymusictemplate'} = $IN{'newsmartentrymusictemplate'};
$templs{'gmdategroupingfooterarchivetemplate'} = $IN{'newdategroupingfooterarchivetemplate'};
$templs{'gmsmartemoticonscodetemplate'} = $IN{'newsmartemoticonscodetemplate'};
$templs{'gmcookiescodetemplate'} = $IN{'newcookiescodetemplate'};
$templs{'gmusererrorheadertemplate'} = $IN{'newgmusererrorheadertemplate'};
$templs{'gmusererrorfootertemplate'} = $IN{'newgmusererrorfootertemplate'};
Gm_Storage::setTemplates( templates =>\%templs, errHandler=>\&Gm_Web::displayAdminErrorExit );


$statusnote = qq(<B><FONT COLOR="#0000FF">The $IN{'modifiedtemplategroup'} templates have been modified.  Be sure to rebuild<BR>your files to make these changes take effect throughout your site.</FONT></B><P>);

gm_writetocplog("$IN{'authorname'} modified the $IN{'modifiedtemplategroup'} templates");

if ($IN{'autorebuild'} eq "index") { &gm_rebuildmainindexfile; }
if ($IN{'autorebuild'} eq "archiveindexes") { &gm_rebuildarchivelogindexes; }
if ($IN{'autorebuild'} eq "entrypages") { &gm_rebuildallentrypages; }
if ($IN{'autorebuild'} eq "everything") { &gm_rebuildeverything; }

&gm_edittemplates;

}

# --------------
# authors editor
# --------------
# DEPRECATED by viewAuthorList in gm.cgi
sub gm_editauthors {
	die( "gm_editauthors has been DEPRECATED");
}

# -------------------
# create a new author
# -------------------
# DEPRECATED by addAuthors in gm.cgi
sub gm_createnewauthor {
	die( "gm_createnewauthor has been DEPRECATED");
}

# ----------------
# delete an author
# ----------------
## depecated by deleteAuthor in gm.cgi
sub gm_deleteselectedauthor {
	die( "gm_deleteselectedauthor has been DEPRECATED");
}

# -----------------
# editing an author
# -----------------
# deprecated by gm.cgi: viewAuthor
sub gm_editselectedauthor {
	die( "gm_editselectedauthor has been DEPRECATED");
}

# -------------------------
# save changes to an author
# -------------------------
## DEPRECATED BY updateAuthor in gm.cgi
sub gm_saveauthorchanges {
	die( "gm_saveauthorchanges has been DEPRECATED");
}

# ------------------
# configuration menu
# ------------------
# html used for noting with something is update: "<B><FONT COLOR="#00FF00">Updated</FONT></B> "
sub gm_configuration {

&gm_validate;

if ($gmconfigurationaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to configure this program without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to configure this program.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;

my ($basedate, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
	Gm_Utils::getStdDate( $serveroffset );
my $montwo = Gm_Utils::toTwoDigit( $mon );
my $mdaytwo = Gm_Utils::toTwoDigit( $mday );
my $hourtwo = Gm_Utils::toTwoDigit( $hour );
my $mintwo = Gm_Utils::toTwoDigit( $min );

$censorlist = Gm_Utils::toWebSafe($censorlist);
$otherfilelist = Gm_Utils::toWebSafe($otherfilelist);

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Configuration Options</FONT></B><P>); }

print<<GMCONFIGMENUTOP;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#FFFFD0" COLSPAN=2>$gmfonttag<B>Path Configuration</B><BR><FONT SIZE=1>Your paths tell Greymatter where to look for things on your site; local paths are relative to your server, and the website paths are their respective pointers on the web.  Each of these paths MUST be correctly set for Greymatter to work correctly; if you can't seem to set them right, use virtual paths (with "." and "../") instead; read the Troubleshooting section of the <a href="http://greymatterforum.proboards82.com/" title="read the manual" target="_blank">manual</a> for more information.  It's a good idea to run "Diagnostics & Repair" after saving changes to your paths.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>Local Log Path:</B><BR><FONT SIZE=1>The main weblog/journal directory on your account, where your main index file is.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedlogpath" VALUE="$LogPath" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>Local Entries/Archives Path:</B><BR><FONT SIZE=1>The directory on your account where your entry files (current and archived) are to be stored.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedentriespath" VALUE="$EntriesPath" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>Local CGI Path:</B><BR><FONT SIZE=1>The place on your account where you keep all your Greymatter CGI files ("gm*.cgi").</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedcgilocalpath" VALUE="$cgilocalpath" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>Website Log Path:</B><BR><FONT SIZE=1>The website address of the directory where your main index file is.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedlogwebpath" VALUE="$LogWebPath" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>Website Entries Path:</B><BR><FONT SIZE=1>The website address of the directory where all your entries are to be stored.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedentrieswebpath" VALUE="$EntriesWebPath" SIZE=30 STYLE="width: 400" WIDTH=100%>$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT>$gmfonttag<B>Website CGI Path:</B><BR><FONT SIZE=1>The website address of the directory where all your Greymatter CGI files are kept.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedcgiwebpath" VALUE="$cgiwebpath" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT>$gmfonttag<B>Website Emoticons Path:</B><BR><FONT SIZE=1>The path for the emoticon images. either a website path (like http://) or a local path (like /emoticons). no slash ("/") at the end.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedemoticonspath" VALUE="$emoticonspath" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Index & Archive Options</B><BR><FONT SIZE=1>Options relating to your main index and your archives.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Index filename:</B><BR><FONT SIZE=1>The filename of your log/journal's main index.  If you enable "Keep archive master index", Greymatter will create that file in the archives directory with the same filename.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=350></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedindexfilename" VALUE="$indexfilename" SIZE=15 STYLE="width: 200">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>.suffix to entry files:</B><BR><FONT SIZE=1>If you have "Generate pages for individual entries" enabled, this is the suffix those pages will have.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedentrysuffix" VALUE="$entrysuffix" SIZE=15 STYLE="width: 200">$gmfonttag</TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>.suffix to log archives:</B><BR><FONT SIZE=1>If you have "Keep monthly/weekly log archives" enabled, this is the suffix those log archive files will have.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedlogarchivesuffix" VALUE="$logarchivesuffix" SIZE=15 STYLE="width: 200">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Days to keep on main index:</B><BR><FONT SIZE=1>The number of days' worth of entries Greymatter will list on your main index before scrolling them off.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedindexdays" VALUE="$indexdays" SIZE=5 MAXLENGTH=5>$gmfonttag</TD></TR>

GMCONFIGMENUTOP

print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Generate pages for individual entries?</B><BR><FONT SIZE=1>Specifies whether you want individual entries to have their own pages.  Comments are disabled if this is turned off.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedgenerateentrypages', value=>Gm_Constants::YES,
	checked=>$generateentrypages ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedgenerateentrypages', value=>Gm_Constants::NO,
	checked=>$generateentrypages ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Keep archive master index?</B><BR><FONT SIZE=1>If enabled, Greymatter will keep an index (with the same filename as above) in your entries/archives directory, intended to be an overview of all your archives.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedkeeparchivemasterindex', value=>Gm_Constants::YES,
	checked=>$keeparchivemasterindex ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedkeeparchivemasterindex', value=>Gm_Constants::NO,
	checked=>$keeparchivemasterindex ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Keep monthly/weekly log archives?</B><BR><FONT SIZE=1>If enabled, Greymatter will keep archive files of your log in monthly or weekly installments in your entries/archives directory.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedkeepmonthlyarchives', value=>Gm_Constants::YES,
	checked=>$keepmonthlyarchives ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedkeepmonthlyarchives', value=>Gm_Constants::NO,
	checked=>$keepmonthlyarchives ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Keep main index and archive log<BR>indexes concurrent with each other?</B><BR><FONT SIZE=1>If enabled, both new and archived entries will be listed in the monthly/weekly archives; if disabled, Greymatter won't list entries there until they've scrolled off the main index.  For simplicity's sake, it's a good idea leave this on.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedconcurrentmainandarchives', value=>Gm_Constants::YES,
	checked=>$concurrentmainandarchives ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedconcurrentmainandarchives', value=>Gm_Constants::NO,
	checked=>$concurrentmainandarchives ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Archive by month or week?</B><BR><FONT SIZE=1>If "Keep monthly/weekly log archives" is enabled, this specifies whether the log archives will be generated by the month or by the week.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedarchiveformat', value=>Gm_Constants::MONTH,
	checked=>$archiveformat ).' Monthly &#160; ');
println( Gm_Web::createRadioButton( name=>'editedarchiveformat', value=>Gm_Constants::WEEK,
	checked=>$archiveformat ).' Weekly ');
println('</FONT></TD></TR>');


print qq(</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>E-Mail Options</B><BR><FONT SIZE=1>Options relating to e-mail setup and notification.  If you don't plan to have Greymatter send you e-mails, you can safely ignore the "E-Mail Program Location" and "E-Mail(s) to send notices to" fields.</FONT></FONT></TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>E-Mail Program Location:</B><BR><FONT SIZE=1>The pointer to the mail program (usually Sendmail) on your account.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedmailprog" VALUE="$mailprog" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>E-Mail(s) to send notices to:</B><BR><FONT SIZE=1>The e-mail addresses you want all notifications (if any) to be sent to.  Separate multiple e-mail addresses with semicolons.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editednotifyemail" VALUE="$NotifyEmail" SIZE=30 STYLE="width: 400">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=100%>$gmfonttag<B>Send e-mail notifications for:</B><BR><FONT SIZE=1>Indicates whether you want Greymatter to send e-mails notifying you of new karma votes, new comment postings, both karma and comments, or to disable e-mail notification altogether.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER">'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editednotifyforstatus', value=>Gm_Constants::KARMA,
	checked=>$NotifyForStatus ).' New karma votes &#160;');
println( Gm_Web::createRadioButton( name=>'editednotifyforstatus', value=>Gm_Constants::COMMENTS,
	checked=>$NotifyForStatus ).' New comments<BR>');
println( Gm_Web::createRadioButton( name=>'editednotifyforstatus', value=>Gm_Constants::BOTH,
	checked=>$NotifyForStatus ).' Both &#160; ');
println( Gm_Web::createRadioButton( name=>'editednotifyforstatus', value=>Gm_Constants::NEITHER,
	checked=>$NotifyForStatus ).' Neither');
println('</FONT></TD></TR>');

print qq(</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Emoticon Options</B><BR><FONT SIZE=1>Options relating to using emoticons in entries and comments.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Allow emoticons?</B><BR><FONT SIZE=1>Specifies if you want to allow emoticons in the entries and/or the comments.</FONT></FONT></TD>);

println( '<TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedemoticonsallowed', value=>Gm_Constants::ENTRIES,
	checked=>$emoticonsallowed ).' Entries only &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedemoticonsallowed', value=>Gm_Constants::COMMENTS,
	checked=>$emoticonsallowed ).' Comments only<BR> ');
println( Gm_Web::createRadioButton( name=>'editedemoticonsallowed', value=>Gm_Constants::BOTH,
	checked=>$emoticonsallowed ).' Both &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedemoticonsallowed', value=>Gm_Constants::NEITHER,
	checked=>$emoticonsallowed ).' Neither ');
println( '</FONT></TD></TR>' );

print qq(</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Karma & Comments Options</B><BR><FONT SIZE=1>Options relating to karma voting and comment posting.  Obviously, certain options can be ignored if you have their respective functions disabled (for example, if you disable comments or have "Generate pages for individual entries" turned off, none of the options relating to comments will have any effect).</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Allow karma voting and/or comment posting?</B><BR><FONT SIZE=1>Specifies whether you want to permit voting on karma, posting comments, both, or neither, on your site.  You can leave them enabled and still turn karma or comments on or off for individual entries; to disable either or both will override that for ALL entries.</FONT></FONT></TD>);

println('<TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedallowkarmaorcomments', value=>Gm_Constants::KARMA,
	checked=>$allowkarmaorcomments ).' Karma only &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedallowkarmaorcomments', value=>Gm_Constants::COMMENTS,
	checked=>$allowkarmaorcomments ).'Comments only<BR> '); 
println( Gm_Web::createRadioButton( name=>'editedallowkarmaorcomments', value=>Gm_Constants::BOTH,
	checked=>$allowkarmaorcomments ).'Both &#160;  '); 
println( Gm_Web::createRadioButton( name=>'editedallowkarmaorcomments', value=>Gm_Constants::NEITHER,
	checked=>$allowkarmaorcomments ).'Neither '); 
println( '</FONT></TD></TR>' );

print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Order of comments on entry pages:</B><BR><FONT SIZE=1>The order in which you want comments displayed.  If "ascending", they'll be listed from newest to oldest, with the newest comment at the top; if "descending", from first to last, with the first comment at the top.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommentsorder', value=>Gm_Constants::ASCENDING,
	checked=>$commentsorder ).' Ascending &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentsorder', value=>Gm_Constants::DESCENDING,
	checked=>$commentsorder ).' Descending ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Can post comments and vote on karma in archives?</B><BR><FONT SIZE=1>If enabled, visitors can cast karma votes or post comments (if applicable) on entries no longer listed on the main index.  Enabling this may slow down your site over time.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedposttoarchives', value=>Gm_Constants::YES,
	checked=>$posttoarchives ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedposttoarchives', value=>Gm_Constants::NO,
	checked=>$posttoarchives ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Karma voting on by default?</B><BR><FONT SIZE=1>Specifies whether "Allow karma voting on this entry" is preselected to "Yes" or "No" by default on the "Add a new entry" screen.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedallowkarmadefault', value=>Gm_Constants::YES,
	checked=>$allowkarmadefault ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedallowkarmadefault', value=>Gm_Constants::NO,
	checked=>$allowkarmadefault ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Comment posting on by default?</B><BR><FONT SIZE=1>Specifies whether "Allow comments to be posted to this entry" is preselected to "Yes" or "No" by default on the "Add a new entry" screen.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedallowcommentsdefault', value=>Gm_Constants::YES,
	checked=>$allowcommentsdefault ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedallowcommentsdefault', value=>Gm_Constants::NO,
	checked=>$allowcommentsdefault ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>HTML allowed in comments?</B><BR><FONT SIZE=1>Indicates whether you want to allow visitors to include HTML codes in their comments, or to have Greymatter strip them out.  You can also specify whether only the codes for links, bold and italics can be included, or just the codes for links.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedallowhtmlincomments', value=>Gm_Constants::YES,
	checked=>$allowhtmlincomments ).' All HTML allowed &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedallowhtmlincomments', value=>Gm_Constants::NO,
	checked=>$allowhtmlincomments ).' No HTML allowed<BR> ');
println( Gm_Web::createRadioButton( name=>'editedallowhtmlincomments', value=>'linkboldital',
	checked=>$allowhtmlincomments ).' Linking, Bold & Italic code only<BR> ');
println( Gm_Web::createRadioButton( name=>'editedallowhtmlincomments', value=>'linkonly',
	checked=>$allowhtmlincomments ).' Linking code only ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Auto-link URLs in comments?</B><BR><FONT SIZE=1>If enabled, Greymatter will automatically link to any website or e-mail addresses that users post in their comments (unless you've enabled linking above and they've already linked the website/e-mail address themselves).</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedautolinkurls', value=>Gm_Constants::YES,
	checked=>$autolinkurls ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedautolinkurls', value=>Gm_Constants::NO,
	checked=>$autolinkurls ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Strip new lines from comments?</B><BR><FONT SIZE=1>If enabled, all line and paragraph breaks are stripped when displaying visitors' comments, turning them into unbroken blocks of text; if disabled, Greymatter preserves the visitors' original formatting.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedstriplinesfromcomments', value=>Gm_Constants::YES,
	checked=>$striplinesfromcomments ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedstriplinesfromcomments', value=>Gm_Constants::NO,
	checked=>$striplinesfromcomments ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Allow multiple karma votes from same IP?</B><BR><FONT SIZE=1>If enabled, the same visitor could cast multiple karma votes on the same entry; if disabled, only one vote per visitor is allowed.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedallowmultiplekarmavotes', value=>Gm_Constants::YES,
	checked=>$allowmultiplekarmavotes ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedallowmultiplekarmavotes', value=>Gm_Constants::NO,
	checked=>$allowmultiplekarmavotes ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Mention it in the control panel log when<BR>comments and karma votes are added?</B><BR><FONT SIZE=1>Enable this if you want Greymatter to mention all new comments and karma votes in the control panel log.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedlogkarmaandcomments', value=>Gm_Constants::YES,
	checked=>$logkarmaandcomments ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedlogkarmaandcomments', value=>Gm_Constants::NO,
	checked=>$logkarmaandcomments ).' No ');
println('</FONT></TD></TR>');


# new config entries for $keepphphacklog and $mailhacknotice: linear 9/12/2003 
# merged into 1.3 
print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Mention it in the control panel log when<BR>PHP hack attempts are detected?</B><BR><FONT SIZE=1>Enable this if you want Greymatter to log all attempts at hacking in the control panel log. Particularly useful for those who have set their file .suffix to .php</FONT></FONT></TD>);
 
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedkeepphphacklog', value=>Gm_Constants::YES,
	checked=>$keepphphacklog ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedkeepphphacklog', value=>Gm_Constants::NO,
	checked=>$keepphphacklog ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Send e-mail notifications when<BR>PHP hack attempts are detected?</B><BR><FONT SIZE=1>Enable this if you want to receive mail when PHP hack attempts are logged. Particularly useful for those who have set their file .suffix to .php</FONT></FONT></TD>);
 
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedmailhacknotice', value=>Gm_Constants::YES,
	checked=>$mailhacknotice ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedmailhacknotice', value=>Gm_Constants::NO,
	checked=>$mailhacknotice ).' No ');
println('</FONT></TD></TR>');


println('<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.
	'<B>Password Protect Author Name in Comments?</B><BR><FONT SIZE=1> '.
	'If enabled '.
	'comments cannot be entered that contain a registered authors name.  When authors '.
	'wish to post comments they must enter their author name, the "_", and their '.
	'password.  In other words as AUTHORNAME_PASSWORD (using proper case for the '.
	'username and password).  Exact means that the commenter name must match the '.
	'author\'s name exactly.</FONT></FONT></TD>');
	
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedprotectauthorname', value=>'LOOSE',
	checked=>$protectauthorname ).' Loose &#160; ');
println( Gm_Web::createRadioButton( name=>'editedprotectauthorname', value=>'STRICT',
	checked=>$protectauthorname ).' Exact &#160; ');
println( Gm_Web::createRadioButton( name=>'editedprotectauthorname', value=>Gm_Constants::NO,
	checked=>$protectauthorname ).' No ');
println('</FONT></TD></TR>');

println('<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.
	'<B>Limit Links in Comments?</B><BR><FONT SIZE=1>If enabled '.
	'comments that contain more than the specified allowed amount of comments will '.
	'be automatically block and/or banned.</FONT></FONT></TD>');
	
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommentlinklimit', value=>'blockban',
	checked=>$commentlinklimit ).' Block and Ban &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentlinklimit', value=>'block',
	checked=>$commentlinklimit ).' Block &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentlinklimit', value=>Gm_Constants::NO,
	checked=>$commentlinklimit ).' No <br />');
println( '<INPUT TYPE=TEXT CLASS="textinput" NAME="editedcommentlinklimitnum" VALUE="'.
	$commentlinklimitnum.'" SIZE=5 MAXLENGTH=5> links' );	
println('</FONT></TD></TR>');

println('<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.
	'<B><FONT COLOR="#00FF00">Updated</FONT> Force Previewing when Posting a Comment?</B>'.
	'<BR><FONT SIZE=1>If enabled '.
	'comments cannot be entered without previewing first.  This extra step can help '.
	'cut down on spam.  Note that if this is enabled, you may wish to remove the '.
	'"Submit" button on the comment entry template, since this will just take the user'.
	'to the preview page, or remove the "Preview" button.'.
	'<br />Note: This may require a modification to the "Confirmation Form Template",'.
	' simply add or verify that the button in that template has the "name=postit" attribute.'.
	'<br />Note: If you choose "Random", a random phrase will be hidden on the preview form, '.
	'ensuring that comments cannot be posted directly, they must be Previewed.  This is recommended '.
	'but requires that the line "&lt;input type=hidden name=previewrand value={{previewrand}} /&gt;" be put '.
	'just before the submit button in the Comment Confirmation templates.'.
	'</FONT></TD>');
	
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommentforcepreview', value=>'rand',
	checked=>$commentforcepreview ).' Random ');
println( Gm_Web::createRadioButton( name=>'editedcommentforcepreview', value=>Gm_Constants::YES,
	checked=>$commentforcepreview ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentforcepreview', value=>Gm_Constants::NO,
	checked=>$commentforcepreview ).' No ');
println('</FONT></TD></TR>');

println('<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.
	'<B>Commenter Verification?</B> <FONT COLOR="#00FF00"UPDATED</FONT><BR><FONT SIZE=1>If enabled '.
	'when a comment is submitted, the commenter will be prompted to retype a "pass-phrase" withen 3 minutes,'.
	'to cut down on automated spam.  You can provide a static pass-phrase that users will '.
	'be prompted, or the pass-phrase will be used to create a random 7 character string '.
	'</FONT></FONT></TD>');
	
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommentverify', value=>'random',
	checked=>$commentverify ).' Random Phrase &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentverify', value=>'static',
	checked=>$commentverify ).' Static Phrase &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentverify', value=>Gm_Constants::NO,
	checked=>$commentverify ).' No <br />');
println( '<INPUT TYPE=TEXT CLASS="textinput" NAME="editedcommentverifyphrase" VALUE="'.
	$commentverifyphrase.'" SIZE=15 MAXLENGTH=15> phrase' );	
println('</FONT></TD></TR>');

println('<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.
	'<B><FONT COLOR="#00FF00">NEW</FONT> Verify Site Comment/Karma Vote Posted From?</B><br />'.
	'<FONT SIZE=1>If enabled will verify that the page that comments are posted or karma votes are '.
	'from matches the site listed in Website Path variables.  '.
	'Spammers can fake where the form is posted from, but some do not.  This will block their '.
	'comments/ karma votes with an error message.  May not work with some path configurations.'.
	'</FONT></TD>');
	
println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommentverifyreferer', value=>Gm_Constants::YES,
	checked=>$commentverifyreferer ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentverifyreferer', value=>Gm_Constants::NO,
	checked=>$commentverifyreferer ).' No ');
println('</FONT></TD></TR>');

println('<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.
	'<B><FONT COLOR="#00FF00">NEW</FONT> Comment Throttling?</B><BR><FONT SIZE=1>If enabled '.
	'will limit the amount of comments that can be made on an entry by a single user '.
	'(assuming that the user\'s IP is the same) in a given day.  Static will allow the user '.
	'to comment every X minutes, while Exponential will allow the second comment after 1 minute, '.
	'the third after 4, fourth after 9, and so on.'.
	'</FONT></TD>');

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommentthrottle', value=>Gm_Constants::YES,
	checked=>$commentthrottle ).' Exponential &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommentthrottle', value=>'static',
	checked=>$commentthrottle ).' Static ');
println( Gm_Web::createRadioButton( name=>'editedcommentthrottle', value=>Gm_Constants::NO,
	checked=>$commentthrottle ).' No <br />');
println( '<INPUT TYPE=TEXT CLASS="textinput" NAME="editedcommentthrottlemin" VALUE="'.
	$commentthrottlemin.'" SIZE=15 MAXLENGTH=15> minutes' );	
println('</FONT></TD></TR>');


print qq(</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Date & Time Options</B><BR><FONT SIZE=1>Miscellaneous options regarding to dates & times.  Use the wide variety date and time variables in your templates to fine-tune how you want the date and time to appear on your site.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Server Offset Time:</B><BR><FONT SIZE=1>As of this moment, Greymatter reads your time as <B>$hour\:$mintwo $AMPM</B>.  If this is incorrect, specify the number of hours to add or subtract from this time (to subtract, make it a negative number, with a minus in front of it).</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedoffsettime" VALUE="$serveroffset" SIZE=5 MAXLENGTH=5>$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Your Time Zone:</B><BR><FONT SIZE=1>The time zone you live in.  This is what will appear wherever you use the {{timezone}} variable in your templates.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedtimezone" VALUE="$timezone" SIZE=5 MAXLENGTH=5>$gmfonttag</TD></TR>

</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>File Uploading Options</B><BR><FONT SIZE=1>Options relating to uploading files from within Greymatter.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Allowed File Types:</B><BR><FONT SIZE=1>If you only wish to allow certain types of files to be uploaded, enter their file suffixes here.  Separate allowed file types by semicolons (for example, "jpg;gif;zip").  Leave this blank to allow any type of file to be uploaded.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editeduploadfilesallowed" VALUE="$uploadfilesallowed" SIZE=20 STYLE="width: 320">$gmfonttag</TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Maximum Filesize Allowed:</B><BR><FONT SIZE=1>If you don't wish to allow files larger than a certain size to be uploaded, specify that limit here (in KB/kilobytes).  Leave this on "0" to allow files of any size to be uploaded.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editeduploadfilesizelimit" VALUE="$uploadfilesizelimit" SIZE=5 MAXLENGTH=5>$gmfonttag KB</TD></TR>

</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Censoring Options</B><BR><FONT SIZE=1>Words or phrases you want to censor on your site (if any), and where to censor them.<BR>Censored terms will be turned into "*" asterisks.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Enable censoring?</B><BR><FONT SIZE=1>Specifies whether you want any words or phrases in your censor list to appear censored for entries, comments, or both.  Leave it on "Neither" to disable censorship.</FONT></FONT></TD>);

println( '<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcensorenabled', value=>Gm_Constants::ENTRIES,
	checked=>$censorenabled ).' Entries only &#160 '); 
println( Gm_Web::createRadioButton( name=>'editedcensorenabled', value=>Gm_Constants::COMMENTS,
	checked=>$censorenabled ).' Comments only<BR> ');
println( Gm_Web::createRadioButton( name=>'editedcensorenabled', value=>Gm_Constants::BOTH,
	checked=>$censorenabled ).' Both &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedcensorenabled', value=>Gm_Constants::NEITHER,
	checked=>$censorenabled ).' Neither');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Censor List</B><BR><FONT SIZE=1>Enter any words or phrases you want to censor, separated by lines (press return after each word/phrase).  Use [brackets] around words/phrases to censor the term only if it's not part of another word/phrase; for example, censoring the word hell would render hell as **** and shell as s****, but censoring [hell] would only turn hell by itself into asterisks, and leave the word shell alone.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><TEXTAREA NAME="editedcensorlist" COLS=25 ROWS=6 WRAP=VIRTUAL STYLE="width: 320">$censorlist</TEXTAREA>$gmfonttag</FONT></TD></TR>

</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Connect Other Files (Advanced Users Only)</B><BR><FONT SIZE=1>If you wish, you can connect other files on your account to Greymatter, and have them treated as if they were one of Greymatter's regular index files; for example, using {{header}} or {{footer}} in another file to insert your Greymatter header or footer into that file.  (You'll need to edit & upload these files to your account outside Greymatter.)  This is <B>only recommended for advanced users</B> that are already comfortable using Greymatter.</FONT></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Filename List</B><BR><FONT SIZE=1>To connect a file to Greymatter, <B>CHMOD it to 666</B>&#151;making sure it contains whatever Greymatter variables you wish&#151;and enter its filename on the right; place each filename on separate lines.  If the file isn't in the same directory as gm.cgi, then use virtual paths relative to where it's running from.  For example, if you want to connect "test.htm" and it's in the directory above gm.cgi, you'd use ../test.htm; or, if you run gm.cgi from /here/cgi-bin and test.htm was in /there/log, you'd use ../../there/log ("../" means to go up one directory).  Greymatter will automatically create a "pattern" file in your entries directory for each filename, and whenever you reupload a changed file, Greymatter will automatically update its stored pattern for that file.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><TEXTAREA NAME="editedotherfilelist" COLS=25 ROWS=10 WRAP=VIRTUAL STYLE="width: 320">$otherfilelist</TEXTAREA>$gmfonttag</FONT></TD></TR>

<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Update them when adding entries?</B><BR><FONT SIZE=1>If "Yes", then Greymatter will automatically update any of the connected files above when new entries are added; if not, they'll only be updated whenever you rebuild them (either specifically, or by rebuilding everything).</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedotherfilelistentryrebuild', value=>Gm_Constants::YES,
	checked=>$otherfilelistentryrebuild ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedotherfilelistentryrebuild', value=>Gm_Constants::NO,
	checked=>$otherfilelistentryrebuild ).' No ');
println('</FONT></TD></TR>');


print qq(</TABLE></TD></TR></TABLE>

<P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=7 CELLSPACING=1 WIDTH=700>

<TR><TD VALIGN=MIDDLE ALIGN=CENTER BGCOLOR="#C0C0C0" COLSPAN=2>$gmfonttag<B>Miscellaneous Options</B></FONT></TD></TR>

<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Enable/Disable cookies?</B><BR><FONT SIZE=1>By default, Greymatter doesn't keep a cookie on your browser to remember your name and password.  To enable Greymatter's cookies, select "Yes".</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcookiesallowed', value=>Gm_Constants::YES,
	checked=>$cookiesallowed ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcookiesallowed', value=>Gm_Constants::NO,
	checked=>$cookiesallowed ).' No ');
println('<BR><INPUT TYPE=CHECKBOX NAME="editeddeletecookies" VALUE="yes"> Delete cookies set by Greymatter?');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF">);

println('<TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>'.$gmfonttag.'<B>Keep control panel log?</B><BR>'.
	'<FONT SIZE=1>Specifies whether you want Greymatter to keep its internal log of all activity; '.
	'disable this if you want to shut it off.</FONT></FONT></TD>');

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedkeeplog', value=>Gm_Constants::YES,
	checked=>$keeplog ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedkeeplog', value=>Gm_Constants::NO,
	checked=>$keeplog ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Allow "easy formatting"?</B><BR><FONT SIZE=1>With "easy formatting", bold text, italics & underlining can be done easily by bracketing text with two **asterisks**, \\\\backslashes\\\\ or __underlines__ respectively.  You can specify whether this is enabled in entries, comments, or both; if disabled, the characters won't be converted.</FONT></FONT></TD>);

println( '<TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedinlineformatting', value=>Gm_Constants::ENTRIES,
	checked=>$inlineformatting ).' Entries only &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedinlineformatting', value=>Gm_Constants::COMMENTS,
	checked=>$inlineformatting ).' Comments only<BR> ');
println( Gm_Web::createRadioButton( name=>'editedinlineformatting', value=>Gm_Constants::BOTH,
	checked=>$inlineformatting ).' Both &#160; '); 
println( Gm_Web::createRadioButton( name=>'editedinlineformatting', value=>Gm_Constants::NEITHER,
	checked=>$inlineformatting ).' Neither ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Default entry list view:</B><BR><FONT SIZE=1>This specifies which view will be the default when you go to the Edit An Entry selection menu.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%>$gmfonttag<SELECT NAME="editeddefaultentrylistview" CLASS="selectlist">\n);

println( Gm_Web::createOption( value=>'main', label=>' Current entries ('.$indexdays.' day(s))',
	checked=>$defaultentrylistview ));
println( Gm_Web::createOption( value=>'onlyyou', label=>' All entries by you',
	checked=>$defaultentrylistview ));
println( Gm_Web::createOption( value=>Gm_Constants::MORE, label=>' All extended entries',
	checked=>$defaultentrylistview ));
println( Gm_Web::createOption( value=>Gm_Constants::OPEN, label=>' All open entries',
	checked=>$defaultentrylistview ));
println( Gm_Web::createOption( value=>Gm_Constants::CLOSED, label=>' All closed entries',
	checked=>$defaultentrylistview ));
println( Gm_Web::createOption( value=>Gm_Constants::ALL, label=>' All entries',
	checked=>$defaultentrylistview ));


print qq(</SELECT></FONT></TD></TR>\n<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Order of list links:</B><BR><FONT SIZE=1>The order in which you want links to be displayed in log list variables&#151;check the manual for more information on those.  If "ascending", the links will be listed from newest to oldest, with the newest entry at the top; if "descending", from first to last, with the first entry at the top.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedentrylistsortorder', value=>Gm_Constants::ASCENDING,
	checked=>$entrylistsortorder ).' Ascending &#160; ');
println( Gm_Web::createRadioButton( name=>'editedentrylistsortorder', value=>Gm_Constants::DESCENDING,
	checked=>$entrylistsortorder ).' Descending ');
println('</FONT></TD></TR>');

print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Log entry list variable number:</B><BR><FONT SIZE=1>The number of entries to link to, starting from the most recent, whenever the "number" variant of the log entrylist variables (for example, if this is set to 5, using {{logmoreentrylist number}} would generate a list of links to the five most recent extended entries).  Check the <a href="http://greymatterforum.proboards82.com/" title="read the manual" target="_blank">manual</a> for more information on those variables.</FONT></FONT></TD><TD VALIGN=MIDDLE ALIGN=CENTER WIDTH=50%></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="editedentrylistcountnumber" VALUE="$entrylistcountnumber" SIZE=5 MAXLENGTH=5>$gmfonttag</TD></TR>\n);

print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Link to entries in {{logentrylist comments}} only if comments are active?</B><BR><FONT SIZE=1>If you use {{logentrylist comments}} and its related variables (see the <a href="http://greymatterforum.proboards82.com/" title="read the manual" target="_blank">manual</a> for more information), this specifies whether to list only entries to which comments can still be posted.</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedcommententrylistonlyifokay', value=>Gm_Constants::YES,
	checked=>$commententrylistonlyifokay ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedcommententrylistonlyifokay', value=>Gm_Constants::NO,
	checked=>$commententrylistonlyifokay ).' No ');
println('</FONT></TD></TR>');


print qq(<TR BGCOLOR="#FFFFFF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>Entries to link to in 	{{calendar}}:</B><BR><FONT SIZE=1>Whenever you use {{calendar}} or {{calendarweek}} to generate tables linking to your entries, this specifies whether you want to link to the most recent entry for that day, or to link only to extended entries.  (It won't generate links at all if "Generate pages for individual entries" is turned off.)</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedlinktocalendarentries', value=>Gm_Constants::ALL,
	checked=>$linktocalendarentries ).' Always link to entry for that calendar day<BR>');
println( Gm_Web::createRadioButton( name=>'editedlinktocalendarentries', value=>Gm_Constants::MORE,
	checked=>$linktocalendarentries ).' Link only to extended entries ');
println('</FONT></TD></TR>');	


print qq(<TR BGCOLOR="#F8F8FF"><TD VALIGN=MIDDLE ALIGN=RIGHT WIDTH=50%>$gmfonttag<B>"Automatically rebuild" selected by default?</B><BR><FONT SIZE=1>Selects whether the option to automatically rebuild files after saving changes to templates or entries is prechecked by default.  (Authors without access to rebuilding files won't see this option.)</FONT></FONT></TD>);

println('<TD VALIGN="MIDDLE" ALIGN="CENTER" WIDTH=50%>'.$gmfonttag );
println( Gm_Web::createRadioButton( name=>'editedautomaticrebuilddefault', value=>Gm_Constants::YES,
	checked=>$automaticrebuilddefault ).' Yes &#160; ');
println( Gm_Web::createRadioButton( name=>'editedautomaticrebuilddefault', value=>Gm_Constants::NO,
	checked=>$automaticrebuilddefault ).' No ');
println('</FONT></TD></TR>');


print<<GMCONFIGMENUBOTTOM;

</TABLE></TD></TR></TABLE>
<P>
<TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 BGCOLOR="#FFD0D0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<FONT SIZE=1><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Diagnostics & Repair"></TD></TR></TABLE></TD></TR></TABLE>
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Save Configuration"> <INPUT TYPE=RESET CLASS="button" STYLE="background: #FFD0D0" VALUE="Undo Changes Since Last Save">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">

</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMCONFIGMENUBOTTOM

$statusnote = Gm_Constants::EMPTY;

exit;

}

# ----------------
# save config file
# ----------------

sub gm_saveconfiguration {

&gm_validate;

if ($gmconfigurationaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to save changes to the config file without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to change the config file.</FONT></B><P>);
	&gm_frontpage;
}

chomp ($IN{'editedcensorlist'});
$IN{'editedcensorlist'} = Gm_Utils::toStoreSafe($IN{'editedcensorlist'});
chomp ($IN{'editedotherfilelist'});
$IN{'editedotherfilelist'} = Gm_Utils::toStoreSafe($IN{'editedotherfilelist'});

$IN{'editedlogpath'} = Gm_Utils::toConfigSafe($IN{'editedlogpath'});
$IN{'editedentriespath'} = Gm_Utils::toConfigSafe($IN{'editedentriespath'});
$IN{'editedlogwebpath'} = Gm_Utils::toConfigSafe($IN{'editedlogwebpath'});
$IN{'editedentrieswebpath'} = Gm_Utils::toConfigSafe($IN{'editedentrieswebpath'});
$IN{'editednotifyemail'} = Gm_Utils::toConfigSafe($IN{'editednotifyemail'});
$IN{'editedindexfilename'} = Gm_Utils::toConfigSafe($IN{'editedindexfilename'});
$IN{'editedentrysuffix'} = Gm_Utils::toConfigSafe($IN{'editedentrysuffix'});
$IN{'editedindexdays'} = Gm_Utils::toConfigSafe($IN{'editedindexdays'});
$IN{'editedoffsettime'} = Gm_Utils::toConfigSafe($IN{'editedoffsettime'});
$IN{'editedtimezone'} = Gm_Utils::toConfigSafe($IN{'editedtimezone'});
$IN{'editedmailprog'} = Gm_Utils::toConfigSafe($IN{'editedmailprog'});
$IN{'editedcgilocalpath'} = Gm_Utils::toConfigSafe($IN{'editedcgilocalpath'});
$IN{'editedcgiwebpath'} = Gm_Utils::toConfigSafe($IN{'editedcgiwebpath'});
$IN{'editedemoticonspath'} = Gm_Utils::toConfigSafe($IN{'editedemoticonspath'});
$IN{'editedentrylistcountnumber'} = Gm_Utils::toConfigSafe($IN{'editedentrylistcountnumber'});
$IN{'editedlogarchivesuffix'} = Gm_Utils::toConfigSafe($IN{'editedlogarchivesuffix'});

$IN{'editedcensorlist'} =~ s/^\s+//;
$IN{'editedcensorlist'} =~ s/\s+$//;
$IN{'editedotherfilelist'} =~ s/^\s+//;
$IN{'editedotherfilelist'} =~ s/^\s+//;

$IN{'editedentrysuffix'} =~ s/\.//g;
$IN{'editednotifyemail'} =~ s/ //g;
$IN{'editedlogarchivesuffix'} =~ s/\.//g;

if (($IN{'editedlogpath'} eq Gm_Constants::EMPTY) || ($IN{'editedentriespath'} eq Gm_Constants::EMPTY) || 
($IN{'editedlogwebpath'} eq Gm_Constants::EMPTY) || ($IN{'editedentrieswebpath'} eq Gm_Constants::EMPTY) || 
($IN{'editedindexfilename'} eq Gm_Constants::EMPTY) || ($IN{'editedentrysuffix'} eq Gm_Constants::EMPTY) || 
($IN{'editedindexdays'} eq Gm_Constants::EMPTY) || ($IN{'editedoffsettime'} eq Gm_Constants::EMPTY) || 
($IN{'editedtimezone'} eq Gm_Constants::EMPTY) || ($IN{'editedcgilocalpath'} eq Gm_Constants::EMPTY) || 
($IN{'editedcgiwebpath'} eq Gm_Constants::EMPTY) || ($IN{'editedentrylistcountnumber'} eq Gm_Constants::EMPTY) || 
($IN{'editedlogarchivesuffix'} eq Gm_Constants::EMPTY)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You left one or more of the required fields blank.  Please try again.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editedindexdays'} =~ /\D/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Days to keep on main index" must be a number.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editedoffsettime'} =~ /[^0-9.-]/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Server Offset Time" must be a number.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editeduploadfilesizelimit'} eq Gm_Constants::EMPTY) { $IN{'editeduploadfilesizelimit'} = 0; }

if ($IN{'editeduploadfilesizelimit'} =~ /\D/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Maximum Filesize Allowed" must be a number.</FONT></B><P>);
	&gm_configuration;
}

if (($IN{'editednotifyemail'} ne Gm_Constants::EMPTY) && ($IN{'editedmailprog'} eq Gm_Constants::EMPTY)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You must give your server's e-mail program location<BR>if you're going to have e-mail notification enabled.</FONT></B><P>);
	&gm_configuration;
}

if (($IN{'editednotifyemail'} eq Gm_Constants::EMPTY) && ($IN{'editednotifyforstatus'} ne Gm_Constants::NEITHER)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You must give an e-mail address to receive e-mail notifications.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editedentrylistcountnumber'} =~ /\D/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Log entry list variable number" must be a number.</FONT></B><P>);
	&gm_configuration;
}

$IN{'editeduploadfilesallowed'} =~ s/;/SEMICOLON/g;

if ($IN{'editeduploadfilesallowed'} =~ /\W/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Allowed File Types" must only contain alphanumeric characters (besides semicolons).</FONT></B><P>);
	&gm_configuration;
}

$IN{'editeduploadfilesallowed'} =~ s/SEMICOLON/;/g;

if ($IN{'editedindexdays'} < 1) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Days to keep on main index" must be set to at least one!</FONT></B><P>);
	&gm_configuration;
}

if( $IN{'editedcommentlinklimit'} ne Gm_Constants::NO && $IN{'editedcommentlinklimitnum'} < 1 ){
	# blocking comments with zero links makes no sense
	$statusnote = '<B><FONT COLOR="#FF0000">Limit Links in Comments" must be set to at '.
		'least one!</FONT></B><P>';
	&gm_configuration;
}

if( $IN{'editedcommentverify'} ne Gm_Constants::NO && $IN{'editedcommentverifyphrase'} eq '' ){
	# if turned on must have a phrase of some sort
	$statusnote = '<B><FONT COLOR="#FF0000">Please provide a pass-phrase for '.
		'"Commenter Verification"!</FONT></B><P>';
	&gm_configuration;
}

if( $IN{'editedcommentthrottle'} eq 'static' && ( $IN{'editedcommentthrottlemin'} eq '' ||
	$IN{'editedcommentthrottlemin'} =~ /\D/  )){
	# if turned on must have a phrase of some sort
	$statusnote = '<B><FONT COLOR="#FF0000">Please provide a number of minutes for '.
		'"Comment Throttling"!</FONT></B><P>';
	&gm_configuration;
}


if (substr($IN{'editedlogpath'}, -1) eq "/") { chop ($IN{'editedlogpath'}) };
if (substr($IN{'editedentriespath'}, -1) eq "/") { chop ($IN{'editedentriespath'}) };
if (substr($IN{'editedcgilocalpath'}, -1) eq "/") { chop ($IN{'editedcgilocalpath'}) };
if (substr($IN{'editedlogwebpath'}, -1) eq "/") { chop ($IN{'editedlogwebpath'}) };
if (substr($IN{'editedentrieswebpath'}, -1) eq "/") { chop ($IN{'editedentrieswebpath'}) };
if (substr($IN{'editedcgiwebpath'}, -1) eq "/") { chop ($IN{'editedcgiwebpath'}) };
if (substr($IN{'editedemoticonspath'}, -1) eq "/") { chop ($IN{'editedemoticonspath'}) };

my %confs = ();
$confs{'gmlogpath'} = $IN{'editedlogpath'};
$confs{'gmentriespath'} = $IN{'editedentriespath'};
$confs{'gmlogwebpath'} = $IN{'editedlogwebpath'};
$confs{'gmentrieswebpath'} = $IN{'editedentrieswebpath'};
$confs{'gmnotifyemail'} = $IN{'editednotifyemail'};
$confs{'gmindexfilename'} = $IN{'editedindexfilename'};
$confs{'gmentrysuffix'} = $IN{'editedentrysuffix'};
$confs{'gmindexdays'} = $IN{'editedindexdays'};
$confs{'gmserveroffset'} = $IN{'editedoffsettime'};
$confs{'gmtimezone'} = $IN{'editedtimezone'};
$confs{'gmkeeplog'} = $IN{'editedkeeplog'};
$confs{'gmposttoarchives'} = $IN{'editedposttoarchives'};
$confs{'gmallowkarmadefault'} = $IN{'editedallowkarmadefault'};
$confs{'gmallowcommentsdefault'} = $IN{'editedallowcommentsdefault'};
$confs{'gmcommentsorder'} = $IN{'editedcommentsorder'};
$confs{'gmgenerateentrypages'} = $IN{'editedgenerateentrypages'};
$confs{'gmallowhtmlincomments'} = $IN{'editedallowhtmlincomments'};
$confs{'gmlogkarmaandcomments'} = $IN{'editedlogkarmaandcomments'};
$confs{'gmmailprog'} = $IN{'editedmailprog'};
$confs{'gmnotifyforstatus'} = $IN{'editednotifyforstatus'};
$confs{'gmautolinkurls'} = $IN{'editedautolinkurls'};
$confs{'gmstriplinesfromcomments'} = $IN{'editedstriplinesfromcomments'};
$confs{'gmallowmultiplekarmavotes'} = $IN{'editedallowmultiplekarmavotes'};
$confs{'gmversionsetup'} = $gmversion;
$confs{'gmversion'} = Gm_Constants::GM_VERSION;
$confs{'gmcgilocalpath'} = $IN{'editedcgilocalpath'};
$confs{'gmcgiwebpath'} = $IN{'editedcgiwebpath'};
$confs{'gmconcurrentmainandarchives'} = $IN{'editedconcurrentmainandarchives'};
$confs{'gmkeeparchivemasterindex'} = $IN{'editedkeeparchivemasterindex'};
$confs{'gmentrylistsortorder'} = $IN{'editedentrylistsortorder'};
$confs{'gmallowkarmaorcomments'} = $IN{'editedallowkarmaorcomments'};
$confs{'gmentrylistcountnumber'} = $IN{'editedentrylistcountnumber'};
$confs{'gmcookiesallowed'} = $IN{'editedcookiesallowed'};
$confs{'gmlogarchivesuffix'} = $IN{'editedlogarchivesuffix'};
$confs{'gmcensorlist'} = $IN{'editedcensorlist'};
$confs{'gmcensorenabled'} = $IN{'editedcensorenabled'};
$confs{'gmkeepmonthlyarchives'} = $IN{'editedkeepmonthlyarchives'};
$confs{'gmdefaultentrylistview'} = $IN{'editeddefaultentrylistview'};
$confs{'gmlinktocalendarentries'} = $IN{'editedlinktocalendarentries'};
$confs{'gmautomaticrebuilddefault'} = $IN{'editedautomaticrebuilddefault'};
$confs{'gmcommententrylistonlyifokay'} = $IN{'editedcommententrylistonlyifokay'};
$confs{'gmotherfilelist'} = $IN{'editedotherfilelist'};
$confs{'gmotherfilelistentryrebuild'} = $IN{'editedotherfilelistentryrebuild'};
$confs{'gmarchiveformat'} = $IN{'editedarchiveformat'};
$confs{'gminlineformatting'} = $IN{'editedinlineformatting'};
$confs{'gmuploadfilesallowed'} = $IN{'editeduploadfilesallowed'};
$confs{'gmuploadfilesizelimit'} = $IN{'editeduploadfilesizelimit'};
$confs{'gmemoticonspath'} = $IN{'editedemoticonspath'};
$confs{'gmkeepphphacklog'} = $IN{'editedkeepphphacklog'};
$confs{'gmmailhacknotice'} = $IN{'editedmailhacknotice'};
$confs{'gmemoticonsallowed'} = $IN{'editedemoticonsallowed'};
$confs{'gmprotectauthorname'} = $IN{'editedprotectauthorname'};
$confs{'gmcommentlinklimit'} = $IN{'editedcommentlinklimit'};
$confs{'gmcommentlinklimitnum'} = $IN{'editedcommentlinklimitnum'};
$confs{'gmcommentforcepreview'} = $IN{'editedcommentforcepreview'};
$confs{'gmcommentverify'} = $IN{'editedcommentverify'};
$confs{'gmcommentverifyphrase'} = $IN{'editedcommentverifyphrase'};
$confs{'gmcommentverifyreferer'} = $IN{'editedcommentverifyreferer'};
$confs{'gmcommentthrottle'} = $IN{'editedcommentthrottle'};
$confs{'gmcommentthrottlemin'} = $IN{'editedcommentthrottlemin'};

Gm_Storage::setConfigs( configs=>\%confs, errHandler=>\&Gm_Web::displayAdminErrorExit );

if (($keeplog eq Gm_Constants::NO) && ($IN{'editedkeeplog'} eq Gm_Constants::YES)) {
	my ($gmdate) = Gm_Utils::getStdDate( $serveroffset );
	gm_writetocplog( "$IN{'authorname'} let this log get its groove back\n".
		"<FONT SIZE=1>[$gmdate] [$authorIP]</FONT> $IN{'authorname'} edited the config file");
}

if ($IN{'editedkeeplog'} eq Gm_Constants::NO) {
	my ($gmdate) = Gm_Utils::getStdDate( $serveroffset );
	gm_writetocplog("$IN{'authorname'} edited the config file\n<FONT SIZE=1>[$gmdate] [$authorIP]</FONT> $IN{'authorname'} decided to stop this log from getting down with its bad-ass self");
} else {
	gm_writetocplog("$IN{'authorname'} edited the config file");
}

$statusnote = qq(<B><FONT COLOR="#0000FF">The config file has been updated.  Be sure to rebuild your files<BR>for the changes to take effect on your site, if appropriate.</FONT></B><P>);

if ($IN{'editeddeletecookies'} eq Gm_Constants::YES) {
	$statusnote .= "\n<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"JavaScript\">\n<!--//\ndeleteCookie(\"gmcookiename\");\ndeleteCookie(\"gmcookiepw\");\n//-->\n</SCRIPT>";
}

&gm_frontpage;

}

# -------------------
# edit banned ip list
# -------------------
## DEPRECATED BY: viewBanList in gm.cgi
sub gm_editbanlist {
	die( "gm_editbanlist has been DEPRECATED");
}

# -------------------------
# add an ip to the ban list
# -------------------------
## DEPRECATED BY: addBannedIp in gm.cgi
sub gm_addbannedip {
	die( "gm_addbannedip has been DEPRECATED");
}

# ------------------------------
# delete an ip from the ban list
# ------------------------------
## DEPRECATED BY: deleteBannedIp in gm.cgi
sub gm_deletebannedip {
	die( "gm_deletebannedip has been DEPRECATED");
}

# ---------------
# add a new entry
# ---------------
## DEPRECATED BY: newEntry in gm.cgi
sub gm_addentry {

&gm_validate;

if ($gmentryaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to add an entry without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to add entries.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readcounter;

if ($newentrynumber eq "0") {
	_checkIfDiagRun('<B><FONT COLOR="#FF0000">Please run "Diagnostics & Repair" '.
		'in the Configuration screen before posting your first entry.</FONT></B><P>');
}

if ($statusnote eq Gm_Constants::EMPTY) {
	$statusnote = qq(<B><FONT COLOR="#000000">Add A New Entry</FONT></B><BR><FONT SIZE=1>This is the form by which you add new entries to your weblog/journal.  You can make this either a standard or extended entry;<BR>standard entries contain only main text (the first box), while extended entries also have "more" text (the second box).<BR>Standard & extended entries can be handled and formatted in distinct ways via your templates.</FONT><P>);
}

if ($IN{'newentrysubject'} ne Gm_Constants::EMPTY) { 
	$IN{'newentrysubject'} = Gm_Utils::toWebSafe($IN{'newentrysubject'}); 
}
if ($IN{'newentrymaintext'} ne Gm_Constants::EMPTY) { 
	$IN{'newentrymaintext'} = Gm_Utils::toWebSafe($IN{'newentrymaintext'}); 
}
if ($IN{'newentrymoretext'} ne Gm_Constants::EMPTY) { 
	$IN{'newentrymoretext'} = Gm_Utils::toWebSafe($IN{'newentrymoretext'}); 
}

# emoticons code display added
&gm_emoticons_code;

my $inlineinstructions = '';
if( $inlineformatting eq Gm_Constants::ENTRIES || $inlineformatting eq Gm_Constants::BOTH ){
	$inlineinstructions = '<FONT SIZE=1>With "easy formatting", bold text, italics & underlining can be done easily by bracketing text with two **asterisks**, \\\\backslashes\\\\ or __underlines__ respectively.</FONT>';
}

print<<GMADDENTRYTOP;

$gmheadtagtwo

$gmframetop
$statusnote
<script language="JavaScript">
function commentEmoticonMain(code)
{
	var cache = document.entryadd.newentrymaintext.value;

	document.entryadd.newentrymaintext.value = cache + " " + code;
	document.entryadd.newentrymaintext.focus();
}
function commentEmoticonMore(code)
{
	var cache = document.entryadd.newentrymoretext.value;

	document.entryadd.newentrymoretext.value = cache + " " + code;
	document.entryadd.newentrymoretext.focus();
}
</script>
<FORM ACTION="gm.cgi" METHOD=POST name="entryadd">
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=RIGHT>$gmfonttag<b>Subject:</b></FONT></TD><TD ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="newentrysubject" VALUE="$IN{'newentrysubject'}" SIZE=50 STYLE="width: 550">$gmfonttag</TD></TR></TABLE>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=RIGHT>$gmfonttag<b>Music:</b></FONT></TD><TD ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="newentrymusic" VALUE="$IN{'newentrymusic'}" SIZE=45 STYLE="width: 550">$gmfonttag</TD></TR></TABLE>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=RIGHT>$gmfonttag<b>Mood:</b></FONT></TD><TD ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="newentrymood" VALUE="$IN{'newentrymood'}" SIZE=45 STYLE="width: 550">$gmfonttag</TD></TR></TABLE>
<P>
<b>Main Entry Text</b>
<BR>
</FONT>
<table>
<tr valign="top">
$emoticonsmaincode
 <td><TEXTAREA NAME="newentrymaintext" COLS=86 ROWS=15 WRAP=VIRTUAL STYLE="width: 720">$IN{'newentrymaintext'}</TEXTAREA>
 <br />$inlineinstructions</td>
</tr>
</table>
$gmfonttag<P>
<b>Extended ("More") Entry Text&#151;Optional</b>
<BR>
</FONT>
<table>
<tr valign="top">
 $emoticonsmorecode
 <td><TEXTAREA NAME="newentrymoretext" COLS=86 ROWS=15 WRAP=VIRTUAL STYLE="width: 720">$IN{'newentrymoretext'}</TEXTAREA>
 </td>
</tr>
</table>
$gmfonttag<P>
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
<!--//
if ((parseInt(navigator.appVersion) >= 4) && (navigator.appName == "Microsoft Internet Explorer")) {
	document.write("<font size=1>Shortcut keys: CTRL-SHIFT-A to add a link, CTRL-SHIFT-B to bold selected text,<BR>CTRL-SHIFT-I to italicise, CTRL-SHIFT-U to underline</FONT><P>");
}
//-->
</SCRIPT>
<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0 WIDTH=716 BGCOLOR="#FFFFD0"><TR><TD VALIGN=TOP ALIGN=CENTER>$gmfonttag<b>Entry Options</b><BR><font size=1>If you wish to enable or disable karma voting and/or comment posting for this entry, you can specify it below (use Configuration to set whether those are on or off by default), unless you've disabled karma or comments altogether.  You can also specify whether to keep an entry permanently at the top of your main log (you can edit the entry later to turn that off).</FONT></FONT></TD></TR></TABLE></TD></TR></TABLE>
<P>

GMADDENTRYTOP

if (($allowkarmaorcomments eq Gm_Constants::KARMA) || ($allowkarmaorcomments eq Gm_Constants::BOTH)) {
	print qq(Allow karma voting on this entry: );

	println( Gm_Web::createRadioButton( name=>'newentryallowkarma', value=>Gm_Constants::YES,
		checked=>$allowkarmadefault ).' Yes ');
	println( Gm_Web::createRadioButton( name=>'newentryallowkarma', value=>Gm_Constants::NO,
		checked=>$allowkarmadefault ).' No ');
} else {
	print qq(<INPUT TYPE=HIDDEN NAME="newentryallowkarma" VALUE="no">\n);
}

if ($allowkarmaorcomments eq Gm_Constants::BOTH) { print "<BR>\n"; }

# emoticons options added by flipped cracker 9/17/2003
# merged in version 1.3
if (($emoticonsallowed eq Gm_Constants::ENTRIES) || ($emoticonsallowed eq Gm_Constants::BOTH)) {
	print qq(Allow emoticons to be used in this entry: <INPUT TYPE=RADIO NAME="newentryemoticonsallowed" VALUE="yes" CHECKED> Yes <INPUT TYPE=RADIO NAME="newentryemoticonsallowed" VALUE="no"> No\n<BR>\n);
} else {
	print qq(<INPUT TYPE=HIDDEN NAME="newentryemoticonsallowed" VALUE="no">\n);
}
#merged 9/17/2003

if (($allowkarmaorcomments eq Gm_Constants::COMMENTS) || ($allowkarmaorcomments eq Gm_Constants::BOTH)) {
	print qq(Allow comments to be posted to this entry: );
	
	println( Gm_Web::createRadioButton( name=>'newentryallowcomments', value=>Gm_Constants::YES,
		checked=>$allowcommentsdefault ).' Yes ');
	println( Gm_Web::createRadioButton( name=>'newentryallowcomments', value=>Gm_Constants::NO,
		checked=>$allowcommentsdefault ).' No ');
} else {
	print qq(<INPUT TYPE=HIDDEN NAME="newentryallowcomments" VALUE="no">\n);
}

print<<GMADDENTRYBOTTOM;

<BR>
Keep this entry at the top of the main log: <INPUT TYPE=RADIO NAME="newentrystayattop" VALUE="yes"> Yes <INPUT TYPE=RADIO NAME="newentrystayattop" VALUE="no" CHECKED> No
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Preview Before Posting"> <INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Add This Entry">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMADDENTRYBOTTOM

exit;

}

# -------------------------------
# add a new entry - popup version
# -------------------------------

sub gm_addentrypopup {

&gm_validate;

if (($gmentryaccess ne Gm_Constants::YES) || ($gmbookmarkletaccess ne Gm_Constants::YES)) {
	gm_writetocplog("$IN{'authorname'} attempted to add an entry via popup without authorization");
	$statusnote = qq(<b><font color="#FF0000">You don't have access to add entries via the popup window.</FONT></b><P>);
	&gm_frontpage;
}

&gm_readcounter;

if ($newentrynumber eq "0") {
	_checkIfDiagRun('<b><font color="#FF0000">Please run "Diagnostics & Repair" '.
		'in the Configuration screen before posting your first entry.</FONT></b><P>');
}

if ($statusnote eq Gm_Constants::EMPTY) {
	$statusnote = qq(<b><font color="#000000">Greymatter Pop-Up Posting Window</FONT></b><P>);
}

$popupincludetext = qq(<A HREF="$IN{'loglink'}">$IN{'loglinktitle'}</A>);

if ($IN{'logtext'} ne Gm_Constants::EMPTY) { $popupincludetext .= "\n\n$IN{'logtext'}"; }

if ($IN{'newentrysubject'} ne Gm_Constants::EMPTY) { $IN{'newentrysubject'} = Gm_Utils::toWebSafe($IN{'newentrysubject'}); }
if ($IN{'newentrymaintext'} ne Gm_Constants::EMPTY) {
	$IN{'newentrymaintext'} = Gm_Utils::toWebSafe($IN{'newentrymaintext'});
} else {
	$IN{'newentrymaintext'} = $popupincludetext;
}
if ($IN{'newentrymoretext'} ne Gm_Constants::EMPTY) { $IN{'newentrymoretext'} = Gm_Utils::toWebSafe($IN{'newentrymoretext'}); }


# emoticons code display added
&gm_emoticons_code;

my $inlineinstructions = '';
if( $inlineformatting eq Gm_Constants::ENTRIES || $inlineformatting eq Gm_Constants::BOTH ){
	$inlineinstructions = '<FONT SIZE=1>With "easy formatting", bold text, italics & underlining can be done easily by bracketing text with two **asterisks**, \\\\backslashes\\\\ or __underlines__ respectively.</FONT>';
}

print<<GMADDENTRYPOPUPTOP;

$gmheadtagtwo
$gmframetoptwo
$statusnote
<script language="JavaScript">
function commentEmoticonMain(code)
{
	var cache = document.entryadd.newentrymaintext.value;

	document.entryadd.newentrymaintext.value = cache + " " + code;
	document.entryadd.newentrymaintext.focus();
}
function commentEmoticonMore(code)
{
	var cache = document.entryadd.newentrymoretext.value;

	document.entryadd.newentrymoretext.value = cache + " " + code;
	document.entryadd.newentrymoretext.focus();
}
</script>
<FORM ACTION="gm.cgi" METHOD=POST name="entryadd">
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=HIDDEN NAME="gmbmspecial" VALUE="popupblog">
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=RIGHT>$gmfonttag<b>Subject:</b></FONT></TD><TD ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="newentrysubject" VALUE="$IN{'newentrysubject'}" SIZE=25 STYLE="width: 450">$gmfonttag</TD></TR></TABLE>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=RIGHT>$gmfonttag<b>Music:</b></FONT></TD><TD ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="newentrymusic" VALUE="$IN{'newentrymusic'}" SIZE=45 STYLE="width: 450">$gmfonttag</TD></TR></TABLE>
<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=RIGHT>$gmfonttag<b>Mood:</b></FONT></TD><TD ALIGN=LEFT></FONT><INPUT TYPE=TEXT CLASS="textinput" NAME="newentrymood" VALUE="$IN{'newentrymood'}" SIZE=45 STYLE="width: 450">$gmfonttag</TD></TR></TABLE>
<P>
<b>Main Entry Text</b>
<BR>
</FONT>
<table>
<tr valign="top">
$emoticonsmaincode
 <td><TEXTAREA NAME="newentrymaintext" COLS=50 ROWS=12 WRAP=VIRTUAL STYLE="width: 590">$IN{'newentrymaintext'}</TEXTAREA>
 <br />$inlineinstructions</td>
</tr>
</table>
$gmfonttag<P>
<b>Extended ("More") Entry Text&#151;Optional</b>
<BR>
</FONT>
<table>
<tr valign="top">
 $emoticonsmorecode
 <td><TEXTAREA NAME="newentrymoretext" COLS=50 ROWS=12 WRAP=VIRTUAL STYLE="width: 590">$IN{'newentrymoretext'}</TEXTAREA>
 </td>
</tr>
</table>
<P>
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript">
<!--//
if ((parseInt(navigator.appVersion) >= 4) && (navigator.appName == "Microsoft Internet Explorer")) {
	document.write("<font size=1>Shortcut keys: CTRL-SHIFT-A to add a link, CTRL-SHIFT-B to bold selected text,<BR>CTRL-SHIFT-I to italicise, CTRL-SHIFT-U to underline</FONT><P>");
}
//-->
</SCRIPT>
<P>

GMADDENTRYPOPUPTOP

if (($allowkarmaorcomments eq Gm_Constants::KARMA) || ($allowkarmaorcomments eq Gm_Constants::BOTH)) {
	print qq(Allow karma voting on this entry: );
	
	println( Gm_Web::createRadioButton( name=>'newentryallowkarma', value=>Gm_Constants::YES,
		checked=>$allowkarmadefault ).' Yes ');
	println( Gm_Web::createRadioButton( name=>'newentryallowkarma', value=>Gm_Constants::NO,
		checked=>$allowkarmadefault ).' No ');
} else {
	print qq(<INPUT TYPE=HIDDEN NAME="newentryallowkarma" VALUE="no">\n);
}

if ($allowkarmaorcomments eq Gm_Constants::BOTH) { print "<BR>\n"; }

# emoticons options added by flipped cracker 9/17/2003
# merged in version 1.3
if (($emoticonsallowed eq Gm_Constants::ENTRIES) || ($emoticonsallowed eq Gm_Constants::BOTH)) {
	print qq(Allow emoticons to be used in this entry: <INPUT TYPE=RADIO NAME="newentryemoticonsallowed" VALUE="yes" CHECKED> Yes <INPUT TYPE=RADIO NAME="newentryemoticonsallowed" VALUE="no"> No\n<BR>\n);
} else {
	print qq(<INPUT TYPE=HIDDEN NAME="newentryemoticonsallowed" VALUE="no">\n);
}

if (($allowkarmaorcomments eq Gm_Constants::COMMENTS) || ($allowkarmaorcomments eq Gm_Constants::BOTH)) {
	print qq(Allow comments to be posted to this entry: );
	
	println( Gm_Web::createRadioButton( name=>'newentryallowcomments', value=>Gm_Constants::YES,
		checked=>$allowcommentsdefault ).' Yes ');
	println( Gm_Web::createRadioButton( name=>'newentryallowcomments', value=>Gm_Constants::NO,
		checked=>$allowcommentsdefault ).' No ');
} else {
	print qq(<INPUT TYPE=HIDDEN NAME="newentryallowcomments" VALUE="no">\n);
}

print<<GMADDENTRYPOPUPBOTTOM;

<BR>
Keep this entry at the top of the main log: <INPUT TYPE=RADIO NAME="newentrystayattop" VALUE="yes"> Yes <INPUT TYPE=RADIO NAME="newentrystayattop" VALUE="no" CHECKED> No
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Preview Before Posting"> <INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Add This Entry">
</FORM>
$gmframebottomtwo

</BODY>
</HTML>

GMADDENTRYPOPUPBOTTOM

exit;

}

# ----------------------------
# preview entry before posting
# ----------------------------
## DEPRECATED BY: viewPreview in gm.cgi
sub gm_previewentry {
	die( "gm_previewentry has been DEPRECATED");
}

# ------------------
# save the new entry
# ------------------

sub gm_savenewentry {

&gm_validate;
&gm_readconfig;
&gm_readtemplates;

if ($gmentryaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to add an entry without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to add entries.</FONT></B><P>);
	&gm_frontpage;
}

$IN{'newentrysubject'} = Gm_Utils::toStoreSafe($IN{'newentrysubject'});
$IN{'newentrysubject'} = Gm_Utils::toConfigSafe($IN{'newentrysubject'});
$IN{'newentrymaintext'} = Gm_Utils::toStoreSafe($IN{'newentrymaintext'});
$IN{'newentrymoretext'} = Gm_Utils::toStoreSafe($IN{'newentrymoretext'});
$IN{'newentrymusic'} = Gm_Utils::toStoreSafe($IN{'newentrymusic'});
$IN{'newentrymood'} = Gm_Utils::toStoreSafe($IN{'newentrymood'});

if ($IN{'newentrymaintext'} eq Gm_Constants::EMPTY) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You left the main text field blank.  Please try again.</FONT></B><P>);
	if ($IN{'gmbmspecial'} eq "popupblog") { &gm_addentrypopup; } else { &gm_addentry; }
}

&gm_readcounter;

$newentrynumber++;

# $newentrynumberpadded = sprintf ("%8d", $newentrynumber);
# $newentrynumberpadded =~ tr/ /0/;
$newentrynumberpadded = Gm_Utils::toEntryPadded( $newentrynumber ); 

&gm_readconfig;
my ($basedate, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
	Gm_Utils::getStdDate( $serveroffset );
my $shortyear = substr($JSYear, -2, 2);
	
my $montwo = Gm_Utils::toTwoDigit( $mon );
my $mdaytwo = Gm_Utils::toTwoDigit( $mday );
my $hourtwo = Gm_Utils::toTwoDigit( $hour );
my $mintwo = Gm_Utils::toTwoDigit( $min );

## Note that this is file storage specific bit of code.  We must check somehow
# but really we don't want to overwrite a file
# open (CHECKIT, "<$EntriesPath/$newentrynumberpadded.cgi") || ($numbercheck="good");
# @gmchecklistor = <CHECKIT>;
# if(@gmchecklistor[0] =~ /\|/) {$numbercheck="bugger";}
# close (CHECKIT);
# if($numbercheck eq "bugger") {
# 	gm_dangermouse("Fatal Error, gm-counter likely to be disrupted. Please run a Diagnostics & Repair."); 
# 	exit;
# } else {
# 	unlink ("$EntriesPath/$newentrynumberpadded.cgi");
# }

## TODO FIX THIS SO THAT ITS A STORAGE FUNCTION
# open (FUNNYFEET, ">$EntriesPath/$newentrynumberpadded.cgi") || &gm_dangermouse("Can't write to $EntriesPath/$newentrynumberpadded.cgi.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# print FUNNYFEET "$newentrynumber|$IN{'authorname'}|$IN{'newentrysubject'}|$wday|$mon|$mday|$JSYear|$hour|$min|$sec|$AMPM|0|0|0|$IN{'newentryallowkarma'}|$IN{'newentryallowcomments'}|open|$IN{'newentrymusic'}|$IN{'newentrymood'}|$IN{'newentryemoticonsallowed'}\n";
# print FUNNYFEET "0.0.0.0|I\n";
# print FUNNYFEET "$IN{'newentrymaintext'}\n";
# print FUNNYFEET "$IN{'newentrymoretext'}\n";
# close (FUNNYFEET);
# chmod (0666, "$EntriesPath/$newentrynumberpadded.cgi");
my %gmEntry = ();
$gmEntry{'entryinfo'}{'id'} = $newentrynumber;
$gmEntry{'entryinfo'}{'author'} = $IN{'authorname'};
$gmEntry{'entryinfo'}{'subject'} = $IN{'newentrysubject'};
$gmEntry{'entryinfo'}{'weekday'} = $wday;
$gmEntry{'entryinfo'}{'month'} = $mon;
$gmEntry{'entryinfo'}{'day'} = $mday;
$gmEntry{'entryinfo'}{'year'} = $JSYear;
$gmEntry{'entryinfo'}{'hour'} = $hour;
$gmEntry{'entryinfo'}{'minute'} = $min;
$gmEntry{'entryinfo'}{'second'} = $sec;
$gmEntry{'entryinfo'}{'ampm'} = $AMPM;
$gmEntry{'entryinfo'}{'karmapos'} = 0;
$gmEntry{'entryinfo'}{'karmaneg'} = 0;
$gmEntry{'entryinfo'}{'commenttotal'} = 0;
$gmEntry{'entryinfo'}{'karma'} = $IN{'newentryallowkarma'};
$gmEntry{'entryinfo'}{'comments'} = $IN{'newentryallowcomments'};
$gmEntry{'entryinfo'}{'status'} = Gm_Constants::OPEN;
$gmEntry{'entryinfo'}{'music'} = $IN{'newentrymusic'};
$gmEntry{'entryinfo'}{'mood'} = $IN{'newentrymood'};
$gmEntry{'entryinfo'}{'emoticons'} = $IN{'newentryemoticonsallowed'};
$gmEntry{'karmavotes'} = { '0.0.0.0' => 'I' };
$gmEntry{'maintext'} = $IN{'newentrymaintext'};
$gmEntry{'extendedtext'} = $IN{'newentrymoretext'};
$gmEntry{'comments'} = [];
Gm_Storage::setEntry( entry=>\%gmEntry, 'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );

$newentrytempmorestatus = Gm_Constants::N;
if ($IN{'newentrymoretext'} ne Gm_Constants::EMPTY) { $newentrytempmorestatus = Gm_Constants::Y; }

my %newentry = ();
$newentry{'id'} = $newentrynumber;
$newentry{'author'} = $IN{'authorname'};
$newentry{'subject'} = $IN{'newentrysubject'};
$newentry{'created'} = "$montwo\/$mdaytwo\/$shortyear";
$newentry{'createt'} = "$hourtwo\:$mintwo $AMPM";
$newentry{'status'} = 'O';  ## TODO, SHOULD BE CONSTANT OR STANDARD
$newentry{'extended'} = $newentrytempmorestatus;
$newentry{'music'} = $IN{'newentrymusic'};
$newentry{'mood'} = $IN{'newentrymood'};
$newentry{'emoticons'} = $IN{'newentryemoticonsallowed'};

Gm_Storage::addEntrylist( %newentry, errHandler=>\&Gm_Web::displayAdminErrorExit );


if ($IN{'newentrystayattop'} eq Gm_Constants::YES) { $newstayattopnumber = $newentrynumber; }

$newalltimeopenentriesnumber++;

&gm_writecounter;

if ($generateentrypages eq Gm_Constants::YES) {

	&gm_readconfig;
#	&gm_getentryvariables($newentrynumber);
	$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
  	errHandler=>\&Gm_Web::displayAdminErrorExit );
	if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
		if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 			&gm_formatentry($gmmoreentrypagetemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		} else {
# 			&gm_formatentry($gmentrypagetemplate);
			$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
				template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
		}
# 		open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write file to $EntriesPath/$thisentrynumberpadded.$entrysuffix - please run Diagnostics & Repair in the Configuration screen.");
# 		print THISFILE $entryreturn;
# 		close (THISFILE);
# 		chmod (0666, "$EntriesPath/$newentrynumberpadded.$entrysuffix");
		Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
			content=>[$entryreturn],'new'=>1, ch_mod=>'0666', 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	} else {
		unlink( "$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix" );
	}

	if ($newentrynumber ne '1') {
		$updatepreviousnumber = $newentrynumber - 1;
# 		&gm_getentryvariables($updatepreviousnumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$updatepreviousnumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );

		if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
			if ($updatepreviousnumber <= $newarchivenumber) {
				if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 					&gm_formatentry($gmmorearchiveentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmmorearchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
				} else {
# 					&gm_formatentry($gmarchiveentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmarchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
				}
			} else {
				if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 					&gm_formatentry($gmmoreentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
				} else {
# 					&gm_formatentry($gmentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
				}
			}
# 			open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write file to $EntriesPath/$thisentrynumberpadded.$entrysuffix - please run Diagnostics & Repair in the Configuration screen.");
# 			print THISFILE $entryreturn;
# 			close (THISFILE);
# 			chmod (0666, "$EntriesPath/$newentrynumberpadded.$entrysuffix");
			Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
				content=>[$entryreturn], ch_mod=>'0666', 
				errHandler=>\&Gm_Web::displayAdminErrorExit );			
		} else {
			unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
		}
	}

}
  
&gm_generatemainindex;

&gm_readcounter;

if (($newarchivenumber ne '0') || ($concurrentmainandarchives eq Gm_Constants::YES)) {
	if (($generateentrypages eq Gm_Constants::YES) && ($newarchivenumber ne '0')) {
# 		&gm_getentryvariables($newarchivenumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
		$originaldaymarker = "$entryVars->{'thisentryday'} $entryVars->{'thisentrymonth'}";
		$currentdaymarker = $originaldaymarker;
		$markercount = $newarchivenumber;
		do {
			if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
				if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 					&gm_formatentry($gmmorearchiveentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmmorearchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
				} else {
# 					&gm_formatentry($gmarchiveentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmarchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
				}
# 				open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write file to $EntriesPath/$thisentrynumberpadded.$entrysuffix - please run Diagnostics & Repair in the Configuration screen.");
# 				print THISFILE $entryreturn;
# 				close (THISFILE);
# 				chmod (0666, "$EntriesPath/$newentrynumberpadded.$entrysuffix");
				Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
					content=>[$entryreturn], ch_mod=>'0666', 
					errHandler=>\&Gm_Web::displayAdminErrorExit );	
			} else {
				unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
			}
			$markercount--;
			if ($markercount eq '0') {
				$currentdaymarker = "finis";
			} else {
# 				&gm_getentryvariables($markercount);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$markercount, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
				$currentdaymarker = "$entryVars->{'thisentryday'} $entryVars->{'thisentrymonth'}";
			}		
		} until $currentdaymarker ne $originaldaymarker;
	}

	if ($concurrentmainandarchives eq Gm_Constants::YES) { $newarchivenumber = $newentrynumber; }
	unless ($keepmonthlyarchives eq Gm_Constants::NO) { &gm_generatearchive($newarchivenumber); }
	&gm_readcounter;

}

if ($keeparchivemasterindex eq Gm_Constants::YES) {
	if ($newarchivenumber ne '0') {
# 		&gm_getentryvariables($newarchivenumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	} else {
# 		&gm_getentryvariables($newentrynumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	}
# 	&gm_formatentry($gmarchivemasterindextemplate);
	$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
		template=>$gmarchivemasterindextemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);	
# 	open (THISFILE, ">$EntriesPath/$indexfilename") || &gm_dangermouse("Can't write to $EntriesPath/$indexfilename.  Please make sure your paths are configured correctly, that the entries/archives directory is CHMODed to 777, and that $EntriesPath/$indexfilename is CHMODed to 666; also try running Diagnostics & Repair from the Configuration screen.");
# 	print THISFILE $entryreturn;
# 	close (THISFILE);
# 	chmod (0666, "$EntriesPath/$indexfilename");
	Gm_Storage::saveFile( loc=>"$EntriesPath/$indexfilename", 
		content=>[$entryreturn], ch_mod=>'0666', 
		errHandler=>\&Gm_Web::displayAdminErrorExit );
}

my $gmauthors = Gm_Storage::getAuthors( errHandler=>\&Gm_Web::displayAdminErrorExit );
my $selectedauthor = $gmauthors->{$IN{'authorname'}};

my $authorEntries = $selectedauthor->{'posttotal'}++;

Gm_Storage::updateAuthor( key=>$selectedauthor->{'author'}, 
		posttotal=>$authorEntries, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );

$recordentrysubject = $IN{'newentrysubject'};
if ($recordentrysubject eq Gm_Constants::EMPTY) { $recordentrysubject = "[no subject]"; }

if ($IN{'gmbmspecial'} eq "popupblog") {
	gm_writetocplog("$IN{'authorname'} added a new entry (#$newentrynumber\: $recordentrysubject) via popup");
} else {
	gm_writetocplog("$IN{'authorname'} added a new entry (#$newentrynumber\: $recordentrysubject)");
}

if (($otherfilelist ne Gm_Constants::EMPTY) && ($otherfilelistentryrebuild eq Gm_Constants::YES) && ($IN{'gmbmspecial'} ne "popupblog")) {
	$IN{'rebuilding'} = "connectedaftersave";
	$IN{'rebuildfrom'} = "connected";
	&gm_rebuildupdate;
}

if ($IN{'gmbmspecial'} eq "popupblog") {

$indexfilenamesmartcheck = "/$indexfilename";
$indexfilenameprefix = substr($indexfilename, 0, 6);
if ($indexfilenameprefix eq "index.") { $indexfilenamesmartcheck = "/"; }

print<<GMPOPUPNOTICE;

$gmheadtag

$gmframetoptwo<B><FONT COLOR="#0000FF">Your new entry has been added to <A HREF="$LogWebPath$indexfilenamesmartcheck" TARGET="NEW"><FONT COLOR="#0000FF">your site</FONT></A>.</FONT></B><P><A HREF="javascript:window.close();">Click here to close this window.</A>$gmframebottomtwo

</BODY>
</HTML>

GMPOPUPNOTICE

exit;

}

$statusnote = qq(<B><FONT COLOR="#0000FF">Your new entry has been added.</FONT></B><P>);
&gm_frontpage;

}

# ------------------
# rebuild files menu
# ------------------

sub gm_rebuildfilesmenu {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the files without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the files.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readcounter;

if ($newentrynumber eq "0") {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no entries yet!</FONT></B><P>);
	&gm_frontpage;
}

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=380><TR><TD VALIGN=MIDDLE ALIGN=CENTER>$gmfonttag<B><FONT COLOR="#000000">Rebuild Files</FONT></B><BR><FONT SIZE=1>If you've made any changes that will have a visible impact on your site (such as changing the templates, closing/reopening an entry, etc), you may want to rebuild the relevant files so that the changes will be immediately visible&#151;note that whenever you add a new entry, Greymatter automatically updates the relevant files.</FONT></TD></TR></TABLE><P>); }

$rebuildconnectedfilesbutton = Gm_Constants::EMPTY;

if ($otherfilelist ne Gm_Constants::EMPTY) {
	$rebuildconnectedfilesbutton = qq(<P>\n<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Connected Files" STYLE="width: 320">);
}

print<<GMREBUILDMENU;

$gmheadtag

$gmframetop
$statusnote
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Last Entry Page Only" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Main Index File" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Main Entry Pages" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Archive Master Index" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Archive Log Indexes" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild Archive Entry Pages" STYLE="width: 320">
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Rebuild All Entry Pages" STYLE="width: 320">
$rebuildconnectedfilesbutton
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Rebuild Everything" STYLE="width: 320">
<P>
<FONT SIZE=1>
After clicking, expect a wait of up to several minutes, depending<BR>on how much is being rebuilt.  <B>DO NOT INTERRUPT GREYMATTER</B><BR>while it's rebuilding, or you could damage your files.
</FONT>
<P>
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
<P>
$gmframebottom

</BODY>
</HTML>

GMREBUILDMENU

$statusnote = Gm_Constants::EMPTY;

exit;

}

# ---------------------------
# rebuild the main index file
# ---------------------------

sub gm_rebuildmainindexfile {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the main index file without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the main index file.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readcounter;

if ($newentrynumber eq "0") {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no entries yet.</FONT></B><P>);
	&gm_frontpage;
}

&gm_generatemainindex;

gm_writetocplog("$IN{'authorname'} rebuilt the main index file");

if ($IN{'autorebuild'} eq "index") {
	$statusnote = qq(<B><FONT COLOR="#0000FF">The $IN{'modifiedtemplategroup'} templates have been<BR>modified and the main index file has been rebuilt.</FONT></B><P>);
	&gm_edittemplates;
} else {
	$statusnote = qq(<B><FONT COLOR="#0000FF">The main index file has been rebuilt.</FONT></B><P>);
	&gm_frontpage;
}

}

# ----------------------------
# rebuild last entry page only
# ----------------------------

sub gm_rebuildlastentrypageonly {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the last entry page without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the last entry page.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;

if ($generateentrypages ne Gm_Constants::YES) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Entry page generation is currently disabled.</FONT></B><P>);
	&gm_rebuildfilesmenu;
}

&gm_readcounter;
&gm_readtemplates;

if ($newentrynumber eq '0') {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no entries yet.</FONT></B><P>);
	&gm_frontpage;
}

# &gm_getentryvariables($newentrynumber);
$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );
## TODO: THIS IS ALL OVER THE PLACE
if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
	if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 		&gm_formatentry($gmmoreentrypagetemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
	} else {
# 		&gm_formatentry($gmentrypagetemplate);
		$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);
	}
# 	open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write to $EntriesPath/$thisentrynumberpadded.$entrysuffix.  Please make sure that your entries/archives directory is configured correctly and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# 	print THISFILE $entryreturn;
# 	close (THISFILE);
# 	chmod (0666, "$EntriesPath/$thisentrynumberpadded.$entrysuffix");
Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
	content=>[$entryreturn], 'new'=>1, ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit );
} else {
	unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
}

gm_writetocplog("$IN{'authorname'} rebuilt the last entry page");

$statusnote = qq(<B><FONT COLOR="#0000FF">The last entry page has been rebuilt.</FONT></B><P>);
&gm_frontpage;

}

# ------------------------
# rebuild main entry files
# ------------------------

sub gm_rebuildmainentrypages {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the main entry pages without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the main entry pages.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;

if ($generateentrypages ne Gm_Constants::YES) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Entry page generation is currently disabled.</FONT></B><P>);
	&gm_rebuildfilesmenu;
}

&gm_readcounter;
&gm_readtemplates;

if ($newentrynumber eq '0') {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no entries yet.</FONT></B><P>);
	&gm_frontpage;
}

$IN{'rebuilding'} = "mainentries";
$IN{'rebuildfrom'} = $newarchivenumber + 1;

&gm_rebuildupdate;

}

# ----------------------------
# rebuild archive master index
# ----------------------------

sub gm_rebuildarchivemasterindex {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the archive master index without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the archive master index.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

if ($keeparchivemasterindex eq Gm_Constants::NO) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">"Keep archive master index" is currently disabled.</FONT></B><P>);
	&gm_frontpage;
}

if ($newarchivenumber ne '0') {
# 	&gm_getentryvariables($newarchivenumber);
	$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );
} else {
# 	&gm_getentryvariables($newentrynumber);
	$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );
}

# &gm_formatentry($gmarchivemasterindextemplate);
$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
	template=>$gmarchivemasterindextemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);

# open (THISFILE, ">$EntriesPath/$indexfilename") || &gm_dangermouse("Can't write to $EntriesPath/$indexfilename.  Please make sure your paths are configured correctly, that the entries/archives directory is CHMODed to 777, and that $EntriesPath/$indexfilename is CHMODed to 666; also try running Diagnostics & Repair from the Configuration screen.");
# print THISFILE $entryreturn;
# close (THISFILE);
# chmod (0666, "$EntriesPath/$indexfilename");
Gm_Storage::saveFile( loc=>"$EntriesPath/$indexfilename", content=>[$entryreturn], 
	'new'=>1, ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit );

gm_writetocplog("$IN{'authorname'} rebuilt the archive master index");

$statusnote = qq(<B><FONT COLOR="#0000FF">The archive master index has been rebuilt.</FONT></B><P>);
&gm_frontpage;

}

# ---------------------------
# rebuild archive log indexes
# ---------------------------

sub gm_rebuildarchivelogindexes {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the archive log indexes without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the archive log indexes.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

# TODO: SAME LOGIC AS gm_rebuildarchivemasterindex WHY DUPLICATE
if (($IN{'autorebuild'} eq 'archiveindexes') && ($keeparchivemasterindex ne Gm_Constants::NO)) {
	if ($newarchivenumber ne '0') {
# 		&gm_getentryvariables($newarchivenumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	} else {
# 		&gm_getentryvariables($newentrynumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	}
# 	&gm_formatentry($gmarchivemasterindextemplate); 
	$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
		template=>$gmarchivemasterindextemplate, errHandler=>\&Gm_Web::displayAdminErrorExit);

# 	open (THISFILE, ">$EntriesPath/$indexfilename") || &gm_dangermouse("Can't write to $EntriesPath/$indexfilename.  Please make sure your paths are configured correctly, that the entries/archives directory is CHMODed to 777, and that $EntriesPath/$indexfilename is CHMODed to 666; also try running Diagnostics & Repair from the Configuration screen.");
# 	print THISFILE $entryreturn;
# 	close (THISFILE);
	Gm_Storage::saveFile( loc=>"$EntriesPath/$indexfilename", content=>[$entryreturn], 
		'new'=>1, ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit );
}

if ($keepmonthlyarchives eq Gm_Constants::NO) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Log archives are currently disabled.</FONT></B><P>);
	if ($IN{'autorebuild'} eq "archiveindexes") {
		$statusnote = qq(<B><FONT COLOR="#FF0000">The $IN{'modifiedtemplategroup'} templates have been modified.</FONT></B><P>);
	}
	&gm_frontpage;
}

if (($newarchivenumber eq "0") && ($concurrentmainandarchives ne Gm_Constants::YES)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no archive log indexes yet.</FONT></B><P>);
	if ($IN{'autorebuild'} eq "archiveindexes") {
		$statusnote = qq(<B><FONT COLOR="#FF0000">The $IN{'modifiedtemplategroup'} templates have been modified.</FONT></B><P>);
	}
	&gm_frontpage;
}

unlink glob("$EntriesPath/archive-*.$entrysuffix");
unlink glob("$EntriesPath/archive-*.$logarchivesuffix");

if ($concurrentmainandarchives eq Gm_Constants::YES) { $newarchivenumber = $newentrynumber; }

$stoppednumber = $newarchivenumber;
do { 
	&gm_generatearchive($stoppednumber); 
} until $stoppednumber <= 1;
if( $gmneedstogeneratefirstarchive ){ &gm_generatearchive(1); }
			
gm_writetocplog("$IN{'authorname'} rebuilt the archive log indexes");

if ($IN{'autorebuild'} eq "archiveindexes") {
	$statusnote = qq(<B><FONT COLOR="#0000FF">The $IN{'modifiedtemplategroup'} templates have been<BR>modified and the archive indexes have been rebuilt.</FONT></B><P>);
	&gm_edittemplates;
} else {
	$statusnote = qq(<B><FONT COLOR="#0000FF">The archive log indexes have been rebuilt.</FONT></B><P>);
	&gm_frontpage;
}

}

# ---------------------------
# rebuild archive entry pages
# ---------------------------

sub gm_rebuildarchiveentrypages {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the archive entry pages without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the archive entry pages.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

if ($newarchivenumber eq '0') {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no archives yet.</FONT></B><P>);
	&gm_frontpage;
}

if ($generateentrypages eq Gm_Constants::NO) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Entry page generation is currently disabled.</FONT></B><P>);
	&gm_rebuildfilesmenu;
}

$IN{'rebuilding'} = "archivefiles";
$IN{'rebuildfrom'} = "1";

&gm_rebuildupdate;

}

# -----------------------
# rebuild all entry pages
# -----------------------

sub gm_rebuildallentrypages {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the entry pages without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the entry pages.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;

if ($generateentrypages ne Gm_Constants::YES) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">Entry page generation is currently disabled.</FONT></B><P>);
	&gm_rebuildfilesmenu;
}

&gm_readcounter;
&gm_readtemplates;

if ($newentrynumber eq "0") {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no entries yet.</FONT></B><P>);
	&gm_frontpage;
}

unlink glob("$EntriesPath/archive-*.$entrysuffix");

$IN{'rebuilding'} = "entryfiles";
$IN{'rebuildfrom'} = "1";

&gm_rebuildupdate;

}

# -------------------------------
# rebuild connected files - check
# -------------------------------

sub gm_rebuildconnectedfilescheck {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild the connected files without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild the connected files.</FONT></B><P>);
	&gm_frontpage;
}

if ($otherfilelist eq Gm_Constants::EMPTY) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">There are no connected files to rebuild.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

$IN{'rebuilding'} = "connected";
$IN{'rebuildfrom'} = "connected";

&gm_rebuildupdate;

}

# ------------------
# rebuild everything
# ------------------

sub gm_rebuildeverything {

&gm_validate;

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild all the files without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild all the files.</FONT></B><P>);
	&gm_frontpage;
}

unlink glob("$EntriesPath/*.reg");
unlink glob("$EntriesPath/archive-*.$entrysuffix");
unlink glob("$EntriesPath/archive-*.$logarchivesuffix");

$IN{'rebuilding'} = "everything";
$IN{'rebuildfrom'} = "index";

&gm_rebuildupdate;

}

# ------------------------------
# edit an entry - selection menu
# ------------------------------
# DEPRECATED BY: viewEntryList in gm.cgi
sub gm_editentryselection {
	die( "gm_editentryselection has been DEPRECATED");
}

# ------------------------------------
# editing entries - search and replace
# ------------------------------------
## DEPRECATED BY: viewSearchAndReplace in gm.cgi
sub gm_editentrysearchandreplace {
	die( "gm_editentrysearchandreplace has been DEPRECATED");
}

# --------------------------
# perform search and replace
# --------------------------
## TODO: THIS SHOULD DO A REBUILD ONCE ITS DONE, HAVE TO MANUALLY REBUILD
## DEPRECATED BY: entrySearchAndReplace in gm.cgi
sub gm_performsearchandreplace {
	die( "gm_performsearchandreplace has been DEPRECATED");
}

# -----------------------------------
# edit an entry - main editing screen
# -----------------------------------
# TODO: REFACTOR THIS, ADD NEW, AND ADD POPUP INTO ONE
## DEPRECATED BY: viewEntry in gm.cgi
sub gm_editthisentry {
	die( "gm_editthisentry has been DEPRECATED");
}

# ----------------------------
# save changes to edited entry
# ----------------------------
# DEPRECATED BY: editEntry in gm.cgi
sub gm_saveentrychanges {
 	die( "gm_saveentrychanges has been DEPRECATED");
}

# ------------------------
# change entry open status
# ------------------------
# DEPRECATED BY: changeEntryStatus in gm.cgi
sub gm_changeentryopenstatus {
	die( "gm_changeentryopenstatus has been DEPRECATED");
}

# -----------------------
# delete selected comment
# -----------------------
# DEPRECATED BY: deleteEntryComments in gm.cgi
sub gm_deleteselectedcomment {
	die( "gm_deleteselectedcomment has been DEPRECATED");
}

# -----------------------
# delete all selected comments
# -----------------------
# DEPRECATED BY: deleteEntryComments in gm.cgi
sub gm_DeleteAllSelectedComments {
	die( "gm_DeleteAllSelectedComments has been DEPRECATED");
}

# ---------------------
# edit selected comment
# ---------------------
# DEPRECATED BY: viewEntryComment in gm.cgi
sub gm_editselectedcomment {
	die( "gm_editselectedcomment has been DEPRECATED");
}

# --------------------
# save comment changes
# --------------------
# DEPRECATED BY: updateEntryComment in gm.cgi
sub gm_savecommentchanges {
	die( "gm_savecommentchanges has been DEPRECATED");
}

# ------------------------
# save config file for D&R
# ------------------------

sub gm_saveconfigurationdr {

&gm_validate;

if ($gmconfigurationaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to save changes to the config file without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to change the config file.</FONT></B><P>);
	&gm_frontpage;
}

chomp ($IN{'editedcensorlist'});
$IN{'editedcensorlist'} = Gm_Utils::toStoreSafe($IN{'editedcensorlist'});
chomp ($IN{'editedotherfilelist'});
$IN{'editedotherfilelist'} = Gm_Utils::toStoreSafe($IN{'editedotherfilelist'});

$IN{'editedlogpath'} = Gm_Utils::toConfigSafe($IN{'editedlogpath'});
$IN{'editedentriespath'} = Gm_Utils::toConfigSafe($IN{'editedentriespath'});
$IN{'editedlogwebpath'} = Gm_Utils::toConfigSafe($IN{'editedlogwebpath'});
$IN{'editedentrieswebpath'} = Gm_Utils::toConfigSafe($IN{'editedentrieswebpath'});
$IN{'editednotifyemail'} = Gm_Utils::toConfigSafe($IN{'editednotifyemail'});
$IN{'editedindexfilename'} = Gm_Utils::toConfigSafe($IN{'editedindexfilename'});
$IN{'editedentrysuffix'} = Gm_Utils::toConfigSafe($IN{'editedentrysuffix'});
$IN{'editedindexdays'} = Gm_Utils::toConfigSafe($IN{'editedindexdays'});
$IN{'editedoffsettime'} = Gm_Utils::toConfigSafe($IN{'editedoffsettime'});
$IN{'editedtimezone'} = Gm_Utils::toConfigSafe($IN{'editedtimezone'});
$IN{'editedmailprog'} = Gm_Utils::toConfigSafe($IN{'editedmailprog'});
$IN{'editedcgilocalpath'} = Gm_Utils::toConfigSafe($IN{'editedcgilocalpath'});
$IN{'editedcgiwebpath'} = Gm_Utils::toConfigSafe($IN{'editedcgiwebpath'});
$IN{'editedemoticonspath'} = Gm_Utils::toConfigSafe($IN{'editedemoticonspath'});
$IN{'editedentrylistcountnumber'} = Gm_Utils::toConfigSafe($IN{'editedentrylistcountnumber'});
$IN{'editedlogarchivesuffix'} = Gm_Utils::toConfigSafe($IN{'editedlogarchivesuffix'});

$IN{'editedcensorlist'} =~ s/^\s+//;
$IN{'editedcensorlist'} =~ s/\s+$//;
$IN{'editedotherfilelist'} =~ s/^\s+//;
$IN{'editedotherfilelist'} =~ s/^\s+//;

$IN{'editedentrysuffix'} =~ s/\.//g;
$IN{'editednotifyemail'} =~ s/ //g;
$IN{'editedlogarchivesuffix'} =~ s/\.//g;

if (($IN{'editedlogpath'} eq Gm_Constants::EMPTY) || ($IN{'editedentriespath'} eq Gm_Constants::EMPTY) || ($IN{'editedlogwebpath'} eq Gm_Constants::EMPTY) || ($IN{'editedentrieswebpath'} eq Gm_Constants::EMPTY) || ($IN{'editedindexfilename'} eq Gm_Constants::EMPTY) || ($IN{'editedentrysuffix'} eq Gm_Constants::EMPTY) || ($IN{'editedindexdays'} eq Gm_Constants::EMPTY) || ($IN{'editedoffsettime'} eq Gm_Constants::EMPTY) || ($IN{'editedtimezone'} eq Gm_Constants::EMPTY) || ($IN{'editedcgilocalpath'} eq Gm_Constants::EMPTY) || ($IN{'editedcgiwebpath'} eq Gm_Constants::EMPTY) || ($IN{'editedentrylistcountnumber'} eq Gm_Constants::EMPTY) || ($IN{'editedlogarchivesuffix'} eq Gm_Constants::EMPTY)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You left one or more of the required fields blank.  Please try again.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editedindexdays'} =~ /\D/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">"Days to keep on main index" must be a number.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editedoffsettime'} =~ /\D/) {
	unless ($IN{'editedoffsettime'} =~ /-/) {
		$statusnote = qq(<B><FONT COLOR="#FF0000">"Server Offset Time" must be a number.</FONT></B><P>);
		&gm_configuration;
	}
}

if ($IN{'editeduploadfilesizelimit'} eq Gm_Constants::EMPTY) { $IN{'editeduploadfilesizelimit'} = 0; }

if ($IN{'editeduploadfilesizelimit'} =~ /\D/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">"Maximum Filesize Allowed" must be a number.</FONT></B><P>);
	&gm_configuration;
}

if (($IN{'editednotifyemail'} ne Gm_Constants::EMPTY) && ($IN{'editedmailprog'} eq Gm_Constants::EMPTY)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You must give your server's e-mail program location<BR>if you're going to have e-mail notification enabled.</FONT></B><P>);
	&gm_configuration;
}

if (($IN{'editednotifyemail'} eq Gm_Constants::EMPTY) && ($IN{'editednotifyforstatus'} ne Gm_Constants::NEITHER)) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">You must give an e-mail address to receive e-mail notifications.</FONT></B><P>);
	&gm_configuration;
}

if ($IN{'editedentrylistcountnumber'} =~ /\D/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">"Log entry list variable number" must be a number.</FONT></B><P>);
	&gm_configuration;
}

$IN{'editeduploadfilesallowed'} =~ s/;/SEMICOLON/g;

if ($IN{'editeduploadfilesallowed'} =~ /\W/) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">"Allowed File Types" must only contain alphanumeric characters (besides semicolons).</FONT></B><P>);
	&gm_configuration;
}

$IN{'editeduploadfilesallowed'} =~ s/SEMICOLON/;/g;

if ($IN{'editedindexdays'} < 1) {
	$statusnote = qq(<B><FONT COLOR="#FF0000">"Days to keep on main index" must be set to at least one!</FONT></B><P>);
	&gm_configuration;
}

if (substr($IN{'editedlogpath'}, -1) eq "/") { chop ($IN{'editedlogpath'}) };
if (substr($IN{'editedentriespath'}, -1) eq "/") { chop ($IN{'editedentriespath'}) };
if (substr($IN{'editedcgilocalpath'}, -1) eq "/") { chop ($IN{'editedcgilocalpath'}) };
if (substr($IN{'editedlogwebpath'}, -1) eq "/") { chop ($IN{'editedlogwebpath'}) };
if (substr($IN{'editedentrieswebpath'}, -1) eq "/") { chop ($IN{'editedentrieswebpath'}) };
if (substr($IN{'editedcgiwebpath'}, -1) eq "/") { chop ($IN{'editedcgiwebpath'}) };
if (substr($IN{'editedemoticonspath'}, -1) eq "/") { chop ($IN{'editedemoticonspath'}) };

my %confs = ();
$confs{'gmlogpath'} = $IN{'editedlogpath'};
$confs{'gmentriespath'} = $IN{'editedentriespath'};
$confs{'gmlogwebpath'} = $IN{'editedlogwebpath'};
$confs{'gmentrieswebpath'} = $IN{'editedentrieswebpath'};
$confs{'gmnotifyemail'} = $IN{'editednotifyemail'};
$confs{'gmindexfilename'} = $IN{'editedindexfilename'};
$confs{'gmentrysuffix'} = $IN{'editedentrysuffix'};
$confs{'gmindexdays'} = $IN{'editedindexdays'};
$confs{'gmserveroffset'} = $IN{'editedoffsettime'};
$confs{'gmtimezone'} = $IN{'editedtimezone'};
$confs{'gmkeeplog'} = $IN{'editedkeeplog'};
$confs{'gmposttoarchives'} = $IN{'editedposttoarchives'};
$confs{'gmallowkarmadefault'} = $IN{'editedallowkarmadefault'};
$confs{'gmallowcommentsdefault'} = $IN{'editedallowcommentsdefault'};
$confs{'gmcommentsorder'} = $IN{'editedcommentsorder'};
$confs{'gmgenerateentrypages'} = $IN{'editedgenerateentrypages'};
$confs{'gmallowhtmlincomments'} = $IN{'editedallowhtmlincomments'};
$confs{'gmlogkarmaandcomments'} = $IN{'editedlogkarmaandcomments'};
$confs{'gmmailprog'} = $IN{'editedmailprog'};
$confs{'gmnotifyforstatus'} = $IN{'editednotifyforstatus'};
$confs{'gmautolinkurls'} = $IN{'editedautolinkurls'};
$confs{'gmstriplinesfromcomments'} = $IN{'editedstriplinesfromcomments'};
$confs{'gmallowmultiplekarmavotes'} = $IN{'editedallowmultiplekarmavotes'};
$confs{'gmversionsetup'} = $gmversion;
$confs{'gmversion'} = Gm_Constants::GM_VERSION;
$confs{'gmcgilocalpath'} = $IN{'editedcgilocalpath'};
$confs{'gmcgiwebpath'} = $IN{'editedcgiwebpath'};
$confs{'gmconcurrentmainandarchives'} = $IN{'editedconcurrentmainandarchives'};
$confs{'gmkeeparchivemasterindex'} = $IN{'editedkeeparchivemasterindex'};
$confs{'gmentrylistsortorder'} = $IN{'editedentrylistsortorder'};
$confs{'gmallowkarmaorcomments'} = $IN{'editedallowkarmaorcomments'};
$confs{'gmentrylistcountnumber'} = $IN{'editedentrylistcountnumber'};
$confs{'gmcookiesallowed'} = $IN{'editedcookiesallowed'};
$confs{'gmlogarchivesuffix'} = $IN{'editedlogarchivesuffix'};
$confs{'gmcensorlist'} = $IN{'editedcensorlist'};
$confs{'gmcensorenabled'} = $IN{'editedcensorenabled'};
$confs{'gmkeepmonthlyarchives'} = $IN{'editedkeepmonthlyarchives'};
$confs{'gmdefaultentrylistview'} = $IN{'editeddefaultentrylistview'};
$confs{'gmlinktocalendarentries'} = $IN{'editedlinktocalendarentries'};
$confs{'gmautomaticrebuilddefault'} = $IN{'editedautomaticrebuilddefault'};
$confs{'gmcommententrylistonlyifokay'} = $IN{'editedcommententrylistonlyifokay'};
$confs{'gmotherfilelist'} = $IN{'editedotherfilelist'};
$confs{'gmotherfilelistentryrebuild'} = $IN{'editedotherfilelistentryrebuild'};
$confs{'gmarchiveformat'} = $IN{'editedarchiveformat'};
$confs{'gminlineformatting'} = $IN{'editedinlineformatting'};
$confs{'gmuploadfilesallowed'} = $IN{'editeduploadfilesallowed'};
$confs{'gmuploadfilesizelimit'} = $IN{'editeduploadfilesizelimit'};
$confs{'gmemoticonspath'} = $IN{'editedemoticonspath'};
$confs{'gmkeepphphacklog'} = $IN{'editedkeepphphacklog'};
$confs{'gmmailhacknotice'} = $IN{'editedmailhacknotice'};
$confs{'gmemoticonsallowed'} = $IN{'editedemoticonsallowed'};
$confs{'gmprotectauthorname'} = $IN{'editedprotectauthorname'};
$confs{'gmcommentlinklimit'} = $IN{'editedcommentlinklimit'};
$confs{'gmcommentlinklimitnum'} = $IN{'editedcommentlinklimitnum'};
$confs{'gmcommentforcepreview'} = $IN{'editedcommentforcepreview'};
$confs{'gmcommentverify'} = $IN{'editedcommentverify'};
$confs{'gmcommentverifyphrase'} = $IN{'editedcommentverifyphrase'};
$confs{'gmcommentverifyreferer'} = $IN{'editedcommentverifyreferer'};
$confs{'gmcommentthrottle'} = $IN{'editedcommentthrottle'};
$confs{'gmcommentthrottlemin'} = $IN{'editedcommentthrottlemin'};
Gm_Storage::setConfigs( configs=>\%confs, errHandler=>\&Gm_Web::displayAdminErrorExit );

if (($keeplog eq Gm_Constants::NO) && ($IN{'editedkeeplog'} eq Gm_Constants::YES)) {
	my ($gmdate) = Gm_Utils::getStdDate( $serveroffset );
	gm_writetocplog( "$IN{'authorname'} let this log get its groove back\n".
		"<FONT SIZE=1>[$gmdate] [$authorIP]</FONT> $IN{'authorname'} edited the config file");
}

if ($IN{'editedkeeplog'} eq Gm_Constants::NO) {
	my ($gmdate) = Gm_Utils::getStdDate( $serveroffset );
	gm_writetocplog("$IN{'authorname'} edited the config file for D&R\n<FONT SIZE=1>[$gmdate] [$authorIP]</FONT> $IN{'authorname'} decided to stop this log from getting down with its bad-ass self");
} else {
	gm_writetocplog("$IN{'authorname'} edited the config file for D&R");
}

}

# ----------------------------
# diagnostics & repair - check
# ----------------------------

sub gm_diagnosticscheck {

&gm_saveconfigurationdr;
&gm_validate;

if ($gmconfigurationaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to perform diagnostics & repair without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to perform diagnostics & repair.</FONT></B><P>);
	&gm_frontpage;
}

print<<GMDIAGNOSTICSCHECK;

$gmheadtag
$gmframetop
<B>Diagnostics & Repair</B>
<P>
This will check file access and permissions for your Greymatter installation, correctly CHMOD all files (if it can; you will need to do this manually if Greymatter can't do this automatically), repair any missing entries or corrupt counter files, and rebuild your entry list.  If you are installing Greymatter for the first time, if you've changed your path settings and want to verify them, or if you believe an important configuration file might be corrupt, click below to run diagnostics and rebuilding operations on your Greymatter setup.  Running this will not alter your files.  <B>Note:</B> This will verify your Local paths, but it cannot verify your Website paths.<P>Please wait for several moments after clicking (or even minutes if you have a large number of entries).<BR><B>DO NOT interrupt this procedure once started!</B><P><FORM ACTION="gm.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}"><TABLE BORDER=0 cellpadding=1 CELLSPACING=0 BGCOLOR="#000000"><TR><TD><TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 BGCOLOR="#FFD0D0"><TR><TD VALIGN=MIDDLE ALIGN=CENTER><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Perform Diagnostics & Repair"></FONT></TD></TR></TABLE></TD></TR></TABLE><P><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Configuration"> <INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0"></FORM><P>
$gmframebottom

</BODY>
</HTML>

GMDIAGNOSTICSCHECK

exit;

}

# ------------------------------
# diagnostics & repair - perform
# ------------------------------
### THIS SEEMS TO DUPLICATE PART OF GM_LOGIN SUB
sub gm_diagnosticsperform {

&gm_validate;

if ($gmconfigurationaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to perform diagnostics & repair without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to perform diagnostics & repair.</FONT></B><P>);
	&gm_frontpage;
}

$docreport = "<UL>\n";

# NOTE: THIS IS NO LONGER VALIDATING THE CGILOCALPATH BY doing open with that in path 
## ( DO WE NEED THAT VAR?)
my $worked = Gm_Storage::validateResources( errHandler=>\&Gm_Web::displayAdminErrorExit, ch_mod=>'1' );

if( $worked ){
	$docreport .= "<LI> All config files are readable/writeable and are CHMODed correctly\n";
	$docreport .= "<LI> The local CGI path is correctly configured and all essential files are there\n";
} else {
	$docreport .= "<LI> Config files are <b>NOT</b> readable/writeable; errors were encountered\n";
	$docreport .= "<LI> The local CGI path is <b>NOT</b> correctly configured; errors were encountered\n";
}

# open (NOWHEREMAN, ">$EntriesPath/gm-testfile.txt") || &gm_dangermouse("Can't create files in $EntriesPath.  Make sure the entries/archives path is correctly configured and that this directory is CHMODed to 777.");
# print NOWHEREMAN "test";
# close (NOWHEREMAN);
#  IS THIS NECESCARY?  CAN WE TEST WITH FLAGS SOMEHOW?
Gm_Storage::saveFile( loc=>"$EntriesPath/gm-testfile.txt", content=>['test'],
	'new'=>1, ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit );

unlink ("$EntriesPath/gm-testfile.txt") || 
	&gm_dangermouse("Can't delete the gm-testfile.txt file created in $EntriesPath.  Your server may not support this operation.");

$docreport .= "<LI> The entries/archives path is readable/writeable and is CHMODed correctly\n";

# chmod (0666, "$EntriesPath/$indexfilename");

# unless (!(open(NOWHERETEMP,"<$EntriesPath/$indexfilename"))) {
if ( -e "$EntriesPath/$indexfilename" ){

# 	open (NOWHEREMAN, "<$EntriesPath/$indexfilename") || &gm_dangermouse("Can't read $EntriesPath/$indexfilename.  Make sure the entries/archives path is correctly configured and CHMODed to 777, the index filename is correctly specified under Configuration, and that this file is CHMODed to 666.");
# 	@nowhereland = <NOWHEREMAN>;
# 	close (NOWHEREMAN);
# 
# 	open (NOWHEREMAN, ">$EntriesPath/$indexfilename") || &gm_dangermouse("Can't write to $EntriesPath/$indexfilename.  Make sure the entries/archives path is correctly configured and CHMODed to 777, the index filename is correctly specified under Configuration, and that this file is CHMODed to 666.");
# 	print NOWHEREMAN @nowhereland;
# 	close (NOWHEREMAN);

	Gm_Storage::validateFile( file=>"$EntriesPath/$indexfilename", writable=>1, ch_mod=>1, 
		errHandler=>\&Gm_Web::displayAdminErrorExit );

$docreport .= "<LI> The archive index file is readable/writeable and is CHMODed correctly\n";

}

#close(NOWHERETEMP);

&gm_readcounter;

$oldentrynumbercount = $newentrynumber;
$countentriesfromhere = 5000;  ## this is a needless built in limit, and silly, better ways to do this
## NOTE:  ONE DAY WILL NEED TO ALLOW USER TO SELECT A RANGE OF ENTRIES TO BUILD, TO GIVE BETTER CONTROL
# TO THEM.
$foundtopentry = Gm_Constants::NO;		

# 00000000.cgi can't be read fix: linear 9/3/2003
# merged into 1.3
do {
#    $countentriesfromherepadded = sprintf ("%8d", $countentriesfromhere);
#    $countentriesfromherepadded =~ tr/ /0/;
   $countentriesfromherepadded = Gm_Utils::toEntryPadded( $countentriesfromhere );
   
   if ($countentriesfromhere eq '0') {
      $newentrynumber = '0';
      $foundtopentry = Gm_Constants::YES;
   }
   if (-e "$EntriesPath/$countentriesfromherepadded.cgi") {
      $newentrynumber = $countentriesfromhere;
      $foundtopentry = Gm_Constants::YES;
   }
   $countentriesfromhere--;
} until $foundtopentry eq Gm_Constants::YES;
# merged 9/11/2003 

&gm_writecounter;
## TODO:  NEED TO ADD LOGIC TO FIX OTHER COUNTER VARIABLES, JUST KEEPS TRACK OF ARCHIVE AND TOTAL

if ($oldentrynumbercount ne $newentrynumber) {
	$docreport .= "<LI> The counter was successfully repaired\n";
	## this is actually fixing the archivetotal var
	&gm_generatemainindex;
}
## TODO:  NEED TO ADD LOGIC TO FIX OTHER COUNTER VARIABLES, JUST KEEPS TRACK OF ARCHIVE AND TOTAL


if ($newentrynumber ne '0') {
	$checkentrycounter = $newentrynumber;
	$docreportentryappend = Gm_Constants::NO;
	do {
# 		$checkentrycounterpadded = sprintf ("%8d", $checkentrycounter);
# 		$checkentrycounterpadded =~ tr/ /0/;
		$checkentrycounterpadded = Gm_Utils::toEntryPadded( $checkentrycounter );
		
		$makedummyentry = Gm_Constants::NO;
# 		if (!(open(ENTRYCHECK,"<$EntriesPath/$checkentrycounterpadded.cgi"))) { 
		if (! -r "$EntriesPath/$checkentrycounterpadded.cgi" ){ 
## TODO: THERE SHOULD PROBABLY BE A FILE EXISTS, STORAGE FUNCTION
			$makedummyentry = Gm_Constants::YES;	
		}
#		close(ENTRYCHECK);
		if (($makedummyentry eq Gm_Constants::YES) && ($checkentrycounter ne '0')) {
			my ($basedate, $wday, $mon, $mday, $JSYear, $hour, $min, $sec, $AMPM ) = 
				Gm_Utils::getStdDate( $serveroffset );
			my $montwo = Gm_Utils::toTwoDigit( $mon );
			my $mdaytwo = Gm_Utils::toTwoDigit( $mday );
			my $hourtwo = Gm_Utils::toTwoDigit( $hour );
			my $mintwo = Gm_Utils::toTwoDigit( $min );
			$thisnewwday = $wday;
			$thisnewmon = $mon;
			$thisnewmday = $mday;
			$thisnewyear = $JSYear;
			$thisnewhour = $hour;
			$thisnewmin = $min;
			$thisnewsec = $sec;
			$thisnewampm = $AMPM;
			if ($checkentrycounter ne $newentrynumber) {
				$nextentrynumber = $thisentrynumber + 1;
# 				$nextentrynumberpadded = sprintf ("%8d", $nextentrynumber);
# 				$nextentrynumberpadded =~ tr/ /0/;
				$nextentrynumberpadded = Gm_Utils::toEntryPadded( $nextentrynumber );
				
# 				open (FUNNYFEET, "<$EntriesPath/$nextentrynumberpadded.cgi") || &gm_dangermouse("Can't open $EntriesPath/$nextentrynumberpadded.cgi - this file may be missing or corrupt, especially if you've tried to add new entries or start using Greymatter with an incorrect installation.  Please run Diagnostics & Repair in the Configuration screen.");
# 				@nextentrylines = <FUNNYFEET>;
# 				close (FUNNYFEET);
# 				($nextentrynumber, $nextentryauthor, $nextentrysubject, $nextentryweekdaynumber, $nextentrymonth, $nextentryday, $nextentryyearyear, $nextentryhour, $nextentryminute, $nextentrysecond, $nextentryampm, $nextentrypositivekarma, $nextentrynegativekarma, $nextentrycommentsnumber, $nextentryallowkarma, $nextentryallowcomments, $nextentryopenstatus, $nextentrymusic, $nextentrymood, $nextentryemoticonsallowed) = split (/\|/, $nextentrylines[0]);
# 				$thisnewwday = $nextentryweekdaynumber;
# 				$thisnewmon = $nextentrymonth;
# 				$thisnewmday = $nextentryday;
# 				$thisnewyear = $nextentryyearyear;
# 				$thisnewhour = $nextentryhour;
# 				$thisnewmin = $nextentryminute;
# 				$thisnewsec = $nextentrysecond;
# 				$thisnewampm = $nextentryampm;
				my $gmEntry = Gm_Storage::getEntry( id=>$nextentrynumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
				
				$nextentrynumber = $gmEntry->{'entryinfo'}{'id'};
				$nextentryauthor = $gmEntry->{'entryinfo'}{'author'};
				$nextentrysubject = $gmEntry->{'entryinfo'}{'subject'};
				$nextentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
				$nextentrymonth = $gmEntry->{'entryinfo'}{'month'};
				$nextentryday = $gmEntry->{'entryinfo'}{'day'};
				$nextentryyearyear = $gmEntry->{'entryinfo'}{'year'};
				$nextentryhour = $gmEntry->{'entryinfo'}{'hour'};
				$nextentryminute = $gmEntry->{'entryinfo'}{'minute'};
				$nextentrysecond = $gmEntry->{'entryinfo'}{'second'};
				$nextentryampm = $gmEntry->{'entryinfo'}{'ampm'};
				$nextentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
				$nextentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
				$nextentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
				$nextentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
				$nextentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
				$nextentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
				$nextentrymusic = $gmEntry->{'entryinfo'}{'music'};
				$nextentrymood = $gmEntry->{'entryinfo'}{'mood'};
				$nextentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};
				
				$thisnewwday = $nextentryweekdaynumber;
				$thisnewmon = $nextentrymonth;
				$thisnewmday = $nextentryday;
				$thisnewyear = $nextentryyearyear;
				$thisnewhour = $nextentryhour;
				$thisnewmin = $nextentryminute;
				$thisnewsec = $nextentrysecond;
				$thisnewampm = $nextentryampm;					
					
			} elsif ($checkentrycounter ne '1') {
				$previousentrynumber = $thisentrynumber - 1;
# 				$previousentrynumberpadded = sprintf ("%8d", $previousentrynumber);
# 				$previousentrynumberpadded =~ tr/ /0/;
				$previousentrynumberpadded = Gm_Utils::toEntryPadded( $previousentrynumber );
				
# 				open (FUNNYFEET, "<$EntriesPath/$previousentrynumberpadded.cgi") || &gm_dangermouse("Can't open $EntriesPath/$previousentrynumberpadded.cgi - this file may be missing or corrupt, especially if you've tried to add new entries or start using Greymatter with an incorrect installation.  Please run Diagnostics & Repair in the Configuration screen.");
# 				@previousentrylines = <FUNNYFEET>;
# 				close (FUNNYFEET);
# 				($previousentrynumber, $previousentryauthor, $previousentrysubject, $previousentryweekdaynumber, $previousentrymonth, $previousentryday, $previousentryyearyear, $previousentryhour, $previousentryminute, $previousentrysecond, $previousentryampm, $previousentrypositivekarma, $previousentrynegativekarma, $previousentrycommentsnumber, $previousentryallowkarma, $previousentryallowcomments, $previousentryopenstatus, $previousentrymusic, $previousentrymood, $previousentryemoticonsallowed) = split (/\|/, $previousentrylines[0]);

				my $gmEntry = Gm_Storage::getEntry( id=>$previousentrynumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
				
				$previousentrynumber = $gmEntry->{'entryinfo'}{'id'};
				$previousentryauthor = $gmEntry->{'entryinfo'}{'author'};
				$previousentrysubject = $gmEntry->{'entryinfo'}{'subject'};
				$previousentryweekdaynumber = $gmEntry->{'entryinfo'}{'weekday'};
				$previousentrymonth = $gmEntry->{'entryinfo'}{'month'};
				$previousentryday = $gmEntry->{'entryinfo'}{'day'};
				$previousentryyearyear = $gmEntry->{'entryinfo'}{'year'};
				$previousentryhour = $gmEntry->{'entryinfo'}{'hour'};
				$previousentryminute = $gmEntry->{'entryinfo'}{'minute'};
				$previousentrysecond = $gmEntry->{'entryinfo'}{'second'};
				$previousentryampm = $gmEntry->{'entryinfo'}{'ampm'};
				$previousentrypositivekarma = $gmEntry->{'entryinfo'}{'karmapos'};
				$previousentrynegativekarma = $gmEntry->{'entryinfo'}{'karmaneg'};
				$previousentrycommentsnumber = $gmEntry->{'entryinfo'}{'commenttotal'};
				$previousentryallowkarma = $gmEntry->{'entryinfo'}{'karma'};
				$previousentryallowcomments = $gmEntry->{'entryinfo'}{'comments'};
				$previousentryopenstatus = $gmEntry->{'entryinfo'}{'status'};
				$previousentrymusic = $gmEntry->{'entryinfo'}{'music'};
				$previousentrymood = $gmEntry->{'entryinfo'}{'mood'};
				$previousentryemoticonsallowed = $gmEntry->{'entryinfo'}{'emoticons'};

				$thisnewwday = $previousentryweekdaynumber;
				$thisnewmon = $previousentrymonth;
				$thisnewmday = $previousentryday;
				$thisnewyear = $previousentryyearyear;
				$thisnewhour = $previousentryhour;
				$thisnewmin = $previousentryminute;
				$thisnewsec = $previousentrysecond;
				$thisnewampm = $previousentryampm;
			}
## TODO:  THIS IS REPAIRING DAMANGED ENTRIES, IT SHOULD HANDLE BAD DATES GRACEFULLY HERE			
# 			open (FUNNYFEET, ">$EntriesPath/$checkentrycounterpadded.cgi") || &gm_dangermouse("Can't write to $EntriesPath/$checkentrycounterpadded.cgi.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777.");
# 			print FUNNYFEET "$checkentrycounter|Greymatter|*Repaired*|$thisnewwday|$thisnewmon|$thisnewmday|$thisnewyear|$thisnewhour|$thisnewmin|$thisnewsec|$thisnewampm|0|0|0|no|no|closed\n";
# 			print FUNNYFEET "0.0.0.0|I\n";
# 			print FUNNYFEET "This entry was detected by Greymatter during Diagnostics & Repair as being missing or corrupt.  This is a dummy entry only.  DO NOT reopen this entry.\n";
# 			print FUNNYFEET "\n";
# 			close (FUNNYFEET);
			my $gmEntry = {};
			if( -e "$EntriesPath/$checkentrycounterpadded.cgi" ){
			$gmEntry = Gm_Storage::getEntry( id=>$checkentrycounter, 
				errHandler=>\&Gm_Web::displayAdminErrorExit );
			}
			
			unless( $gmEntry->{'comments'} ){
				$gmEntry->{'comments'} = [];
			}
			unless( $gmEntry->{'karmavotes'} ){
				$gmEntry->{'karmavotes'} = { '0.0.0.0'=>'I' };
			}			

			$gmEntry->{'entryinfo'}{'id'} = $checkentrycounter;
			$gmEntry->{'entryinfo'}{'author'} = 'Greymatter';
			$gmEntry->{'entryinfo'}{'subject'} = '*Repaired*';
			$gmEntry->{'entryinfo'}{'weekday'} = $thisnewwday;
			$gmEntry->{'entryinfo'}{'month'} = $thisnewmon;
			$gmEntry->{'entryinfo'}{'day'} = $thisnewmday;
			$gmEntry->{'entryinfo'}{'year'} = $thisnewyear;
			$gmEntry->{'entryinfo'}{'hour'} = $thisnewhour;
			$gmEntry->{'entryinfo'}{'minute'} = $thisnewmin;
			$gmEntry->{'entryinfo'}{'second'} = $thisnewsec;
			$gmEntry->{'entryinfo'}{'ampm'} = $thisnewampm;
			$gmEntry->{'entryinfo'}{'karmapos'} = 0;
			$gmEntry->{'entryinfo'}{'karmaneg'} = 0;
			$gmEntry->{'entryinfo'}{'commenttotal'} = 0;
			$gmEntry->{'entryinfo'}{'karma'} = Gm_Constants::NO;
			$gmEntry->{'entryinfo'}{'comments'} = Gm_Constants::NO;
			$gmEntry->{'entryinfo'}{'status'} = closed;
			
			$gmEntry->{'maintext'} = 'This entry was detected by Greymatter during Diagnostics '.
				'& Repair as being missing or corrupt.  This is a dummy entry only.  DO NOT reopen this entry.';

			Gm_Storage::setEntry( entry=>$gmEntry, 'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );

			$docreportentryappend = Gm_Constants::YES;
			$docreport .= "<LI> Entry #$checkentrycounter was detected as being missing or corrupt and was successfully replaced (it is recommended that you go to the Rebuild Files screen now and click \"Rebuild Everything\")\n";
		}
		
		## TODO: VALIDATE DATA IN THE ENTRIES! WE JUST CHECKED IF IT EXISTS
		## SHOULD CHECK A. THAT THE NUMBER FIELDS (SUCH AS ENTRYID) ARE ACTUALLY  NUMBERS
		## THAT IF THERE IS A BAD OR NO DATE, THAT IT IS NOTED OR GIVEN THE SAME DATE AS PREVIOUS ENTRY
		# $foo = 'abc12';  ## originally had some wierd characters like upside down question mark
		# if( $foo =~ m/\D/g ){
		# 	$foo =~ s/\D//gi;
		# }
		
		
		chmod (0666, "$EntriesPath/$checkentrycounterpadded.cgi");
		$checkentrycounter--;
#	} until $checkentrycounter eq '0';
	} until $checkentrycounter < 1;		
	$docreport .= "<LI> All entry files are working correctly\n";
}

## TODO: THIS SHOULD BE THE GENERATE ENTRYLIST FUNCTION IN CORE
if ($newentrynumber ne '0') {
# 	$checkentrycounter = $newentrynumber;
# 	my %rebuiltentrylist = ();
# 	do {
## 		$checkentrycounterpadded = sprintf ("%8d", $checkentrycounter);
## 		$checkentrycounterpadded =~ tr/ /0/;
# 		$checkentrycounterpadded = Gm_Utils::toEntryPadded( $checkentrycounter );
# 
# # TODO:  THE ENTRY DATA BETTER BE CORRECT BY NOW, OR IT WILL ERROR OUT, SANITIZE ABOVE		
# # 		&gm_getentryvariables($checkentrycounter);
# 		$entryVars = Gm_Core::getEntryVariables( entryid=>$checkentrycounter, 
# 			errHandler=>\&Gm_Web::displayAdminErrorExit ); 
# 		$checkentryopenstatus = 'O';
# 		$checkentrymorestatus = Gm_Constants::N;
# 		if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::CLOSED) { $checkentryopenstatus = 'C'; }
# 		if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) { $checkentrymorestatus = Gm_Constants::Y; }
# 		$rebuiltentrylist{$entryVars->{'thisentrynumber'}} = { id=>$entryVars->{'thisentrynumber'}, 
# 			author=>$entryVars->{'thisentryauthor'}, subject=>$entryVars->{'thisentrysubject'}, 
# 			created=>"$entryVars->{'thisentrymonthmonth'}\/$entryVars->{'thisentrydayday'}\/$entryVars->{'thisentryyear'}",
# 			createt=>"$entryVars->{'thisentryhourhour'}\:$entryVars->{'thisentryminuteminute'} $entryVars->{'thisentryampm'}", 
# 			status=>$checkentryopenstatus, extended=>$checkentrymorestatus, 
# 			music=>$entryVars->{'thisentrymusic'}, mood=>$entryVars->{'thisentrymood'}, 
# 			emoticons=>$entryVars->{'thisentryemoticonsallowed'} };
# 		$checkentrycounter--;
# #	} until $checkentrycounter eq "0";
# 	} until $checkentrycounter < 1;	
# 
# 	Gm_Storage::setEntrylist( list=>\%rebuiltentrylist, errHandler=>\&Gm_Web::displayAdminErrorExit );
	Gm_Core::reconstructEntrylist( errHandler=>$errHandler );
	$docreport .= "<LI> The entry list was successfully rebuilt\n"
}

Gm_Storage::validateFile( file=>"$LogPath/$indexfilename", writable=>1, ch_mod=>1, 
	errHandler=>\&Gm_Web::displayAdminErrorExit );


$docreport .= "<LI> The main index file is readable/writeable and is CHMODed correctly\n";

if ($otherfilelist ne Gm_Constants::EMPTY) {
	@connectedfilelist = split ('\\n', $otherfilelist);
	foreach $usethisfilename (@connectedfilelist) {
		Gm_Storage::validateFile( file=>"$usethisfilename", writable=>1, ch_mod=>1, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
	}
	$docreport .= "<LI> All connected files are readable/writeable and are CHMODed correctly\n";
}

gm_writetocplog( "$IN{'authorname'} successfully performed diagnostics & repair.");

print<<GMDIAGNOSTICSFINISHED;

$gmheadtag
$gmframetop
<FONT COLOR="#0000FF"><B>Diagnostics & Repair Complete</B></FONT>
<P>
All operations were completed successfully.  Greymatter successfully checked and/or performed the following:
<P>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR><TD ALIGN=LEFT>$gmfonttag$docreport</FONT></TD></TR></TABLE>
<P>
<FORM ACTION="gm.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}"><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Configuration"> <INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0"></FORM></P><P ALIGN=CENTER>
$gmframebottom

</BODY>
</HTML>

GMDIAGNOSTICSFINISHED

exit;

}

# ----------------
# add bookmarklets
# ----------------
# DEPRECATED BY: viewBookmarklet in gm.cgi
sub gm_addbookmarklets {
 	die( "gm_addbookmarklets has been DEPRECATED");
}

# ------------
# upload files
# ------------

sub gm_uploadfiles {

&gm_validate;

if ($gmuploadaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to upload files without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to upload files.</FONT></B><P>);
	&gm_frontpage;
}

&gm_readcounter;

if ($newentrynumber eq "0") {
	_checkIfDiagRun('<B><FONT COLOR="#FF0000">Please run "Diagnostics & Repair" '.
		'in the Configuration screen before uploading files.</FONT></B><P>');
}

if ($uploadfilesallowed ne Gm_Constants::EMPTY) {
	$howmanyfiletypes = 0;
	@uploadfiletypesallowed = split (/;/, $uploadfilesallowed);
	foreach $thisfiletype (@uploadfiletypesallowed) {
		$allowthesefiletypes .= ".$thisfiletype, ";
	}
	$allowthesefiletypes =~ s/, .(\w+), $/ and .$1/;
	$allowthesefiletypes =~ s/, $//;
}

if (($uploadfilesallowed ne Gm_Constants::EMPTY) && ($uploadfilesizelimit ne "0")) {
	$specialuploadtext = "Only $allowthesefiletypes files may currently be uploaded,<BR>and no file larger than $uploadfilesizelimit\k may be uploaded.<P>";
} elsif ($uploadfilesallowed ne Gm_Constants::EMPTY) {
	$specialuploadtext = "Only $allowthesefiletypes files may currently be uploaded.<P>";
} elsif ($uploadfilesizelimit ne "0") {
	$specialuploadtext = "No file larger than $uploadfilesizelimit\k may currently be uploaded.<P>";
} else {
	$specialuploadtext = Gm_Constants::EMPTY;
}

if ($statusnote eq Gm_Constants::EMPTY) { $statusnote = qq(<B><FONT COLOR="#000000">Upload Files</FONT></B><P>Use the prompt below to browse your computer for a file to upload directly to your account.<BR>(If you don't see the prompt, then your browser doesn't support this feature.)  All files<BR>will be uploaded to your entries/archives directory; after uploading, you can then have<BR>a link to download the file or display the image in a new entry if you wish.<P>$specialuploadtext); }

&gm_readconfig;

$insertauthorname = $IN{'authorname'};
$insertauthorpassword = $IN{'authorpassword'};

print<<GMUPLOADFILES;

$gmheadtag

$gmframetop
$statusnote
<SCRIPT TYPE="text/javascript" LANGUAGE="JavaScript1.2">
<!--//
document.write('<FORM ENCTYPE="multipart/form-data" ACTION="gm-upload.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$insertauthorname"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$insertauthorpassword"><INPUT TYPE=FILE CLASS="textinput" NAME="uploadfile-01" SIZE="40"><P><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Upload This File"></FORM><P>');
//-->
</SCRIPT>
<FORM ACTION="gm.cgi" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}">
<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}">
<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">
</FORM>
$gmframebottom
</BODY>
</HTML>

GMUPLOADFILES

exit;

}

# ----------------
# version checking
# ----------------

sub gm_versioncheck {

if ($versionsetup ne $gmversion) {
println( Gm_Web::createRequestHeader() );
print<<GMVERSIONCHECKTOP;

$gmheadtag
$gmframetop

GMVERSIONCHECKTOP
## TODO: REFACTOR THIS, IT MUST BE UPDATED WITH EVERY RELEASE, WAY TO FIX?
## YES STORE VERSIONS IN CONSTANTS ARRAY, COMPARE TO THAT, FIX WHEN 
if ($versionsetup eq 'one point zero') {
	print qq(Greymatter has detected that you are upgrading from version 1.0.  Some of your files will need to be updated now.  After Greymatter is done updating, you might want to review your configuration and customize the templates; many new templates are included which could affect your site.<P><B>Important notes:</B> If you have an index page in your archives directory, Greymatter will, by default, overwrite it with its new archive index, so you may want to <B>make a backup of that file</B> first; you'll also need to make sure that file is CHMODed to 666, or simply delete that file instead.  There is also a new gm-upload.cgi file that you'll have to upload with your other Greymatter CGI files and CHMOD to 755, if you haven't already.<P><FORM ACTION="gm.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}"><INPUT TYPE=HIDDEN NAME="oldsetupversion" VALUE="$versionsetup"><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Update Now"></FORM><P>);
} elsif ($versionsetup eq '1.1') {
	print qq(Greymatter has detected that you are upgrading from version 1.1.  Some of your files will need to be updated now.  After Greymatter is done updating, you might want to review the new configuration and template options; it's also <I>strongly recommended</I> that you "Rebuild Everything" right after it finishes updating.  Finally, be sure to upload the new gm-upload.cgi with your other Greymatter CGI files and CHMOD it to 755, if you haven't already.<P><FORM ACTION="gm.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}"><INPUT TYPE=HIDDEN NAME="oldsetupversion" VALUE="$versionsetup"><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Update Now"></FORM><P>);
} elsif ($versionsetup eq '1.2' || $versionsetup eq '1.21' || 
		$versionsetup eq '1.21a' || $versionsetup eq '1.21b' || $versionsetup eq '1.21c' || 
		$versionsetup eq '1.21d' || $versionsetup eq '1.21e' || $versionsetup eq '1.3' || 
		$versionsetup eq '1.3a' || $versionsetup eq '1.3.1' || $versionsetup eq '1.6.1' || 
		$versionsetup eq '1.7.1' || $versionsetup eq '1.7.2' || $versionsetup eq '1.7.3' || 
		$versionsetup eq '1.7.4'){
	_printVersionMessage( $versionsetup, $gmversion );
} else {
	## We might actually be dealing with old template format, lets read them again ...
	_old_gm_readconfig();
	if ($versionsetup eq 'one point zero') {
		print qq(Greymatter has detected that you are upgrading from version 1.0.  Some of your files will need to be updated now.  After Greymatter is done updating, you might want to review your configuration and customize the templates; many new templates are included which could affect your site.<P><B>Important notes:</B> If you have an index page in your archives directory, Greymatter will, by default, overwrite it with its new archive index, so you may want to <B>make a backup of that file</B> first; you'll also need to make sure that file is CHMODed to 666, or simply delete that file instead.  There is also a new gm-upload.cgi file that you'll have to upload with your other Greymatter CGI files and CHMOD to 755, if you haven't already.<P><FORM ACTION="gm.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}"><INPUT TYPE=HIDDEN NAME="oldsetupversion" VALUE="$versionsetup"><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Update Now"></FORM><P>);
	} elsif ($versionsetup eq '1.1') {
		print qq(Greymatter has detected that you are upgrading from version 1.1.  Some of your files will need to be updated now.  After Greymatter is done updating, you might want to review the new configuration and template options; it's also <I>strongly recommended</I> that you "Rebuild Everything" right after it finishes updating.  Finally, be sure to upload the new gm-upload.cgi with your other Greymatter CGI files and CHMOD it to 755, if you haven't already.<P><FORM ACTION="gm.cgi" METHOD=POST><INPUT TYPE=HIDDEN NAME="authorname" VALUE="$IN{'authorname'}"><INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="$IN{'authorpassword'}"><INPUT TYPE=HIDDEN NAME="oldsetupversion" VALUE="$versionsetup"><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" VALUE="Update Now"></FORM><P>);
	} elsif ($versionsetup eq '1.2' || $versionsetup eq '1.21' || 
			$versionsetup eq '1.21a' || $versionsetup eq '1.21b' || $versionsetup eq '1.21c' || 
			$versionsetup eq '1.21d' || $versionsetup eq '1.21e' || $versionsetup eq '1.3' || 
			$versionsetup eq '1.3a' || $versionsetup eq '1.3.1' || $versionsetup eq '1.6.1' || 
			$versionsetup eq '1.7.1' || $versionsetup eq '1.7.2'|| $versionsetup eq '1.7.3' || 
			$versionsetup eq '1.7.4'){
		_printVersionMessage( $versionsetup, $gmversion );
	} else {
		print qq(<B>ERROR:</B> Greymatter could not determine the version setup.  Please make sure that Greymatter is installed correctly.  Try reuploading the gm-config.cgi file that came with Greymatter and try logging in again; you'll need to reconfigure your Configuration settings.);
	}
}

print<<GMVERSIONCHECKBOTTOM;

$gmframebottom

</BODY>
</HTML>

GMVERSIONCHECKBOTTOM

exit;

}

}

sub _printVersionMessage {
  my ($versionsetup, $newversion) = @_;
	println('Greymatter has detected that you are upgrading from version '.$versionsetup.'.<br />  '.
	'Version '.$newversion.' has several new features including cosmetic changes, '.
	'bug fixes, security enhancements, and more.'.
	'<P><FORM ACTION="gm.cgi" METHOD=POST>'.
	'<INPUT TYPE=HIDDEN NAME="authorname" VALUE="'.$IN{'authorname'}.'">'.
	'<INPUT TYPE=HIDDEN NAME="authorpassword" VALUE="'.$IN{'authorpassword'}.'">'.
	'<INPUT TYPE=HIDDEN NAME="oldsetupversion" VALUE="'.$versionsetup.'">'.
	'<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" STYLE="background: #D0FFD0" '.
	'VALUE="Update Now"></FORM><P>');
}

## Helper util to reduce copy and paste, should find a better home someday
sub _checkIfDiagRun {
	my $msg = shift();
	$cploglines = Gm_Storage::getCplog( errHandler=>\&Gm_Web::displayAdminErrorExit );
	
	$cplogtext = join (" ", @$cploglines);
	unless ($cplogtext =~ /successfully performed diagnostics/) {
		$statusnote = $msg;
		&gm_frontpage;
	}
}

# -----------------
# version upgrading
##  TODO:  ADDRESS THIS ISSUE
# ISSUE: this is legacy code, it is not worth the time and effort to refactor as it is 
#  very crusty.  Unfortunatly the solution will be tell users to upgrade to the last
# version whitch contains this bit of file.  Then to move forward from there.
#
#  It sucks, we all know it, but every app has this.  The real reason I don't want to
# touch this code is because I CANNOT TEST IT.  And I will not break it until the last moment.
# I would need these early versions which I do not have, nor can they be found
# -----------------
sub gm_versionupgrading {

## Check if the config version is blank, this indicates a probably config file format change
## Use read old templates and read old configs and read old counters where approp.

if ($IN{'oldsetupversion'} eq "one point zero") {
	open (FUNNYFEET, "<gm-entrylist.cgi") || &gm_dangermouse("Can't read the entrylist file.  Please make sure that gm-entrylist.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	@tempnewentrylist = <FUNNYFEET>;
	close (FUNNYFEET);
	open (FUNNYFEETWO, ">gm-entrylist.cgi") || &gm_dangermouse("Can't write to the entrylist file.  Please make sure that gm-entrylist.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	foreach $tempnewentrylistline (@tempnewentrylist) {
		chomp ($tempnewentrylistline);
		($templistnumber, $templistauthorname, $templistsubject, $templistdate, $templisttime, $templistopenstatus) = split (/\|/, $tempnewentrylistline);
		$templistopenstatus = 'O';
		if ($templistopenstatus eq Gm_Constants::CLOSED) { $templistopenstatus = 'C'; }
		$templistmorestatus = Gm_Constants::N;
# 		&gm_getentryvariables($templistnumber);
		$entryVars = Gm_Core::getEntryVariables( entryid=>$templistnumber, 
			errHandler=>\&Gm_Web::displayAdminErrorExit );
		if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) { $templistmorestatus = Gm_Constants::Y; }
		print FUNNYFEETWO "$templistnumber|$templistauthorname|$templistsubject|$templistdate|$templisttime|$templistopenstatus|$templistmorestatus\n";
	}
	close (FUNNYFEETWO);
	_old_gm_readtemplates();
	$gmentrytemplate =~ s/\n/\|\*\|/g;
	$gmentrypagetemplate =~ s/\n/\|\*\|/g;
	$gmarchiveentrypagetemplate =~ s/\n/\|\*\|/g;
	$gmarchiveentrytemplate =~ s/\n/\|\*\|/g;
	$gmdatetemplate =~ s/\n/\|\*\|/g;

	open (FUNNYFEETHREE, ">>gm-templates.cgi");
	print FUNNYFEETHREE "$gmentrytemplate\n";
	print FUNNYFEETHREE "$gmentrypagetemplate\n";
	print FUNNYFEETHREE "$gmarchiveentrypagetemplate\n";
	print FUNNYFEETHREE qq([{{pagepreviouslink}}Previous entry: "{{previousentrysubject}}"</A>]\n);
	print FUNNYFEETHREE qq([{{pagenextlink}}Next entry: "{{nextentrysubject}}"</A>]\n);
	print FUNNYFEETHREE qq([{{pagemorepreviouslink}}Previous extended entry: "{{previousmoreentrysubject}}"</A>]\n);
	print FUNNYFEETHREE qq([{{pagemorenextlink}}Next extended entry: "{{nextmoreentrysubject}}"</A>]\n);
	print FUNNYFEETHREE qq(<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">|*|<HTML>|*|<HEAD>|*|<TITLE>My Archives</TITLE>|*|<META NAME="Generator" CONTENT="Greymatter 1.1">|*|</HEAD>|*||*|<BODY BGCOLOR="#FFFFFF">|*||*|<P ALIGN=CENTER>|*|{{header}}|*|</P><P ALIGN=CENTER>|*|<FONT SIZE=4><B>My Archives</B></FONT>|*|</P>|*||*|<P ALIGN=CENTER>|*|<B>Log Archives</B>|*|</P><P ALIGN=CENTER>|*|{{logarchivelist}}|*|</P><P ALIGN=CENTER>|*|<B>Entries</B>|*|</P><P ALIGN=CENTER>|*|{{logentrylist}}|*|</P>|*||*|<P ALIGN=CENTER>|*|[{{pageindexlink}}Main Index</A>]|*|</P><P ALIGN=CENTER>|*|{{gmicon}}|*|</P><P ALIGN=CENTER>|*|{{footer}}|*|</P>|*||*|</BODY>|*|</HTML>\n);
	print FUNNYFEETHREE qq({{pagearchivelogindexlink}}Log Archives: {{monthword}} {{yearyear}}</A>\n);
	print FUNNYFEETHREE qq({{pagelink}}{{monthmonth}}/{{dayday}}/{{yearyear}}: {{entrysubject}}</A>\n);
	print FUNNYFEETHREE qq(<B>{{pagelink}}{{monthmonth}}/{{dayday}}/{{yearyear}}: {{entrysubject}}</A></B>\n);
	print FUNNYFEETHREE qq( / \n);
	print FUNNYFEETHREE qq(<BR>\n);
	print FUNNYFEETHREE "<P>\n";
	print FUNNYFEETHREE "<br />\n";
	print FUNNYFEETHREE "<P>\n";
	print FUNNYFEETHREE "\n";
	print FUNNYFEETHREE "\n";
	print FUNNYFEETHREE "\n";
	print FUNNYFEETHREE qq( onMouseOver="window.status='{{monthmonth}}/{{dayday}}/{{yearyear}}: {{entrysubject}}';return true" onMouseOut="window.status='';return true"\n);
	print FUNNYFEETHREE "\n";
	print FUNNYFEETHREE "\n";
	print FUNNYFEETHREE "$gmarchiveentrytemplate\n";
	print FUNNYFEETHREE "$gmdatetemplate\n";
	close (FUNNYFEETHREE);
	open (FUNNYFEETFOUR, ">>gm-config.cgi");
	print FUNNYFEETFOUR "yes\n";
	print FUNNYFEETFOUR "ascending\n";
	print FUNNYFEETFOUR "both\n";
	print FUNNYFEETFOUR "10\n";
	close (FUNNYFEETFOUR);
	_old_gm_readconfig();
	$versionsetup = $gmversion;
	_old_gm_writeconfig();
}

if (($IN{'oldsetupversion'} eq "one point zero") || ($IN{'oldsetupversion'} eq "1.1")) {
	_old_gm_readtemplates();
	open (LAUGHINGFEET, "<gm-templates.cgi") || &gm_dangermouse("Can't read the templates file.  Please make sure that gm-templates.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	@gmtemplateline = <LAUGHINGFEET>;
	close (LAUGHINGFEET);
	
	open (LAUGHINGFEETONE, ">gm-templates.cgi") || &gm_dangermouse("Can't write to the templates file.  Please make sure that gm-templates.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	foreach $thistemplateline (@gmtemplateline) {
		chomp ($thistemplateline);
		unless ($thistemplateline eq Gm_Constants::EMPTY) {
			$authoremaillinkreplacement = qq(<A HREF="mailto:{{authoremail}}">);
			$authorhomepagelinkreplacement = qq(<A HREF="mailto:{{authorhomepage}}">);
			$commentauthoremaillinkreplacement = qq(<A HREF="mailto:{{commentauthoremailabsolute}}">);
			$commentauthorhomepagelinkreplacement = qq(<A HREF="mailto:{{commentauthorhomepageabsolute}}">);
			$commentspostlinkreplacement = qq(<A HREF="{{commentspostlink}}">);
			$pagelinkreplacement = qq(<A HREF="{{pagelink}}">);
			$pageindexlinkreplacement = qq(<A HREF="{{pageindexlink}}">);
			$pagearchiveindexlinkreplacement = qq(<A HREF="{{pagearchiveindexlink}}">);
			$pagearchivelogindexlinkreplacement = qq(<A HREF="{{pagearchivelogindexlink}}">);
			$pagenextlinkreplacement = qq(<A HREF="{{nextpagelink}}" onMouseOver="window.status='{{nextmonthmonth}}/{{nextdayday}}/{{nextyear}}: {{nextentrysubject}}';return true" onMouseOut="window.status='';return true">);
			$pagenextmorelinkreplacement = qq(<A HREF="{{nextmorepagelink}}" onMouseOver="window.status='{{nextmoremonthmonth}}/{{nextmoredayday}}/{{nextmoreyear}}: {{nextmoreentrysubject}}';return true" onMouseOut="window.status='';return true">);
			$pagepreviouslinkreplacement = qq(<A HREF="{{previouspagelink}}" onMouseOver="window.status='{{previousmonthmonth}}/{{previousdayday}}/{{previousyear}}: {{previousentrysubject}}';return true" onMouseOut="window.status='';return true">);
			$pagepreviousmorelinkreplacement = qq(<A HREF="{{previousmorepagelink}}" onMouseOver="window.status='{{previousmoremonthmonth}}/{{previousmoredayday}}/{{previousmoreyear}}: {{previousmoreentrysubject}}';return true" onMouseOut="window.status='';return true">);
			$pagesmartindexlinkreplacement = qq(<A HREF="{{pagesmartindexlink}}">);
			$pagepositivekarmalinkreplacement = qq(<A HREF="{{positivekarmalink}}" onMouseOver="window.status='Cast a positive vote on this entry';return true" onMouseOut="window.status='';return true">);
			$pagenegativekarmalinkreplacement = qq(<A HREF="{{negativekarmalink}}" onMouseOver="window.status='Cast a negative vote on this entry';return true" onMouseOut="window.status='';return true">);
			$thistemplateline =~ s/{{authoremaillink}}/$authoremaillinkreplacement/ig;
			$thistemplateline =~ s/{{authorhomepagelink}}/$authorhomepagelinkreplacement/ig;
			$thistemplateline =~ s/{{commentauthoremaillink}}/$commentauthoremaillinkreplacement/ig;
			$thistemplateline =~ s/{{commentauthorhomepagelink}}/$commentauthorhomepagelinkreplacement/ig;
			$thistemplateline =~ s/{{commentspostlink}}/$commentspostlinkreplacement/ig;
			$thistemplateline =~ s/{{pagelink}}/$pagelinkreplacement/ig;
			$thistemplateline =~ s/{{pageindexlink}}/$pageindexlinkreplacement/ig;
			$thistemplateline =~ s/{{pagearchiveindexlink}}/$pagearchiveindexlinkreplacement/ig;
			$thistemplateline =~ s/{{pagearchivelogindexlink}}/$pagearchivelogindexlinkreplacement/ig;
			$thistemplateline =~ s/{{pagenextlink}}/$pagenextlinkreplacement/ig;
			$thistemplateline =~ s/{{pagenextmorelink}}/$pagenextmorelinkreplacement/ig;
			$thistemplateline =~ s/{{pagepreviouslink}}/$pagepreviouslinkreplacement/ig;
			$thistemplateline =~ s/{{pagepreviousmorelink}}/$pagepreviousmorelinkreplacement/ig;
			$thistemplateline =~ s/{{pagemorepreviouslink}}/$pagepreviousmorelinkreplacement/ig;
			$thistemplateline =~ s/{{pagemorenextlink}}/$pagepreviousmorelinkreplacement/ig;
			$thistemplateline =~ s/{{pagesmartindexlink}}/$pagesmartindexlinkreplacement/ig;
			$thistemplateline =~ s/{{positivekarmalink}}/$pagepositivekarmalinkreplacement/ig;
			$thistemplateline =~ s/{{negativekarmalink}}/$pagenegativekarmalinkreplacement/ig;
		}
		print LAUGHINGFEETONE "$thistemplateline\n";
	}
	close (LAUGHINGFEETONE);
	&gm_readtemplates;
	$gmindextemplate = Gm_Utils::toStoreSafe($gmindextemplate);
	$gmentrypagetemplate = Gm_Utils::toStoreSafe($gmentrypagetemplate);
	$gmarchiveindextemplate = Gm_Utils::toStoreSafe($gmarchiveindextemplate);
	$gmarchiveentrypagetemplate = Gm_Utils::toStoreSafe($gmarchiveentrypagetemplate);
	$gmentrytemplate = Gm_Utils::toStoreSafe($gmentrytemplate);
	$gmarchiveentrytemplate = Gm_Utils::toStoreSafe($gmarchiveentrytemplate);
	$gmstayattoptemplate = Gm_Utils::toStoreSafe($gmstayattoptemplate);
	$gmdatetemplate = Gm_Utils::toStoreSafe($gmdatetemplate);
	$gmcommentstemplate = Gm_Utils::toStoreSafe($gmcommentstemplate);
	$gmcommentsformtemplate = Gm_Utils::toStoreSafe($gmcommentsformtemplate);
	$gmparaseparationtemplate = Gm_Utils::toStoreSafe($gmparaseparationtemplate);
	$gmkarmaformtemplate = Gm_Utils::toStoreSafe($gmkarmaformtemplate);
	# new templates {{target}} and dategrouping footer take the place of the long-deprecated ones: linear 9/18/2003
    	# new in 1.3
	$gmlinktargettemplate = Gm_Utils::toStoreSafe($gmlinktargettemplate);
	$gmdategroupingfootertemplate = Gm_Utils::toStoreSafe($gmdategroupingfootertemplate);
	# merged 9/18/2003
	$gmkarmalinktemplate = Gm_Utils::toStoreSafe($gmkarmalinktemplate);
	$gmcommentslinktemplate = Gm_Utils::toStoreSafe($gmcommentslinktemplate);
	$gmcommentauthoremailtemplate = Gm_Utils::toStoreSafe($gmcommentauthoremailtemplate);
	$gmcommentauthorhomepagetemplate = Gm_Utils::toStoreSafe($gmcommentauthorhomepagetemplate);
	$gmcommentdividertemplate = Gm_Utils::toStoreSafe($gmcommentdividertemplate);
	$gmmoreentrytemplate = Gm_Utils::toStoreSafe($gmmoreentrytemplate);
	$gmmoreentrypagetemplate = Gm_Utils::toStoreSafe($gmmoreentrypagetemplate);
	$gmmorearchiveentrypagetemplate = Gm_Utils::toStoreSafe($gmmorearchiveentrypagetemplate);
	$gmpreviouslinktemplate = Gm_Utils::toStoreSafe($gmpreviouslinktemplate);
	$gmnextlinktemplate = Gm_Utils::toStoreSafe($gmnextlinktemplate);
	$gmpreviousmorelinktemplate = Gm_Utils::toStoreSafe($gmpreviousmorelinktemplate);
	$gmnextmorelinktemplate = Gm_Utils::toStoreSafe($gmnextmorelinktemplate);
	$gmarchivemasterindextemplate = Gm_Utils::toStoreSafe($gmarchivemasterindextemplate);
	$gmlogarchiveslinktemplate = Gm_Utils::toStoreSafe($gmlogarchiveslinktemplate);
	$gmentrypagelinktemplate = Gm_Utils::toStoreSafe($gmentrypagelinktemplate);
	$gmmoreentrypagelinktemplate = Gm_Utils::toStoreSafe($gmmoreentrypagelinktemplate);
	$gmlogarchiveslinkseparatortemplate = Gm_Utils::toStoreSafe($gmlogarchiveslinkseparatortemplate);
	$gmentrypagelinkseparatortemplate = Gm_Utils::toStoreSafe($gmentrypagelinkseparatortemplate);
	$gmentrypagelinkmonthseparatortemplate = Gm_Constants::EMPTY;
	$gmentrypagelinkdayseparatortemplate = Gm_Constants::EMPTY;
	$gmentrypagelinkyearseparatortemplate = Gm_Constants::EMPTY;
	$gmheadertemplate = Gm_Utils::toStoreSafe($gmheadertemplate);
	$gmfootertemplate = Gm_Utils::toStoreSafe($gmfootertemplate);
	$gmsidebartemplate = Gm_Utils::toStoreSafe($gmsidebartemplate);
	$gmentryseparatortemplate = Gm_Utils::toStoreSafe($gmentryseparatortemplate);
	$gmarchiveentryseparatortemplate = Gm_Utils::toStoreSafe($gmarchiveentryseparatortemplate);
	$gmmorearchiveentrytemplate = Gm_Utils::toStoreSafe($gmmorearchiveentrytemplate);
	$gmdatearchivetemplate = Gm_Utils::toStoreSafe($gmdatearchivetemplate);
	
	
	open (LAUGHINGFEETTWO, ">gm-templates.cgi") || &gm_dangermouse("Can't write to the templates file.  Please make sure that gm-templates.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	print LAUGHINGFEETTWO "$gmindextemplate\n";
	print LAUGHINGFEETTWO "$gmentrypagetemplate\n";
	print LAUGHINGFEETTWO "$gmarchiveindextemplate\n";
	print LAUGHINGFEETTWO "$gmarchiveentrypagetemplate\n";
	print LAUGHINGFEETTWO "$gmentrytemplate\n";
	print LAUGHINGFEETTWO "$gmarchiveentrytemplate\n";
	print LAUGHINGFEETTWO "$gmstayattoptemplate\n";
	print LAUGHINGFEETTWO "$gmdatetemplate\n";
	print LAUGHINGFEETTWO "$gmcommentstemplate\n";
	print LAUGHINGFEETTWO "$gmcommentsformtemplate\n";
	print LAUGHINGFEETTWO "$gmparaseparationtemplate\n";
	print LAUGHINGFEETTWO "$gmkarmaformtemplate\n";
	print LAUGHINGFEETTWO "$gmlinktargettemplate\n";
	print LAUGHINGFEETTWO "$gmdategroupingfootertemplate\n";
	print LAUGHINGFEETTWO "$gmkarmalinktemplate\n";
	print LAUGHINGFEETTWO "$gmcommentslinktemplate\n";
	print LAUGHINGFEETTWO "$gmcommentauthoremailtemplate\n";
	print LAUGHINGFEETTWO "$gmcommentauthorhomepagetemplate\n";
	print LAUGHINGFEETTWO "$gmcommentdividertemplate\n";
	print LAUGHINGFEETTWO "$gmmoreentrytemplate\n";
	print LAUGHINGFEETTWO "$gmmoreentrypagetemplate\n";
	print LAUGHINGFEETTWO "$gmmorearchiveentrypagetemplate\n";
	print LAUGHINGFEETTWO "$gmpreviouslinktemplate\n";
	print LAUGHINGFEETTWO "$gmnextlinktemplate\n";
	print LAUGHINGFEETTWO "$gmpreviousmorelinktemplate\n";
	print LAUGHINGFEETTWO "$gmnextmorelinktemplate\n";
	print LAUGHINGFEETTWO "$gmarchivemasterindextemplate\n";
	print LAUGHINGFEETTWO "$gmlogarchiveslinktemplate\n";
	print LAUGHINGFEETTWO "$gmentrypagelinktemplate\n";
	print LAUGHINGFEETTWO "$gmmoreentrypagelinktemplate\n";
	print LAUGHINGFEETTWO "$gmlogarchiveslinkseparatortemplate\n";
	print LAUGHINGFEETTWO "$gmentrypagelinkseparatortemplate\n";
	print LAUGHINGFEETTWO "\n";
	print LAUGHINGFEETTWO "\n";
	print LAUGHINGFEETTWO "\n";
	print LAUGHINGFEETTWO "$gmheadertemplate\n";
	print LAUGHINGFEETTWO "$gmfootertemplate\n";
	print LAUGHINGFEETTWO "$gmsidebartemplate\n";
	print LAUGHINGFEETTWO "\n";
	print LAUGHINGFEETTWO "$gmentryseparatortemplate\n";
	print LAUGHINGFEETTWO "$gmarchiveentryseparatortemplate\n";
	print LAUGHINGFEETTWO "$gmmorearchiveentrytemplate\n";
	print LAUGHINGFEETTWO "$gmdatearchivetemplate\n";
	print LAUGHINGFEETTWO qq(<A HREF="{{pagearchivelogindexlink}}">{{weekbeginningmonthmonth}}/{{weekbeginningdayday}}/{{weekbeginningyearyear}} to {{weekendingmonthmonth}}/{{weekendingdayday}}/{{weekendingyearyear}}</A>\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq(<html>|*|<head>|*|<title>{{monthmonth}}/{{dayday}}/{{year}}: {{popuptitle}}</TITLE>|*|<META NAME="Generator" CONTENT="Greymatter {{gmversion}}">|*|</HEAD>|*||*|<BODY BGCOLOR="#000000" TOPMARGIN=0 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0 onBlur="window.close\(\)">|*||*|<IMG BORDER=0 SRC="{{entrieswebpath}}/{{popupfile}}" ALT="{{popuptitle}}" HEIGHT={{popupheight}} WIDTH={{popupwidth}}>|*||*|</BODY>|*|</HTML>\n);
	print LAUGHINGFEETTWO qq(<a href="#" onMouseOver="window.status='{{monthmonth}}/{{dayday}}/{{year}}: {{popuptitle}} \(opens popup window\)';return true" onMouseOut="window.status='';return true" onClick="window.open\('{{entrieswebpath}}/{{popuphtmlfile}}','{{randomnumber 1111-9999}}','width={{popupwidth}},height={{popupheight}},directories=no,location=no,menubar=no,scrollbars=no,status=no,toolbar=no,resizable=no,left=0,top=0,screenx=50,screeny=50'\);return false">\n);
	print LAUGHINGFEETTWO qq(<form action="{{cgiwebpath}}/gm-comments.cgi" METHOD=POST><INPUT TYPE=TEXT NAME="gmsearch" SIZE=20> <INPUT TYPE=SUBMIT VALUE="Search"></FORM>\n);
	print LAUGHINGFEETTWO qq(<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">|*|<HTML>|*|<HEAD>|*|<TITLE>Search Results</TITLE>|*|<META NAME="Generator" CONTENT="Greymatter {{gmversion}}">|*|</HEAD>|*||*|<BODY BGCOLOR="#FFFFFF">|*||*|<P ALIGN=CENTER>|*|<B>Search results for "{{searchterm}}" \({{searchmatches}} matches\)</B>|*|</P>|*||*|{{searchresults}}|*||*|<P ALIGN=CENTER>|*|[<A HREF="{{pageindexlink}}">Return To Main Index</A>]|*|</P><P ALIGN=CENTER>|*|{{gmicon}}|*|</P>|*||*|</BODY>|*|</HTML>\n);
	print LAUGHINGFEETTWO qq(<P ALIGN=JUSTIFY>|*|<A HREF="{{pagelink}}">{{monthmonth}}/{{dayday}}/{{yearyear}}: {{entrysubject}}</A>|*|<P ALIGN=JUSTIFY><I>|*|{{entrymainbodyfirstwords 10}}...|*|</I></BLOCKQUOTE></P>|*|</BLOCKQUOTE></P>\n);
	print LAUGHINGFEETTWO qq(<TABLE BORDER=2 CELLPADDING=5 CELLSPACING=0><TR><TD ALIGN=CENTER COLSPAN=7>{{monthword}} {{yearyear}}</TD></TR><TR><TD ALIGN=CENTER>S</TD><TD ALIGN=CENTER>M</TD><TD ALIGN=CENTER>T</TD><TD ALIGN=CENTER>W</TD><TD ALIGN=CENTER>T</TD><TD ALIGN=CENTER>F</TD><TD ALIGN=CENTER>S</TD></TR>\n);
	print LAUGHINGFEETTWO qq(</TABLE>\n);
	print LAUGHINGFEETTWO qq(<TD ALIGN=CENTER>&#160;</TD>\n);
	print LAUGHINGFEETTWO qq(<TD ALIGN=CENTER>{{day}}</TD>\n);
	print LAUGHINGFEETTWO qq(<TD ALIGN=CENTER><A HREF="{{pagelink}}">{{day}}</A></TD>\n);
	print LAUGHINGFEETTWO qq(\n);
	print LAUGHINGFEETTWO qq( [{{day}}] \n);
	print LAUGHINGFEETTWO qq( [<A HREF="{{pagelink}}">{{day}}</A>] \n);
	print LAUGHINGFEETTWO qq(<A NAME="comments">|*||*|<P ALIGN=CENTER>|*|<B>Previewing Your Comment</B>|*|</P>|*|\n);
	print LAUGHINGFEETTWO qq(<P ALIGN=CENTER>|*|A preview of your new comment is shown above as it will appear on this page.  Click "Post This Comment" below to post it, or click the back button on your browser to re-edit it.|*|</P><P ALIGN=CENTER><CENTER>|*|<FORM ACTION="{{cgiwebpath}}/gm-comments.cgi" METHOD=POST>|*|<INPUT TYPE=HIDDEN NAME="newcommententrynumber" VALUE="{{entrynumber}}">|*|<INPUT TYPE=HIDDEN NAME="newcommentauthor" VALUE="{{previewcommentauthor}}">|*|<INPUT TYPE=HIDDEN NAME="newcommentemail" VALUE="{{previewcommentemail}}">|*|<INPUT TYPE=HIDDEN NAME="newcommenthomepage" VALUE="{{previewcommenthomepage}}">|*|<INPUT TYPE=HIDDEN NAME="newcommentbody" VALUE="{{previewcommentbody}}">|*|<INPUT TYPE=SUBMIT VALUE="Post This Comment">|*|</FORM>|*|</CENTER></P>\n);
	print LAUGHINGFEETTWO qq(No Comments\n);
	print LAUGHINGFEETTWO qq(1 Comment\n);
	print LAUGHINGFEETTWO qq({{commentsnumber}} comments\n);
	print LAUGHINGFEETTWO qq(<BR>\n);
	close (LAUGHINGFEETTWO);
	
	
	_old_gm_readconfig();
	$versionsetup = $gmversion;
	$cookiesallowed = Gm_Constants::NO;
	$logarchivesuffix = $entrysuffix;
	$censorlist = Gm_Constants::EMPTY;
	$censorenabled = Gm_Constants::NEITHER;
	$keepmonthlyarchives = Gm_Constants::YES;
	$defaultentrylistview = Gm_Constants::MAIN;
	$linktocalendarentries = Gm_Constants::ALL;
	$automaticrebuilddefault = Gm_Constants::YES;
	$commententrylistonlyifokay = Gm_Constants::YES;
	$otherfilelist = Gm_Constants::EMPTY;
	$otherfilelistentryrebuild = Gm_Constants::NO;
	$archiveformat = Gm_Constants::MONTH;
	$inlineformatting = Gm_Constants::ENTRIES;
	$uploadfilesallowed = Gm_Constants::EMPTY;
	$uploadfilesizelimit = "0";
	_old_gm_writeconfig();
	open (LAUGHINGFEETTHREE, "<gm-authors.cgi") || &gm_dangermouse("Can't read the authors file.  Please make sure that gm-authors.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	@gmauthorupgradedata = <LAUGHINGFEETTHREE>;
	close (LAUGHINGFEETTHREE);
	open (LAUGHINGFEETFOUR, ">gm-authors.cgi") || &gm_dangermouse("Can't write to the authors file.  Please make sure that gm-authors.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files.");
	foreach $thisupgradeauthorline (@gmauthorupgradedata) {
		chomp ($thisupgradeauthorline);
		unless ($thisupgradeauthorline eq Gm_Constants::EMPTY) {
			($thisupgradeauthorname, $thisupgradeauthorpassword, $thisupgradeauthoremail, $thisupgradeauthorhomepage, $thisupgradeauthordate, $thisupgradeauthorposts, $thisupgradeauthorentryaccess, $thisupgradeauthorentryeditaccess, $thisupgradeauthorconfigurationaccess, $thisupgradeauthortemplateaccess, $thisupgradeauthorauthoraccess, $thisupgradeauthorrebuildaccess, $thisupgradeauthorcplogaccess) = split (/\|/, $thisupgradeauthorline);
			$thisupgradeauthorbookmarkletaccess = Gm_Constants::N;
			$thusupgradeauthoruploadaccess = Gm_Constants::N;
			$thisupgradeauthorloginaccess = Gm_Constants::Y;
			if ($thisupgradeauthorentryaccess eq Gm_Constants::Y ) { $thisupgradeauthorbookmarkletaccess = Gm_Constants::Y; }
			if ($thisupgradeauthorconfigurationaccess eq Gm_Constants::Y ) { $thisupgradeauthoruploadaccess = Gm_Constants::Y; }
			print LAUGHINGFEETFOUR "$thisupgradeauthorname|$thisupgradeauthorpassword|$thisupgradeauthoremail|$thisupgradeauthorhomepage|$thisupgradeauthordate|$thisupgradeauthorposts|$thisupgradeauthorentryaccess|$thisupgradeauthorentryeditaccess|$thisupgradeauthorconfigurationaccess|$thisupgradeauthortemplateaccess|$thisupgradeauthorauthoraccess|$thisupgradeauthorrebuildaccess|$thisupgradeauthorcplogaccess|$thisupgradeauthorbookmarkletaccess|$thisupgradeauthoruploadaccess|$thisupgradeauthorloginaccess\n";
		}
	}
	close (LAUGHINGFEETFOUR);
}

if ($IN{'oldsetupversion'} eq "1.2" || $IN{'oldsetupversion'} eq "1.21" || 
		$IN{'oldsetupversion'} eq "1.21a" || $IN{'oldsetupversion'} eq "1.21b" || $IN{'oldsetupversion'} eq "1.21c" || 
		$IN{'oldsetupversion'} eq "1.21d" || $IN{'oldsetupversion'} eq "1.21e" || $IN{'oldsetupversion'} eq "1.3" || 
		$IN{'oldsetupversion'} eq "1.3a" ) {
	## cleaning up some reused templates in 1.3.1
	_old_gm_readtemplates;
	$gmtemplates[12] = "";
	$gmtemplates[13] = "";
	open (LAUGHINGFEETFOUR, ">gm-templates.cgi") || &gm_dangermouse("Can't write to the templates file.  Please 
	make sure that gm-templates.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI 
	files.");
	foreach $thistemplate (@gmtemplates) {
			$thistemplate =~ s(\n)(\|\*\|)g;
			print LAUGHINGFEETFOUR "$thistemplate\n";
	}
	close (LAUGHINGFEETFOUR);		
}

use Gm_Upgrade;
Gm_Upgrade::upgradeGm( version=>$IN{'oldsetupversion'}, errHandler=>\&Gm_Web::displayAdminErrorExit );

# &gm_readconfig;  ## configs should be in correct format now
# $newConfigs->{'gmversionsetup'} = $gmversion;
# Gm_Storage::setConfigs( configs=>$newConfigs, errHandler=>\&Gm_Web::displayAdminErrorExit );

&gm_readtemplates;

# merged 10/2/2003 

gm_writetocplog("<B><FONT COLOR=\"#0000FF\">$IN{'authorname'} upgraded Greymatter 
from an older version ($IN{'oldsetupversion'}) to a newer version ($gmversion)</FONT></B>");

$statusnote = '<span class="status_msg">Upgrade complete!  Welcome back, '.$IN{'authorname'}.
	'.<BR>New features in '.$gmversion.' include new looks for the Edit Entries and Add a New Entry, '.
	'and new Spam Deterents (check out Configs), bug fixes, security enhancements, and more.</span><P>';

&gm_configuration;
}

##  TODO:  ADDRESS THIS ISSUE
# ISSUE: this is needed by legacy code, it is not worth the time and effort to refactor as it is 
#  very crusty.  Unfortunatly the solution will be tell users to upgrade to the last
# version whitch contains this bit of file.  Then to move forward from there.
#
#  It sucks, we all know it, but every app has this.  The real reason I don't want to
# touch this code is because I CANNOT TEST IT.  And I will not break it until the last moment.
# -----------------
## LATER TODO: MOVE TO GM_UPGRADE
sub _old_gm_readtemplates {

open (FUNNYFEETTAMMY, "<./gm-templates.cgi") || &gm_dangermouse("Can't read the templates file.  Please make sure that gm-templates.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files; also try running Diagnostics & Repair from the Configuration screen.");
@gmtemplates = <FUNNYFEETTAMMY>;
close (FUNNYFEETTAMMY);

$gmcounter = 0;

foreach (@gmtemplates) {
	chomp ($gmtemplates[$gmcounter]);
	$gmtemplates[$gmcounter] =~ s/\|\*\|/\n/g;
	$gmcounter++;
}

$gmindextemplate = $gmtemplates[0];
$gmentrypagetemplate = $gmtemplates[1];
$gmarchiveindextemplate = $gmtemplates[2];
$gmarchiveentrypagetemplate = $gmtemplates[3];
$gmentrytemplate = $gmtemplates[4];
$gmarchiveentrytemplate = $gmtemplates[5];
$gmstayattoptemplate = $gmtemplates[6];
$gmdatetemplate = $gmtemplates[7];
$gmcommentstemplate = $gmtemplates[8];
$gmcommentsformtemplate = $gmtemplates[9];
$gmparaseparationtemplate = $gmtemplates[10];
$gmkarmaformtemplate = $gmtemplates[11];
# new templates {{target}} and dategrouping footer take the place of the long-deprecated ones: linear 9/18/2003
# new in 1.3
$gmlinktargettemplate = $gmtemplates[12];
$gmdategroupingfootertemplate = $gmtemplates[13];
# merged 9/18/2003 
$gmkarmalinktemplate = $gmtemplates[14];
$gmcommentslinktemplate = $gmtemplates[15];
$gmcommentauthoremailtemplate = $gmtemplates[16];
$gmcommentauthorhomepagetemplate = $gmtemplates[17];
$gmcommentdividertemplate = $gmtemplates[18];
$gmmoreentrytemplate = $gmtemplates[19];
$gmmoreentrypagetemplate = $gmtemplates[20];
$gmmorearchiveentrypagetemplate = $gmtemplates[21];
$gmpreviouslinktemplate = $gmtemplates[22];
$gmnextlinktemplate = $gmtemplates[23];
$gmpreviousmorelinktemplate = $gmtemplates[24];
$gmnextmorelinktemplate = $gmtemplates[25];
$gmarchivemasterindextemplate = $gmtemplates[26];
$gmlogarchiveslinktemplate = $gmtemplates[27];
$gmentrypagelinktemplate = $gmtemplates[28];
$gmmoreentrypagelinktemplate = $gmtemplates[29];
$gmlogarchiveslinkseparatortemplate = $gmtemplates[30];
$gmentrypagelinkseparatortemplate = $gmtemplates[31];
$gmentrypagelinkmonthseparatortemplate = $gmtemplates[32];
$gmentrypagelinkdayseparatortemplate = $gmtemplates[33];
$gmentrypagelinkyearseparatortemplate = $gmtemplates[34];
$gmheadertemplate = $gmtemplates[35];
$gmfootertemplate = $gmtemplates[36];
$gmsidebartemplate = $gmtemplates[37];
$gmcustomlinktemplate = $gmtemplates[38];
$gmentryseparatortemplate = $gmtemplates[39];
$gmarchiveentryseparatortemplate = $gmtemplates[40];
$gmmorearchiveentrytemplate = $gmtemplates[41];
$gmdatearchivetemplate = $gmtemplates[42];
$gmlogarchiveslinkweeklytemplate = $gmtemplates[43];
$gmcustomonetemplate = $gmtemplates[44];
$gmcustomtwotemplate = $gmtemplates[45];
$gmcustomthreetemplate = $gmtemplates[46];
$gmcustomfourtemplate = $gmtemplates[47];
$gmcustomfivetemplate = $gmtemplates[48];
$gmcustomsixtemplate = $gmtemplates[49];
$gmcustomseventemplate = $gmtemplates[50];
$gmcustomeighttemplate = $gmtemplates[51];
$gmcustomninetemplate = $gmtemplates[52];
$gmcustomtentemplate = $gmtemplates[53];
$gmpopuppagetemplate = $gmtemplates[54];
$gmpopupcodetemplate = $gmtemplates[55];
$gmsearchformtemplate = $gmtemplates[56];
$gmsearchresultspagetemplate = $gmtemplates[57];
$gmsearchresultsentrytemplate = $gmtemplates[58];
$gmcalendartablebeginningtemplate = $gmtemplates[59];
$gmcalendartableendingtemplate = $gmtemplates[60];
$gmcalendarblankcelltemplate = $gmtemplates[61];
$gmcalendarfullcelltemplate = $gmtemplates[62];
$gmcalendarfullcelllinktemplate = $gmtemplates[63];
$gmcalendarweekblankdaytemplate = $gmtemplates[64];
$gmcalendarweekfulldaytemplate = $gmtemplates[65];
$gmcalendarweekfulldaylinktemplate = $gmtemplates[66];
$gmcommentpreviewdividertemplate = $gmtemplates[67];
$gmcommentpreviewformtemplate = $gmtemplates[68];
$gmsmartlinknocommentstemplate = $gmtemplates[69];
$gmsmartlinkonecommenttemplate = $gmtemplates[70];
$gmsmartlinkmanycommentstemplate = $gmtemplates[71];
$gmlinebreaktemplate = $gmtemplates[72];
$gmcommentlinktargettemplate = $gmtemplates[73];
$gmsmartentrymoodtemplate = $gmtemplates[74];
$gmsmartentrymusictemplate = $gmtemplates[75];
$gmdategroupingfooterarchivetemplate = $gmtemplates[76];
$gmsmartemoticonscodetemplate = $gmtemplates[77];
$gmcookiescodetemplate = $gmtemplates[78];
}

##  TODO:  ADDRESS THIS ISSUE
# ISSUE: this is needed by legacy code, it is not worth the time and effort to refactor as it is 
#  very crusty.  Unfortunatly the solution will be tell users to upgrade to the last
# version whitch contains this bit of file.  Then to move forward from there.
#
#  It sucks, we all know it, but every app has this.  The real reason I don't want to
# touch this code is because I CANNOT TEST IT.  And I will not break it until the last moment.
# -----------------
sub _old_gm_readconfig {

open (FUNNYFEETCOCO, "<./gm-config.cgi") || &gm_dangermouse("Can't read the configuration file.  Please make sure that gm-config.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files; also try running Diagnostics & Repair from the Configuration screen.");
@gmconfig = <FUNNYFEETCOCO>;
close (FUNNYFEETCOCO);

$gmcounter = 0;

foreach (@gmconfig) {
	chomp ($gmconfig[$gmcounter]);
	$gmcounter++;
}

$LogPath = $gmconfig[0];
$EntriesPath = $gmconfig[1];
$LogWebPath = $gmconfig[2];
$EntriesWebPath = $gmconfig[3];
$NotifyEmail = $gmconfig[4];
$indexfilename = $gmconfig[5];
$entrysuffix = $gmconfig[6];
$indexdays = $gmconfig[7];
$serveroffset = $gmconfig[8];
$timezone = $gmconfig[9];
$keeplog = $gmconfig[10];
$posttoarchives = $gmconfig[11];
$allowkarmadefault = $gmconfig[12];
$allowcommentsdefault = $gmconfig[13];
$commentsorder = $gmconfig[14];
$generateentrypages = $gmconfig[15];
$allowhtmlincomments = $gmconfig[16];
$logkarmaandcomments = $gmconfig[17];
$mailprog = $gmconfig[18];
$NotifyForStatus = $gmconfig[19];
$autolinkurls = $gmconfig[20];
$striplinesfromcomments = $gmconfig[21];
$allowmultiplekarmavotes = $gmconfig[22];
$versionsetup = $gmconfig[23];
$cgilocalpath = $gmconfig[24];
$cgiwebpath = $gmconfig[25];
$concurrentmainandarchives = $gmconfig[26];
$keeparchivemasterindex = $gmconfig[27];
$entrylistsortorder = $gmconfig[28];
$allowkarmaorcomments = $gmconfig[29];
$entrylistcountnumber = $gmconfig[30];
$cookiesallowed = $gmconfig[31];
$logarchivesuffix = $gmconfig[32];
$censorlist = $gmconfig[33];
$censorenabled = $gmconfig[34];
$keepmonthlyarchives = $gmconfig[35];
$defaultentrylistview = $gmconfig[36];
$linktocalendarentries = $gmconfig[37];
$automaticrebuilddefault = $gmconfig[38];
$commententrylistonlyifokay = $gmconfig[39];
$otherfilelist = $gmconfig[40];
$otherfilelistentryrebuild = $gmconfig[41];
$archiveformat = $gmconfig[42];
$inlineformatting = $gmconfig[43];
$uploadfilesallowed = $gmconfig[44];
$uploadfilesizelimit = $gmconfig[45];
$emoticonspath = $gmconfig[46];
$keepphphacklog = $gmconfig[47];
$mailhacknotice = $gmconfig[48];
$emoticonsallowed = $gmconfig[49];
}

# ---------------------
# write the config file
# ---------------------
##  TODO:  ADDRESS THIS ISSUE
# ISSUE: this is needed by legacy code, it is not worth the time and effort to refactor as it is 
#  very crusty.  Unfortunatly the solution will be tell users to upgrade to the last
# version whitch contains this bit of file.  Then to move forward from there.
#
#  It sucks, we all know it, but every app has this.  The real reason I don't want to
# touch this code is because I CANNOT TEST IT.  And I will not break it until the last moment.
# -----------------
sub _old_gm_writeconfig {

if ($versionsetup eq "") { $versionsetup = $gmversion; }

open (FUNNYFEETCONNIE, ">./gm-config.cgi") || &gm_dangermouse("Can't write to the configuration file.  Please make sure that gm-config.cgi is CHMODed to 666 and is in the same place as all your other Greymatter CGI files; also try running Diagnostics & Repair from the Configuration screen.");
print FUNNYFEETCONNIE "$LogPath\n";
print FUNNYFEETCONNIE "$EntriesPath\n";
print FUNNYFEETCONNIE "$LogWebPath\n";
print FUNNYFEETCONNIE "$EntriesWebPath\n";
print FUNNYFEETCONNIE "$NotifyEmail\n";
print FUNNYFEETCONNIE "$indexfilename\n";
print FUNNYFEETCONNIE "$entrysuffix\n";
print FUNNYFEETCONNIE "$indexdays\n";
print FUNNYFEETCONNIE "$serveroffset\n";
print FUNNYFEETCONNIE "$timezone\n";
print FUNNYFEETCONNIE "$keeplog\n";
print FUNNYFEETCONNIE "$posttoarchives\n";
print FUNNYFEETCONNIE "$allowkarmadefault\n";
print FUNNYFEETCONNIE "$allowcommentsdefault\n";
print FUNNYFEETCONNIE "$commentsorder\n";
print FUNNYFEETCONNIE "$generateentrypages\n";
print FUNNYFEETCONNIE "$allowhtmlincomments\n";
print FUNNYFEETCONNIE "$logkarmaandcomments\n";
print FUNNYFEETCONNIE "$mailprog\n";
print FUNNYFEETCONNIE "$NotifyForStatus\n";
print FUNNYFEETCONNIE "$autolinkurls\n";
print FUNNYFEETCONNIE "$striplinesfromcomments\n";
print FUNNYFEETCONNIE "$allowmultiplekarmavotes\n";
print FUNNYFEETCONNIE "$versionsetup\n";
print FUNNYFEETCONNIE "$cgilocalpath\n";
print FUNNYFEETCONNIE "$cgiwebpath\n";
print FUNNYFEETCONNIE "$concurrentmainandarchives\n";
print FUNNYFEETCONNIE "$keeparchivemasterindex\n";
print FUNNYFEETCONNIE "$entrylistsortorder\n";
print FUNNYFEETCONNIE "$allowkarmaorcomments\n";
print FUNNYFEETCONNIE "$entrylistcountnumber\n";
print FUNNYFEETCONNIE "$cookiesallowed\n";
print FUNNYFEETCONNIE "$logarchivesuffix\n";
print FUNNYFEETCONNIE "$censorlist\n";
print FUNNYFEETCONNIE "$censorenabled\n";
print FUNNYFEETCONNIE "$keepmonthlyarchives\n";
print FUNNYFEETCONNIE "$defaultentrylistview\n";
print FUNNYFEETCONNIE "$linktocalendarentries\n";
print FUNNYFEETCONNIE "$automaticrebuilddefault\n";
print FUNNYFEETCONNIE "$commententrylistonlyifokay\n";
print FUNNYFEETCONNIE "$otherfilelist\n";
print FUNNYFEETCONNIE "$otherfilelistentryrebuild\n";
print FUNNYFEETCONNIE "$archiveformat\n";
print FUNNYFEETCONNIE "$inlineformatting\n";
print FUNNYFEETCONNIE "$uploadfilesallowed\n";
print FUNNYFEETCONNIE "$uploadfilesizelimit\n";
print FUNNYFEETCONNIE "$emoticonspath\n";
print FUNNYFEETCONNIE "$keepphphacklog\n";
print FUNNYFEETCONNIE "$mailhacknotice\n";
print FUNNYFEETCONNIE "$emoticonsallowed\n";
close (FUNNYFEETCONNIE);

}


# ----------------------
# rebuild update process
# ----------------------

sub gm_rebuildupdate {

my %AUTHOR = %{ &gm_validate };  ## redo to auth, returning hash for global author variable

if ($gmrebuildaccess ne Gm_Constants::YES) {
	gm_writetocplog("$IN{'authorname'} attempted to rebuild files without authorization");
	$statusnote = qq(<B><FONT COLOR="#FF0000">You don't have access to rebuild files.</FONT></B><P>);
	&gm_frontpage;
}

$usethisauthorname = $IN{'authorname'};
$usethisauthorpassword = $IN{'authorpassword'};
$usethisauthorname =~ s/ /\+/g;
$usethisauthorpassword =~ s/ /\+/g;

$nowrebuild = Gm_Constants::EMPTY;
$whatimdoing = "Error";

&gm_readconfig;
&gm_readcounter;
&gm_readtemplates;

if ($IN{'rebuildfrom'} eq "index") {

	&gm_generatemainindex;
	$whatimdoing = "Rebuilt main index.  Now rebuilding log archives...";
	$nowrebuild = "logarchives";

} elsif ($IN{'rebuildfrom'} eq "logarchives") {

	if (($newarchivenumber ne "0") || ($concurrentmainandarchives eq Gm_Constants::YES)) {
		if ($keepmonthlyarchives ne Gm_Constants::NO) {
			if ($concurrentmainandarchives eq Gm_Constants::YES) { $newarchivenumber = $newentrynumber; }
			$stoppednumber = $newarchivenumber;
			## put in looping logic here
			do { &gm_generatearchive($stoppednumber); } until $stoppednumber <= 1;
			if( $gmneedstogeneratefirstarchive ){ &gm_generatearchive(1); }
			&gm_readcounter;
		}
	}
	$whatimdoing = "Rebuilt log archives.  Now rebuilding archive master index...";
	$nowrebuild = "masterindex";

} elsif ($IN{'rebuildfrom'} eq "masterindex") {
	### this should be a function and not duplicated elsewhere e.g. &gm_rebuildmainindexfile
	my $entryVars = ();
	if (($keeparchivemasterindex eq Gm_Constants::YES) && ($newentrynumber ne "0")) {
		if ($newarchivenumber ne "0") {
# 			&gm_getentryvariables($newarchivenumber);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$newarchivenumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
		} else {
# 			&gm_getentryvariables($newentrynumber);
				$entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber, 
					errHandler=>\&Gm_Web::displayAdminErrorExit );
		}
# 	&gm_formatentry($gmarchivemasterindextemplate);
		my $entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
			template=>$gmarchivemasterindextemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
# 		open (THISARCHIVEFILE, ">$EntriesPath/$indexfilename") || &gm_dangermouse("Can't write to $EntriesPath/$indexfilename.  Please make sure your paths are configured correctly, that the entries/archives directory is CHMODed to 777, and that $EntriesPath/$indexfilename is CHMODed to 666; also try running Diagnostics & Repair from the Configuration screen.");
# 		print THISARCHIVEFILE $entryreturn;
# 		close (THISARCHIVEFILE);
		Gm_Storage::saveFile( loc=>"$EntriesPath/$indexfilename", content=>[$entryreturn],
			'new'=>1, ch_mod=>'0666', errHandler=>\&Gm_Web::displayAdminErrorExit );
# 		chmod (0666, "$EntriesPath/$indexfilename");  ### this should be part of Storage!
	}
	if ($otherfilelist ne Gm_Constants::EMPTY) {
		$whatimdoing = "Rebuilt archive master index.  Now rebuilding connected files...";
		$nowrebuild = "connected";
	} else {
		$whatimdoing = "Rebuilt archive master index.  Now rebuilding entry files...";
		$nowrebuild = "1";
	}

} elsif ($IN{'rebuildfrom'} eq "connected") {

	if ($otherfilelist ne Gm_Constants::EMPTY) {
		&gm_rebuildconnectedfiles;
		if ($connectedfilesdone eq Gm_Constants::YES) {
			$whatimdoing = "Rebuilt connected files.  Now rebuilding entry files...";
			$nowrebuild = "1";
			if (($IN{'rebuilding'} eq "connected") || ($IN{'rebuilding'} eq "connectedaftersave")) {
				$nowrebuild = "done";
			}
		} else {
			$connectpercentdone = int( ($IN{'connectednumber'} / $#connectedfilelist) * 100 );
			$whatimdoing = "Rebuilding connected files ($connectpercentdone% done)...";
			$nowrebuild = "connected";
		}
	} else {
		$whatimdoing = "Now rebuilding entry files...";
		$nowrebuild = "1";
	}

} else {

	unless (($IN{'rebuilding'} eq "connected") || ($IN{'rebuilding'} eq "connectedaftersave")) {
	if (($generateentrypages eq Gm_Constants::YES) && ($newentrynumber ne "0")) {
		$currentcount = $IN{'rebuildfrom'};
		$counttohere = $currentcount + 9;
		if ($IN{'rebuildfrom'} eq "archivefiles") {
			if ($counttohere > $newarchivenumber) { $counttohere = $newarchivenumber; }
		} else {
			if ($counttohere > $newentrynumber) { $counttohere = $newentrynumber; }
		}
		my $entryVars = ();
		do {
# 			&gm_getentryvariables($currentcount);
			$entryVars = Gm_Core::getEntryVariables( entryid=>$currentcount);
			if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
				if ($currentcount <= $newarchivenumber) {
					if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 						&gm_formatentry($gmmorearchiveentrypagetemplate);
						$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
							template=>$gmmorearchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
					} else {
# 						&gm_formatentry($gmarchiveentrypagetemplate);
						$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
							template=>$gmarchiveentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
					}
				} else {
					if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
# 						&gm_formatentry($gmmoreentrypagetemplate);
						$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
							template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
					} else {
# 						&gm_formatentry($gmentrypagetemplate);
						$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
							template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
					}
				}
# 				open (THISENTRYFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write to $EntriesPath/$thisentrynumberpadded.$entrysuffix.  Please make sure that your entries/archives directory is correctly configured and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# 				print THISENTRYFILE $entryreturn;
# 				close (THISENTRYFILE);
				Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
					content=>[$entryreturn], ch_mod=>'0666', 'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );
# 				chmod (0666, "$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
			} else {
				unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");  ## this should be a Storage function
			}
			unless ($currentcount eq $counttohere) { $currentcount++; }		
		} until $currentcount >= $counttohere; 
		$percentdone = int( ($counttohere / $newentrynumber) * 100 );
		$whatimdoing = "Rebuilt entry pages: $IN{'rebuildfrom'} to $counttohere ($percentdone% done)...";
		if ($counttohere eq $newentrynumber) {
# 			&gm_getentryvariables($newentrynumber);
			my $entryVars = Gm_Core::getEntryVariables( entryid=>$newentrynumber);			
			if ($entryVars->{'thisentryopenstatus'} eq Gm_Constants::OPEN) {
				if ($entryVars->{'thisentrymorebody'} ne Gm_Constants::EMPTY) {
#					&gm_formatentry($gmmoreentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmmoreentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
				} else {
#					&gm_formatentry($gmentrypagetemplate);
					$entryreturn = Gm_Core::translateEntryTemplates( entryVars=>$entryVars,
						template=>$gmentrypagetemplate, errHandler=>\&Gm_Web::displayAdminErrorExit );
				}
# 				open (THISFILE, ">$EntriesPath/$thisentrynumberpadded.$entrysuffix") || &gm_dangermouse("Can't write to $EntriesPath/$thisentrynumberpadded.$entrysuffix.  Please make sure that your entries/archives directory is configured correctly and is CHMODed to 777; also try running Diagnostics & Repair from the Configuration screen.");
# 				print THISFILE $entryreturn;
# 				close (THISFILE);
# 				chmod (0666, "$EntriesPath/$thisentrynumberpadded.$entrysuffix");
				Gm_Storage::saveFile( loc=>"$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix", 
					content=>[$entryreturn], ch_mod=>'0666', 'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );
			} else {
				unlink ("$EntriesPath/$entryVars->{'thisentrynumberpadded'}.$entrysuffix");
			}
			$nowrebuild = 'done';
		} else {
			$nowrebuild = $counttohere;
		}
	} else {
		$nowrebuild = 'done';
	}
	}

}

## Refactor this out with Gm_Security
$now = time();
$usethistoken = 'gm' . $now;

# open (HAVEATOKEN, ">$EntriesPath/gm-token.cgi") || &gm_dangermouse("Can't persist the token.  Please make sure that your archive directory is CHMODed 777.");
# print HAVEATOKEN "$usethistoken\n";
# print HAVEATOKEN "$IN{'authorname'}\n";
# print HAVEATOKEN "$IN{'authorpassword'}\n";
# close (HAVEATOKEN);
my @tokenvars = ( "$usethistoken", $AUTHOR{'author'}, $AUTHOR{'password'} );
Gm_Storage::saveFile( loc=>"$EntriesPath/gm-token.cgi", 
	content=>\@tokenvars, ch_mod=>'0666', 'new'=>1, errHandler=>\&Gm_Web::displayAdminErrorExit );


$metarefreshtag = qq(<META http-equiv="REFRESH" content="1; URL=gm.cgi?gmtoken=$usethistoken&thomas=rebuildupdate&rebuilding=$IN{'rebuilding'}&rebuildfrom=$nowrebuild&connectednumber=$IN{'connectednumber'}">);
#merged 9/11/2003 

if (($nowrebuild eq Gm_Constants::EMPTY) || ($nowrebuild eq "done")) {
	if ($IN{'rebuilding'} eq "everything") {
		$statusnote = qq(<B><FONT COLOR="#0000FF">All the files have been rebuilt.</FONT></B>);
		## clean up the token file we created: linear 9/3/2003 
        # merged into 1.3
		unlink ("$EntriesPath/gm-token.cgi");
		# merged 9/11/2003 
		gm_writetocplog("$IN{'authorname'} rebuilt all the files");
	} elsif ($IN{'rebuilding'} eq "entryfiles") {
		$statusnote = qq(<B><FONT COLOR="#0000FF">All the entry pages have been rebuilt.</FONT></B>);
		gm_writetocplog("$IN{'authorname'} rebuilt all the entry pages");
	} elsif ($IN{'rebuilding'} eq "archivefiles") {
		$statusnote = qq(<B><FONT COLOR="#0000FF">All the archive entry pages have been rebuilt.</FONT></B>);
		gm_writetocplog("$IN{'authorname'} rebuilt all the archive entry pages");
	} elsif ($IN{'rebuilding'} eq "mainentries") {
		$statusnote = qq(<B><FONT COLOR="#0000FF">All the main entry pages have been rebuilt.</FONT></B>);
		gm_writetocplog("$IN{'authorname'} rebuilt all the main entry pages");
	} elsif ($IN{'rebuilding'} eq "connected") {
		$statusnote = qq(<B><FONT COLOR="#0000FF">All the connected files have been rebuilt.</FONT></B>);
		gm_writetocplog("$IN{'authorname'} rebuilt all the connected files");
	} elsif ($IN{'rebuilding'} eq "connectedaftersave") {
		$statusnote = qq(<B><FONT COLOR="#0000FF">Your new entry has been added.</FONT></B>);
	} else {
		$statusnote = qq(<B><FONT COLOR="#0000FF">All relevant files have been rebuilt.</FONT></B>);
		gm_writetocplog("$IN{'authorname'} rebuilt unknown files");
	}
	$whatimdoing = "$statusnote<P><FORM ACTION=\"gm.cgi\" METHOD=POST>".
	Gm_Security::getFormAuth( author=>\%AUTHOR ).
	'<INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Edit Templates" STYLE="background: #C0C0C0"><br>'.
	'<br><INPUT TYPE=SUBMIT CLASS="button" NAME="thomas" VALUE="Return To Main Menu" STYLE="background: #C0C0C0">'.
	'</FORM><P>';
	$metarefreshtag = Gm_Constants::EMPTY;
}

if ($IN{'rebuilding'} eq "everything") {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Everything</FONT></B><P>);
} elsif ($IN{'rebuilding'} eq "entryfiles") {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Entry Pages</FONT></B><P>);
} elsif ($IN{'rebuilding'} eq "archivefiles") {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Archive Entry Pages</FONT></B><P>);
} elsif ($IN{'rebuilding'} eq "mainentries") {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Main Entry Pages</FONT></B><P>);
} elsif ($IN{'rebuilding'} eq "connected") {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Connected Files</FONT></B><P>);
} elsif ($IN{'rebuilding'} eq "connectedaftersave") {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Connected Files</FONT></B><P>);
} else {
	$statusnote = qq(<B><FONT COLOR="#000000">Rebuilding Files</FONT></B><P>);
}

$gmrebuildheadtag = qq#<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE>Greymatter</TITLE>
$metarefreshtag

$gmadmincss

</HEAD>

<body>#;

print<<GMREBUILDUPDATE;

$gmrebuildheadtag
$gmframetop
$statusnote
$whatimdoing
$gmframebottom

</BODY>
</HTML>

GMREBUILDUPDATE

exit;

}
